
' Declarations for Branching.bas (calculation of cumulative yields)

Dim As Integer Printcontrol

Dim Shared As Integer Z_min_branching = 20
Dim Shared As Integer Z_max_branching = 88
Dim Shared As Integer A_max_branching = 234

ReDim Shared NZICUMU(250,100,3) As Single
                 /'  Title('Nuclide distribution, cumulated')
                     Cxaxis('Neutron number')
                     Cyaxis('Proton number')
                     T ype(Float);   '/
                     ' 3rd dimension: ground-state (0) or nth isomeric state

ReDim Shared d_NZICUMU(2,250,100,3) As Double
                 /'  Title('Nuclide distribution, cumulated')
                     Cxaxis('Neutron number')
                     Cyaxis('Proton number')
                     T ype(Float);   '/
                     ' 1st dimension: error, linear sum, quadratic sum
                     ' 3rd dimension: ground-state (0) or nth isomeric state
                     
' Variables for calculation of covariance/correlation matrix of cumulative yields:
ReDim Shared NZCUMU(250,100) As Single
                 /'  Title('Nuclide distribution, cumulated')
                     Cxaxis('Neutron number')
                     Cyaxis('Proton number')
                     T ype(Float);   '/

ReDim Shared d_NZCUMU(2,250,100) As Double
                 /'  Title('Nuclide distribution, cumulated')
                     Cxaxis('Neutron number')
                     Cyaxis('Proton number')
                     T ype(Float);   '/
                     ' 1st dimension: error, linear sum, quadratic sum
                     
ReDim ZISOcumu(350,150) As Double
    I_Anl = I_Anl + 1
    Anl_Par(I_Anl).C_Name = "ZISOCUMU"
    Anl_Par(I_Anl).C_Title = "Isobaric Z distribution for A = &, cumulative"
    Anl_Par(I_Anl).C_xaxis = "Atomic number"
    Anl_Par(I_Anl).C_yaxis = "Yield"
    Anl_Par(I_Anl).C_Linesymbol = "LRT11"  
    
/'ReDim d_ZISOcumu(2,350,150) As Double
    I_Anl = I_Anl + 1
    Anl_Par(I_Anl).C_Name = "d_ZISOCUMU"
    Anl_Par(I_Anl).C_Title = "Isobaric Z distribution, cumulative (uncertainties)"
    Anl_Par(I_Anl).C_xaxis = "Z distribution for A = &"
    Anl_Par(I_Anl).C_yaxis = "Counts"
    Anl_Par(I_Anl).C_Linesymbol = "LTR11"  
     ' dim. 0,1,2: sigma, N*m1, N*m2, all logarithmic    '/

ReDim ZISOPRE(350,150) As Double
    I_Anl = I_Anl + 1
    Anl_Par(I_Anl).C_Name = "ZISOPRE"
    Anl_Par(I_Anl).C_Title = "Isobaric Z distribution for A = &, pre-neutron"
    Anl_Par(I_Anl).C_xaxis = "Atomic number"
    Anl_Par(I_Anl).C_yaxis = "Yield"
    Anl_Par(I_Anl).C_Linesymbol = "LRT11"  

Redim As Double d_R_nu_delayed(2)
Scope
  Dim As Integer I
  For I = 0 To 2
    d_R_nu_delayed(I) = 0
  Next I
End Scope

Redim Shared As String C_out_an(1)    ' output-buffer of anti-neutrino production
Dim Shared As Integer I_out_an = 0    ' number of entries i C_out_an

Type BranchType
  I_Z As Integer     ' Atomic number
  I_A As Integer     ' Mass number
  I_ISO As Integer   ' Nmbr of isomeric state, 0 for ground state
  R_Life As Single   ' Half life (seconds)
  R_beta As Single   ' Beta-minus branching (without delayed neutrons)
  R_beta_plus As Single ' Beta-plus branching
  R_beta_n As Single ' Beta-n branching  
  R_beta_2n As Single
  R_beta_p As Single ' Beta-p branching
  R_beta_2p As Single
  R_IT As Single     ' Internal-transition branching
  R_alpha As Single
  R_beta_m As Single
  R_beta_plus_m As Single
  R_beta_n_m As Single
  R_beta_2n_m As Single
  R_beta_p_m As Single
  R_beta_2p_m As Single
  R_IT_m As Single
  R_alpha_m As Single
  R_beta_mm As Single
  R_beta_plus_mm As Single
  R_beta_n_mm As Single
  R_beta_2n_mm As Single
  R_beta_p_mm As Single
  R_beta_2p_mm As Single
  R_IT_mm As Single
  R_alpha_mm As Single
End Type

Redim Shared BranchData(2500) As BranchType

Dim Shared As Single Q_threshold = 0  ' Threshold on Q-beta for output

Declare Function U_Q_beta_minus(IZ As Integer, IA As Integer) As Single

Function U_Q_beta_minus(IZ As Integer, IA As Integer) As Single
  U_Q_beta_minus = -( AME2012(IZ+1,IA) - AME2012(IZ,IA) )
 ' U_Q_beta_minus = ( U_MASS(IZ+1,IZ+IN) - U_MASS(IZ,IZ+IN) )
End Function

Declare Sub U_Print_an(IZ As Integer,IN As Integer,R_an As Single,C_decay As String)

Sub U_Print_an(IZ As Integer,IN As Integer,R_an As Single,C_decay As String)
  Dim As Integer IA
  Dim As Single Q_beta_minus
  IA = IZ + IN
  If R_an > 0 Then
    If U_Q_beta_minus(IZ,IA) > Q_threshold Then 
  ' The order of variables in the following line is adapted to SATAN presentation with "S"!  
   '   Print IZ;" ";IA-IZ;" ";IA;" ";Csng(0.01*R_an), _
   '     Csng(U_Q_beta_minus(IZ,IA)),C_decay
      I_out_an = I_out_an + 1   
      Redim Preserve C_out_an(I_out_an)  
      C_out_an(I_out_an) = Str(IZ) + " " + Str(IA) + " " + Str(IA-IZ) 
      C_out_an(I_out_an) = C_out_an(I_out_an) + Space(15 - Len(C_out_an(I_out_an)))
      C_out_an(I_out_an) = C_out_an(I_out_an) + Str(Csng(0.01*R_an)) 
      C_out_an(I_out_an) = C_out_an(I_out_an) + Space(30 - Len(C_out_an(I_out_an)))
      Q_beta_minus = U_Q_beta_minus(IZ,IA)
      ' Fill analyzer Qbeta:
      Qbeta(Q_beta_minus*1.E3) = Qbeta(Q_beta_minus*1.E3) + 0.01*R_an
      C_out_an(I_out_an) = C_out_an(I_out_an) + Str(Csng(Q_beta_minus))  
      C_out_an(I_out_an) = C_out_an(I_out_an) + Space(45 - Len(C_out_an(I_out_an)))
      C_out_an(I_out_an) = C_out_an(I_out_an) + C_decay 
    End If
  End If
End Sub            

Declare Function Ibranch_for_ZAI(IZ As Integer,IA As Integer,ISO As Integer) As Integer

Function Ibranch_for_ZAI(IZ As Integer,IA As Integer,ISO As Integer) As Integer
  Dim As Integer I, Inmbr, IAfound
  Inmbr = 0  '  Default 
  For I = 1 To Ubound(BranchData)
    If IZ = BranchData(I).I_Z Then
      IAfound = Branchdata(I).I_A
    End If
    If IZ = BranchData(I).I_Z and  _ 
       IA = BranchData(I).I_A and  _
       ISO = BranchData(I).I_ISO Then
      Inmbr = I   
      Exit For
    End If   
  Next
  IF Inmbr = 0 Then  ' state in nucleus not found
    If IZ >= Z_min_branching And IZ <= Z_max_branching Then  ' no default decay branch outside Z range
      If IA < IAfound Then Inmbr = -1  ' beta-plus decay assumed
      If IA > IAfound Then Inmbr = -2  ' beta-minus decay assumed
    End if  
  End If
  Ibranch_for_ZAI = Inmbr
End Function

' Data from decay file of JEFF3.1.1 (JEFF report 20) (consistent with NucPropJEFF311.bas) 
' Data extracted from http://www.nndc.bnl.gov/chart are commented

' *) Allowed units are "ns", "ms", "s", "min", "h", "d", "y", "stable"
'  > 1.E10 y is noted as "stable"!
                 
'Z     A     isomer    t(1/2)             Bbeta-(%) Beta+(%)  Bbeta-n(%)  Bbeta-2n%      IT   alpha
'                                                          or Bbeta-p(%) (for beta-plus)       
'                      (value, unit*)     (   n included   )              
'Negative Z value mean that the decay goes into an isomeric state (see Branching.bas).
BranchTable:
Data  _  
 20,   35,    0,      26,      "ms",          0,  100,     95.7,   4.2,   0,  0, _
 20,   36,    0,     102,      "ms",          0,  100,     56.8,   0,     0,  0, _ 
 20,   37,    0,     181,      "ms",          0,  100,     82.1,   0,     0,  0, _
 20,   38,    0,     440,      "ms",          0,    0.02,   0,     0,     0,  0, _  '  0.02% beta_plus
-20,   38,    0,     440,      "ms",          0,   99.98,   0,     0,     0,  0, _  ' 99.98% beta-plus -> m
 20,   39,    0,     0.86,     "s",           0,   100,     0,     0,     0,  0, _
 20,   40,    0,     1,        "stable",      0,     0,     0,     0,     0,  0, _
 20,   41,    0,     1.03E5,   "y",           0,   100,     0,     0,     0,  0, _
 20,   42,    0,     1,        "stable",      0,     0,     0,     0,     0,  0, _
 20,   43,    0,     1,        "stable",      0,     0,     0,     0,     0,  0, _
 20,   44,    0,     1,        "stable",      0,     0,     0,     0,     0,  0, _
 20,   45,    0,     163,      "d",           100,   0,     0,     0,     0,  0, _
 20,   46,    0,     1,        "stable",      0,     0,     0,     0,     0,  0, _
 20,   47,    0,     4.538,    "d",           100,   0,     0,     0,     0,  0, _
 20,   48,    0,     1,        "stable",      0,     0,     0,     0,     0,  0, _
 20,   49,    0,     8.72,     "min",         100,   0,     0,     0,     0,  0, _
 20,   50,    0,     13.9,     "s",            0,    0,     0,     0,     0,  0, _
-20,   50,    0,     13.9,     "s",           100,   0,     0,     0,     0,  0, _   ' 100% beta -> m
 20,   51,    0,     10.0,     "s",           100,   0,     0,     0,     0,  0, _
 20,   52,    0,     4.6,      "s",           100,   0,     2,     0,     0,  0, _
 20,   53,    0,     90,       "ms",          100,   0,    30,     0,     0,  0, _         
 20,   54,    0,     50,       "ms",          100,   0,     0,     0,     0,  0, _
 20,   55,    0,     30,       "ms",          100,   0,     0,     0,     0,  0, _
 20,   56,    0,     10,       "ms",          100,   0,     0,     0,     0,  0, _
 20,   57,    0,     5,        "ms",          100,   0,     0,     0,     0,  0, _
                                                                  _
 21,   40,    0,     0.182,    "s",           0,    100,    0,     0,     0,  0, _    
 21,   41,    0,     0.596,    "s",           0,    100,    0,     0,     0,  0, _
 21,   42,    0,     0.681,    "s",           0,    100,    0,     0,     0,  0, _
 21,   42,    1,     1.033,    "min",           0,    100,    0,     0,     0,  0, _
 21,   43,    0,     3.891,    "h",           0,    100,    0,     0,     0,  0, _
 21,   44,    0,     3.97,     "h",           0,    100,    0,     0,     0,  0, _
 21,   44,    1,     2.442,    "d",           0,    1.23,   0,     0,   98.77, 0, _                                                      
 21,   45,    0,     1,        "stable",      0,     0,     0,     0,     0,  0, _
 21,   45,    1,     0.318,    "s",           0,     0,     0,     0,   100,  0, _
 21,   46,    0,     83.788,   "d",           100,   0,     0,     0,     0,  0, _
 21,   46,    1,     18.7,     "s",           0,     0,     0,     0,   100,  0, _    
 21,   47,    0,     3.351,    "d",           100,   0,     0,     0,     0,  0, _
 21,   48,    0,     1.82,     "d",           100,   0,     0,     0,     0,  0, _
 21,   49,    0,     57.2,     "min",         100,   0,     0,     0,     0,  0, _
 21,   50,    0,      1.708,   "min",         100,   0,     0,     0,     0,  0, _
 21,   50,    1,     0.35,     "s",           1.25,  0,     0,     0,    98.75, 0, _
 21,   51,    0,     12.4,     "s",           100,   0,     0,     0,     0,  0, _
 21,   52,    0,     8.2,      "s",           100,   0,     0,     0,     0,  0, _
 21,   53,    0,     3,        "s",           100,   0,     0,     0,     0,  0, _
 21,   54,    0,     0.26,     "s",           100,   0,     0,     0,     0,  0, _
 21,   55,    0,     120,      "ms",          100,   0,     0,     0,     0,  0, _
 21,   56,    0,     80,       "ms",          100,   0,     0,     0,     0,  0, _
 21,   57,    0,     13,       "ms",          100,   0,    33.0,   0,     0,  0, _
 21,   58,    0,     12,       "ms",          100,   0,     0,     0,     0,  0, _
 21,   59,    0,     10,       "ms",          100,   0,     0,     0,     0,  0, _
 21,   60,    0,     3,        "ms",          100,   0,     0,     0,     0,  0, _
                                                                   _
 22,   40,    0,    53,        "ms",           0,   100,  100,     0,     0,  0, _
 22,   41,    0,    81,        "ms",           0,   100,  100,     0,     0,  0, _
 22,   42,    0,     0.199,    "s",            0,   100,    0,     0,     0,  0, _
 22,   43,    0,     0.509,    "s",            0,   100,    0,     0,     0,  0, _
 22,   44,    0,     60,       "y",            0,   100,    0,     0,     0,  0, _
 22,   45,    0,     3.08,     "h",            0,   100,    0,     0,     0,  0, _                                                             
 22,   46,    0,     1,        "stable",       0,    0,     0,     0,     0,  0, _
 22,   47,    0,     1,        "stable",       0,    0,     0,     0,     0,  0, _
 22,   48,    0,     1,        "stable",       0,    0,     0,     0,     0,  0, _
 22,   49,    0,     1,        "stable",       0,    0,     0,     0,     0,  0, _
 22,   50,    0,     1,        "stable",       0,    0,     0,     0,     0,  0, _
 22,   51,    0,     5.8,      "min",         100,   0,     0,     0,     0,  0, _
 22,   52,    0,     1.7,      "min",         100,   0,     0,     0,     0,  0, _
 22,   53,    0,     32.7,     "s",           100,   0,     0,     0,     0,  0, _
 22,   54,    0,     1.5,      "s",           100,   0,     0,     0,     0,  0, _
 22,   55,    0,     0.49,     "s",           100,   0,     0,     0,     0,  0, _
 22,   56,    0,     164,      "ms",          100,   0,     0,     0,     0,  0, _
 22,   57,    0,     60,       "ms",          100,   0,   0.3,     0,     0,  0, _
 22,   58,    0,     54,       "ms",          100,   0,     0,     0,     0,  0, _
 22,   59,    0,     30,       "ms",          100,   0,     0,     0,     0,  0, _
 22,   60,    0,     22,       "ms",          100,   0,     0,     0,     0,  0, _
 22,   61,    0,     10,       "ms",          100,   0,     0,     0,     0,  0, _
 22,   62,    0,     10,       "ms",          100,   0,     0,     0,     0,  0, _
 22,   63,    0,     3,        "ms",          100,   0,     0,     0,     0,  0, _
                                                                  _
 23,   43,    0,     0.08,     "s",            0,   100,    0,     0,     0,  0, _
 23,   44,    0,     0.111,    "s",            0,   100,    0,     0,     0,  0, _
 23,   44,    1,     0.15,     "s",            0,   100,    0,     0,     0,  0, _
 23,   45,    0,     0.539,    "s",            0,   100,    0,     0,     0,  0, _
 23,   46,    0,     0.423,    "s",            0,   100,    0,     0,     0,  0, _
 23,   46,    1,     1.02,     "ms",           0,    0,     0,     0,    100, 0, _
 23,   47,    0,     32.6,     "min",          0,   100,    0,     0,     0,  0, _
 23,   48,    0,     15.974,   "d",            0,   100,    0,     0,     0,  0, _
 23,   49,    0,     330,      "d",            0,   100,    0,     0,     0,  0, _
 23,   50,    0,     1,        "stable",       0,    0,     0,     0,     0,  0, _  ' t1/2 = 1.4E17 years                                                              
 23,   51,    0,     1,        "stable",       0,    0,     0,     0,     0,  0, _
 23,   52,    0,     3.745,    "min",         100,   0,     0,     0,     0,  0, _
 23,   53,    0,     1.62,     "min",         100,   0,     0,     0,     0,  0, _
 23,   54,    0,     49.8,     "s",           100,   0,     0,     0,     0,  0, _
 23,   55,    0,     6.54,     "s",           100,   0,     0,     0,     0,  0, _
 23,   56,    0,     216,      "ms",          100,   0,     0,     0,     0,  0, _
 23,   57,    0,     0.35,     "s",           100,   0,    0.4,    0,     0,  0, _
 23,   58,    0,     191,      "ms",          100,   0,    80,     0,     0,  0, _
 23,   59,    0,     75,       "ms",          100,   0,     0,     0,     0,  0, _
 23,   60,    0,    122,       "ms",          100,   0,     0,     0,     0,  0, _
 23,   61,    0,     47,       "ms",          100,   0,     6,     0,     0,  0, _
 23,   62,    0,     34,       "ms",          100,   0,     0,     0,     0,  0, _
 23,   63,    0,     17,       "ms",          100,   0,    35,     0,     0,  0, _
 23,   64,    0,     10,       "ms",          100,   0,     0,     0,     0,  0, _
 23,   65,    0,     10,       "ms",          100,   0,     0,     0,     0,  0, _
                                                                  _
 24,   42,    0,     14,       "ms",           0,   100,    0,     0,     0,  0, _
 24,   43,    0,     22,       "ms",           0,   100,   23,     6,     0,  0, _
 24,   44,    0,     54,       "ms",           0,   100,    7,     0,     0,  0, _
 24,   45,    0,     50,       "ms",           0,   100,   27,     0,     0,  0, _
-24,   45,    1,      1,       "ms",           0,    50,    0,     0,    50,  0, _                           
 24,   46,    0,      0.26,    "s",            0,   100,    0,     0,     0,  0, _
 24,   47,    0,      0.5,     "s",            0,   100,    0,     0,     0,  0, _
 24,   48,    0,     21.56,    "h",            0,   100,    0,     0,     0,  0, _
 24,   49,    0,     41.9,     "min",          0,   100,    0,     0,     0,  0, _ 
 24,   50,    0,      1,       "stable",       0,    0,     0,     0,     0,  0, _   ' t1/2 = 1.8E17 Years
 24,   51,    0,     27.703,   "d",            0,   100,    0,     0,     0,  0, _   
 24,   52,    0,      1,       "stable",       0,    0,     0,     0,     0,  0, _
 24,   53,    0,      1,       "stable",       0,    0,     0,     0,     0,  0, _
 24,   54,    0,      1,       "stable",       0,    0,     0,     0,     0,  0, _
 24,   55,    0,      3.54,    "min",         100,   0,     0,     0,     0,  0, _
 24,   56,    0,      5.94,    "min",         100,   0,     0,     0,     0,  0, _
 24,   57,    0,      21.1,    "s",           100,   0,     0,     0,     0,  0, _
 24,   58,    0,      7.0,     "s",           100,   0,     0,     0,     0,  0, _
 24,   59,    0,      0.46,    "s",           100,   0,     0,     0,     0,  0, _
 24,   60,    0,      0.56,    "s",           100,   0,     0,     0,     0,  0, _
 24,   61,    0,      0.261,   "s",           100,   0,     0,     0,     0,  0, _
 24,   62,    0,      0.199,   "s",            50,   0,     0,     0,     0,  0, _ 
-24,   62,    0,      0.199,   "s",            50,   0,     0,     0,     0,  0, _  ' beta -> m 50% (!)
 24,   63,    0,      129,     "ms",          100,   0,     0,     0,     0,  0, _
 24,   64,    0,      43,      "ms",          100,   0,     0,     0,     0,  0, _
 24,   65,    0,      27,      "ms",          100,   0,     0,     0,     0,  0, _
 24,   66,    0,      10,      "ms",          100,   0,     0,     0,     0,  0, _
 24,   67,    0,      10,      "ms",          100,   0,     0,     0,     0,  0, _
                                                                  _
 25,   46,    0,      37,      "ms",           0,   100,   22,    18,     0,  0, _     
 25,   46,    1,       1,      "ms",           0,   100,    0,     0,     0,  0, _ 
 25,   47,    0,     100,      "ms",           0,    98.3,  1.7,   0,     0,  0, _
-25,   47,    0,     100,      "ms",           0,     1.7,  1.7,   0,     0,  0, _  ' 1.7% beta-plus -> m 
 25,   48,    0,     158,      "ms",           0,    99,    0.28,  0,     0,  0, _
 25,   49,    0,       0.382,  "s",            0,   100,    0,     0,     0,  0, _
 25,   50,    0,       0.284,  "s",            0,   100,    0,     0,     0,  0, _
 25,   50,    1,       1.75,   "min",          0,   100,    0,     0,     0,  0, _
 25,   51,    0,      46.2,    "min",          0,   100,    0,     0,     0,  0, _
 25,   52,    0,       5.595,  "d",            0,   100,    0,     0,     0,  0, _
 25,   52,    1,      21.2,    "min",          0,  98.25,   0,     0,     1.75,  0, _      
 25,   53,    0,       3.68E6, "y",            0,   100,    0,     0,     0,  0, _
 25,   54,    0,     312.13,   "d",            0,   100,    0,     0,     0,  0, _                                                 
 25,   55,    0,       1,      "stable",       0,    0,     0,     0,     0,  0, _
 25,   56,    0,       2.582,  "h",           100,   0,     0,     0,     0,  0, _
 25,   57,    0,       1.423,  "min",         100,   0,     0,     0,     0,  0, _
 25,   58,    0,       1.087,  "min",         100,   0,     0,     0,     0,  0, _
 25,   58,    1,       2.7,    "s",           100,   0,     0,     0,     0,  0, _  ' 
 25,   59,    0,       4.59,   "s",           100,   0,     0,     0,     0,  0, _
 25,   60,    0,       51,     "s",           100,   0,     0,     0,     0,  0, _
 25,   60,    1,       1.77,   "s",            88.5,  0,    0,     0,   11.5, 0, _
 25,   61,    0,       0.67,   "s",           100,    0,    0,     0,     0,  0, _
 25,   62,    0,       0.88,   "s",           100,    0,    0,     0,     0,  0, _
 25,   62,    1,       0.092,  "s",           100,    0,    0,     0,     0,  0, _  
 25,   63,    0,       0.275,  "s",           100,    0,    0,     0,     0,  0, _
 25,   64,    0,       89,     "ms",          100,    0,    0,     0,     0,  0, _
_'25,   64,    1,       0.5,    "ms",          0,    0,    0,     0,   100,  0, _
 25,   65,    0,       92,     "ms",          100,    0,    0,     0,     0,  0, _
 25,   66,    0,       64,     "ms",          100,    0,    0,     0,     0,  0, _
 25,   67,    0,       45,     "ms",          100,    0,    0,     0,     0,  0, _
 25,   68,    0,       28,     "ms",          100,    0,    0,     0,     0,  0, _
 25,   69,    0,       14,     "ms",          100,    0,   24,     0,     0,  0, _
                                                                   _
 26,   47,    0,       22,     "ms",           0,    100,  87,     0,     0,  0, _
 26,   48,    0,       44,     "ms",           0,    100,   3.6,   0,     0,  0, _
 26,   49,    0,       70,     "ms",           0,    100,  52,     0,     0,  0, _ 
 26,   50,    0,       0.155,  "s",            0,    100,   0,     0,     0,  0, _
 26,   51,    0,       5.083,  "h",            0,    100,   0,     0,     0,  0, _
 26,   52,    0,       8.275,  "h",            0,     0,    0,     0,     0,  0, _        
-26,   52,    0,       8.275,  "h",            0,    100,   0,     0,     0,  0, _  ' beta-plus -> m     
 26,   52,    1,      45.9,    "s",            0,    100,   0,     0,     0,  0, _
 26,   53,    0,       8.51,   "min",          0,    100,   0,     0,     0,  0, _  
 26,   53,    1,       2.58,   "min",          0,     0,    0,     0,    100,  0, _
 26,   54,    0,       1,      "stable",       0,     0,    0,     0,     0,  0, _
 26,   55,    0,       2.735,  "y",            0,    100,   0,     0,     0,  0, _                                                           
 26,   56,    0,       1,      "stable",       0,     0,    0,     0,     0,  0, _
 26,   57,    0,       1,      "stable",       0,     0,    0,     0,     0,  0, _
 26,   58,    0,       1,      "stable",       0,     0,    0,     0,     0,  0, _
 26,   59,    0,       44.495, "d",           100,    0,    0,     0,     0,  0, _
 26,   60,    0,       1.5E+6, "y",            0,     0,    0,     0,     0,  0, _    
-26,   60,    0,       1.5E+6, "y",           100,    0,    0,     0,     0,  0, _   ' beta -> m 
 26,   61,    0,       5.98,   "min",         100,    0,    0,     0,     0,  0, _
 26,   62,    0,       1.133,  "min",         100,    0,    0,     0,     0,  0, _
 26,   63,    0,       6.1,    "s",           100,    0,    0,     0,     0,  0, _
 26,   64,    0,       2.0,    "s",           100,    0,    0,     0,     0,  0, _
 26,   65,    0,       1.3,    "s",           100,    0,    0,     0,     0,  0, _
 26,   66,    0,       0.44,   "s",           100,    0,    0,     0,     0,  0, _
 26,   67,    0,       0.394,  "s",           100,    0,    0,     0,     0,  0, _
 _'26,   67,    1,       0.075,  "ms",         0,     0,    0,     0,    100,  0, _  ' 100% IT   
 26,   68,    0,       187,    "ms",           0,     0,    0,     0,     0,  0, _    
-26,   68,    0,       187,    "ms",          100,    0,    0,     0,     0,  0, _   ' beta -> m 
 26,   69,    0,       109,    "ms",           93,    0,    0,     0,     0,  0, _
-26,   69,    0,       109,    "ms",            7,    0,    7,     0,     0,  0, _   ' 7% beta-n -> m
 26,   70,    0,       94,     "ms",            0,    0,    0,     0,     0,  0, _    
-26,   70,    0,       94,     "ms",           100,   0,    0,     0,     0,  0, _   ' beta  -> m 
 26,   71,    0,       30,     "ms",           100,   0,    0,     0,     0,  0, _
 26,   72,    0,       10,     "ms",           100,   0,    0,     0,     0,  0, _
                                                                  _
 27,   50,    0,       44,     "ms",            0,  100,   54,     0,     0,  0, _
 27,   51,    0,       60,     "ms",            0,  100,    0,     0,     0,  0, _
 27,   52,    0,      115,     "ms",            0,   50,    0,     0,     0,  0, _
-27,   52,    0,      115,     "ms",            0,   50,    0,     0,     0,  0, _
 27,   52,    1,      104,     "ms",            0,   50,    0,     0,    50,  0, _
 27,   53,    0,      240,     "ms",            0,  100,    0,     0,     0,  0, _
 27,   53,    1,      247,     "ms",            0,    0,    0,     0,     0,  0, _  ' p: 1.5% (not considered)
-27,   53,    1,      247,     "ms",            0,   100,   0,     0,     0,  0, _  ' beta-plus -> m: 98.5%
 27,   54,    0,       0.193,  "s",             0,   100,   0,     0,     0,  0, _
 27,   54,    1,       1.48,   "min",           0,   100,   0,     0,     0,  0, _
 27,   55,    0,      17.53,   "h",             0,   100,   0,     0,     0,  0, _
 27,   56,    0,      77.31,   "d",             0,   100,   0,     0,     0,  0, _
 27,   57,    0,     271.8,    "d",             0,   100,   0,     0,     0,  0, _
 27,   58,    0,      70.86,   "d",             0,   100,   0,     0,     0,  0, _
 27,   58,    1,       8.9,    "h",             0,    0,    0,     0,    100, 0, _                                                
 27,   59,    0,       1,      "stable",        0,    0,    0,     0,     0,  0, _
 27,   60,    0,       5.271,  "y",            100,   0,    0,     0,     0,  0, _
 27,   60,    1,      10.47,   "min",           0.25, 0,    0,     0,    99.75, 0, _  
 27,   61,    0,       1.650,  "h",            100,   0,    0,     0,     0, 0, _
 27,   62,    0,       1.50,   "min",          100,   0,    0,     0,     0, 0, _
 27,   62,    1,      13.91,   "min",           99,   0,    0,     0,     1, 0, _   
 27,   63,    0,       27.4,   "s",            100,   0,    0,     0,     0, 0, _
 27,   64,    0,       0.30,   "s",            100,   0,    0,     0,     0, 0, _
 27,   65,    0,       1.20,   "s",            100,   0,    0,     0,     0, 0, _
 27,   66,    0,       0.233,  "s",            100,   0,    0,     0,     0, 0, _
 27,   67,    0,       0.425,  "s",            100,   0,    0,     0,     0, 0, _
 27,   68,    0,       0.199,  "s",            100,   0,    0,     0,     0, 0, _
 27,   68,    1,       1.6,    "s",             50,   0,    0,     0,    50, 0, _
 27,   69,    0,       0.227,  "s",            100,   0,    1,     0,     0, 0, _
 27,   70,    0,       119,    "ms",           100,   0,    0,     0,     0, 0, _
 27,   70,    1,       0.5,    "s",            100,   0,    0,     0,     0, 0, _
 27,   71,    0,       97,     "ms",           100,   0,    0,     0,     0, 0, _
 27,   72,    0,       90,     "ms",           100,   0,    0,     0,     0, 0, _
 27,   73,    0,       80,     "ms",           100,   0,    0,     0,     0, 0, _
 27,   74,    0,       50,     "ms",           100,   0,    0,     0,     0, 0, _
 27,   75,    0,       40,     "ms",           100,   0,    0,     0,     0, 0, _
                                                                  _
 28,   49,    0,       13,     "ms",            0,   100,   0,     0,     0, 0, _
 28,   50,    0,        9.1,   "ms",            0,   100,   0,     0,     0, 0, _
 28,   51,    0,       30,     "ms",            0,   100,   0,     0,     0, 0, _ 
 28,   52,    0,       38,     "ms",            0,    17,  17,     0,     0, 0, _
-28,   52,    0,       38,     "ms",            0,    83,   0,     0,     0, 0, _
 28,   53,    0,       45,     "ms",            0,    87.5, 22.5,  0,     0, 0, _                                                                    
-28,   53,    0,       45,     "ms",            0,    22.5, 22.5,  0,     0, 0, _                                            
 28,   54,    0,       0.104,  "s",             0,   100,   0,     0,     0, 0, _
 28,   55,    0,       0.204,  "s",             0,   100,   0,     0,     0, 0, _
 28,   56,    0,       6.075,  "d",             0,   100,   0,     0,     0, 0, _
 28,   57,    0,       1.496,  "d",             0,   100,   0,     0,     0, 0, _
 28,   58,    0,       1,      "stable",        0,    0,    0,     0,     0, 0, _  ' t1/2 = 7.E20 years  
 28,   59,    0,       7.6E4,  "y",             0,   100,   0,     0,     0, 0, _                                                            
 28,   60,    0,       1,      "stable",        0,    0,    0,     0,     0, 0, _
 28,   61,    0,       1,      "stable",        0,    0,    0,     0,     0, 0, _
 28,   62,    0,       1,      "stable",        0,    0,    0,     0,     0, 0, _
 28,   63,    0,       100.6,  "y",            100,   0,    0,     0,     0, 0, _
 28,   64,    0,       1,      "stable",        0,    0,    0,     0,     0, 0, _
 28,   65,    0,       2.52,   "h",            100,   0,    0,     0,     0, 0, _
 28,   66,    0,       2.267,  "d",            100,   0,    0,     0,     0, 0, _
 28,   67,    0,       21,     "s",            100,   0,    0,     0,     0, 0, _
 28,   68,    0,       29,     "s",            100,   0,    0,     0,     0, 0, _
 _'28,   68,    1,       0.86,   "ms",          0,    0,    0,     0,   100, 0, _  ' 100% IT
 28,   69,    0,       11.4,   "s",            100,   0,    0,     0,     0, 0, _
 28,   69,    1,       3.5,    "s",            100,   0,    0,     0,     0, 0, _
 28,   70,    0,       6.0,    "s",            100,   0,   100,    0,     0, 0, _
 28,   71,    0,       2.56,   "s",            100,   0,    0,     0,     0, 0, _
 28,   72,    0,       1.57,   "s",            100,   0,    0,     0,     0, 0, _
 28,   73,    0,       0.84,   "s",            100,   0,    0,     0,     0, 0, _
 28,   74,    0,       0.68,   "s",            100,   0,    0,     0,     0, 0, _
 28,   75,    0,       0.6,    "s",            100,   0,    1.6,   0,     0, 0, _
 28,   76,    0,       0.470,  "s",             50,   0,    0,     0,     0, 0, _   
-28,   76,    0,       0.470,  "s",             50,   0,    0,     0,     0, 0, _   ' beta -> m 50% 
 _'28,   76,    1,       590,    "ns",           0,   0,    0,     0,    100, 0, _ ' 100% IT
 28,   77,    0,       300,    "ms",           100,   0,    0,     0,     0, 0, _
 28,   78,    0,       200,    "ms",           100,   0,    0,     0,     0, 0, _
                                                                  _
 29,   56,    0,      93,      "ms",            0,   100,   0.4,   0,     0, 0, _ 
 29,   57,    0,       0.196,  "s",             0,   100,   0,     0,     0, 0, _
 29,   58,    0,       3.204,  "s",             0,   100,   0,     0,     0, 0, _
 29,   59,    0,       1.358,  "min",           0,   100,   0,     0,     0, 0, _
 29,   60,    0,      23.7,    "min",           0,   100,   0,     0,     0, 0, _
 29,   61,    0,       3.333,  "h",             0,   100,   0,     0,     0, 0, _
 29,   62,    0,       9.75,   "min",           0,   100,   0,     0,     0, 0, _
 29,   63,    0,       1,      "stable",        0,    0,    0,     0,     0, 0, _
 29,   64,    0,       12.701, "h",             39,  61,    0,     0,     0, 0, _
 29,   65,    0,       1,      "stable",        0,    0,    0,     0,     0, 0, _
 29,   66,    0,       5.10,   "min",          100,   0,    0,     0,     0, 0, _
 29,   67,    0,       2.579,  "d",            100,   0,    0,     0,     0, 0, _
 _'29,   67,    1,       2.4,    "ns",          0,    0,    0,     0,    100, 0, _   
 29,   68,    0,      31.1,    "s",            100,   0,    0,     0,     0, 0, _
 29,   68,    1,       3.75,   "min",           16,   0,    0,     0,    84, 0, _
 29,   69,    0,       2.85,   "min",          100,   0,    0,     0,    100, 0, _
 29,   70,    0,       44.5,   "s",            100,   0,    0,     0,     0, 0, _
 29,   70,    1,       33,     "s",             52,   0,    0,     0,    48, 0, _
 29,   70,    2,       6.6,    "s",             93.2, 0,    0,     0,     0, 0, _  
-29,   70,    2,       6.6,    "s",              0,   0,    0,     0,     6.8, 0, _  ' 6.8% IT -> m 
 29,   71,    0,       19.4,   "s",            100,   0,    0,     0,     0, 0, _
 29,   72,    0,       6.6,    "s",            100,   0,    0,     0,     0, 0, _
 29,   73,    0,       4.2,    "s",            100,   0,    0,     0,     0, 0, _
 29,   74,    0,       1.594,  "s",            100,   0,    0,     0,     0, 0, _
 29,   75,    0,       1.224,  "s",            100,   0,   3.5,    0,     0, 0, _
 29,   76,    0,       0.641,  "s",            100,   0,    3,     0,     0, 0, _
 29,   76,    1,       1.27,   "s",            100,   0,    0,     0,     0, 0, _
 29,   77,    0,       0.469,  "s",            100,   0,    0,     0,     0, 0, _
 29,   78,    0,       342,    "ms",           100,   0,    0,     0,     0, 0, _
 29,   79,    0,       188,    "ms",           100,   55,   0,     0,     0, 0, _
 29,   80,    0,       100,    "ns",           100,   0,    0,     0,     0, 0, _
                                                                  _
 30,   55,    0,      20,      "ms",            0,   100,   0,     0,     0, 0, _     
 30,   56,    0,      36,      "ms",            0,   100,   0,     0,     0, 0, _
 30,   57,    0,      38,      "ms",            0,   100,  65,     0,     0, 0, _
 30,   58,    0,      84,      "ms",            0,   100,   3,     0,     0, 0, _
 30,   59,    0,       0.182,  "s",             0,   100,   0,     0,     0, 0, _
 30,   60,    0,       2.38,   "min",           0,   100,   0,     0,     0, 0, _ 
 30,   61,    0,       1.485,  "min",           0,   100,   0,     0,     0, 0, _
 30,   61,    1,       0.43,   "s",             0,    0,    0,     0,    100, 0, _
 30,   61,    2,       0.14,   "s",             0,    0,    0,     0,    100, 0, _   
 30,   61,    3,       0.13,   "s",             0,    0,    0,     0,    100, 0, _
 30,   62,    0,       9.26,   "h",             0,   100,   0,     0,     0, 0, _
 30,   63,    0,      38.4,    "min",           0,   100,   0,     0,     0, 0, _
 30,   64,    0,       1,      "stable",        0,    0,    0,     0,     0, 0, _  ' t1/2 = 2.3E18 years
 30,   65,    0,     244.15,   "d",             0,   100,   0,     0,     0, 0, _                                                        
 30,   66,    0,       1,      "stable",        0,    0,    0,     0,     0, 0, _
 30,   67,    0,       1,      "stable",        0,    0,    0,     0,     0, 0, _
 30,   68,    0,       1,      "stable",        0,    0,    0,     0,     0, 0, _
 30,   69,    0,       56.4,   "min",          100,   0,    0,     0,     0, 0, _
 30,   69,    1,       13.78,  "h",            0.03,  0,    0,     0,    99.97, 0, _
 30,   70,    0,       1,      "stable",        0,    0,    0,     0,     0, 0, _
 30,   71,    0,       2.45,   "min",          100,   0,    0,     0,     0, 0, _
 30,   71,    1,       3.96,   "h",            100,   0,    0,     0,     0, 0, _   
 30,   72,    0,       1.938,  "d",            96.67, 0,    0,     0,     0, 0, _
-30,   72,    0,       1.938,  "d",             3.33, 0,    0,     0,     0, 0, _
 30,   73,    0,      23.5,    "s",            100,   0,    0,     0,     0, 0, _
 30,   73,    1,      13,      "s",             0,    0,    0,     0,    100,  0, _
 30,   73,    2,       5.8,    "s",            50,    0,    0,     0,     0, 0, _  ' 50 % IT -> m 
-30,   73,    2,       5.8,    "s",             0,    0,    0,     0,    50, 0, _
 30,   74,    0,      1.593,   "min",           0,    0,    0,     0,     0, 0, _  
-30,   74,    0,      1.593,   "min",          100,   0,    0,     0,     0, 0, _  ' beta -> m 
 30,   75,    0,      10.2,    "s",            100,   0,    0,     0,     0, 0, _
 30,   76,    0,       5.7,    "s",            100,   0,    0,     0,     0, 0, _
 30,   77,    0,       2.08,   "s",            100,   0,    0,     0,     0, 0, _
 30,   77,    1,       1.05,   "s",             50,   0,    0,     0,    50, 0, _  ' > 50% IT
 30,   78,    0,       1.47,   "s",            100,   0,    0,     0,     0, 0, _
 30,   79,    0,       0.995,  "s",            100,   0,   1.3,    0,     0, 0, _
 30,   80,    0,       0.545,  "s",            100,   0,    0,     0,     0, 0, _
 30,   81,    0,       0.29,   "s",            100,   0,   7.5,    0,     0, 0, _
 30,   82,    0,       100,    "ms",           100,   0,    0,     0,     0, 0, _
 30,   83,    0,        80,    "ms",           100,   0,    0,     0,     0, 0, _
                                                                  _
 31,   60,    0,      70,      "ms",            0,   100,   0,     0,     0, 0, _  
 31,   61,    0,     168,      "ms",            0,    90.4,   4.6,     0,     0, 0, _ ' 4.6: beta+ p?, report 20 unclear
-31,   61,    0,     168,      "ms",            0,     9,   0,     0,     0, 0, _ ' 9% beta_plus -> "m"
-31,   61,    0,     168,      "ms",            0,     0.6, 0,     0,     0, 0, _ ' 0.6% beta-plus -> "n" 
 31,   62,    0,       0.116,  "s",             0,   100,   0,     0,     0, 0, _
 31,   63,    0,      32.4,    "s",             0,   100,   0,     0,     0, 0, _
 31,   64,    0,       2.627,  "min",           0,   100,   0,     0,     0, 0, _
 31,   65,    0,      15.2,    "min",           0,   100,   0,     0,     0, 0, _ 
 31,   66,    0,       9.49,   "h",             0,   100,   0,     0,     0, 0, _
 31,   67,    0,       3.261,  "d",             0,   100,   0,     0,     0, 0, _ 
 31,   68,    0,       1.127,  "h",             0,   100,   0,     0,     0, 0, _                                                          
 31,   69,    0,       1,      "stable",        0,    0,    0,     0,     0, 0, _
 31,   70,    0,       21.14,  "min",          99.59, 0.41, 0,     0,     0, 0, _
 31,   71,    0,       1,      "stable",        0,    0,    0,     0,     0, 0, _
 31,   72,    0,       14.1,   "h",            100,   0,    0,     0,     0, 0, _
 31,   72,    1,       0.04,   "s",             0,    0,    0,     0,   100, 0, _ 
 31,   73,    0,       4.86,   "h",             1.41, 0,    0,     0,     0, 0, _   
-31,   73,    0,       4.86,   "h",            98.53, 0,    0,     0,     0, 0, _  ' 98.53 % beta -> m   
 31,   74,    0,       8.12,   "min",          100,   0,    0,     0,     0, 0, _
 31,   74,    1,       9.5,    "s",             25,   0,    0,     0,    75, 0, _  
 31,   75,    0,       2.1,    "min",           96,   0,    0,     0,     0, 0, _  
-31,   75,    0,       2.1,    "min",            4,   0,    0,     0,     0, 0, _  ' 4% beta -> m
 31,   76,    0,       32.6,   "s",            100,   0,    0,     0,     0, 0, _
 31,   77,    0,       13.0,   "s",             0,    0,    0,     0,     0, 0, _   
-31,   77,    0,       13.0,   "s",            100,   0,    0,     0,     0, 0, _  ' beta -> m  
 31,   78,    0,       5.09,   "s",            100,   0,    0,     0,     0, 0, _
 31,   79,    0,       2.847,  "s",             99.91, 0,  0.09,   0,     0, 0, _
-31,   79,    0,       2.847,  "s",             0.15,  0,   0,     0,     0, 0, _
 31,   80,    0,       1.697,  "s",             100,   0,   0,     0,     0, 0, _   
 31,   81,    0,       1.217,  "s",             58.43, 11.90, 0,   0,     0, 0, _  
-31,   81,    0,       1.217,  "s",             41.57, 0,   0,     0,     0, 0, _  ' 41.57% beta -> m
 31,   82,    0,       0.599,  "s",             89.35, 0, 10.65,   0,     0, 0, _
-31,   82,    0,       0.599,  "s",             10.65, 0, 10.65,   0,     0, 0, _  ' 10.65% beta-n -> m
 31,   83,    0,       0.308,  "s",             100,   0, 37.00,   0,     0, 0, _
 31,   84,    0,       0.085,  "s",             100,   0, 70.00,   0,     0, 0, _
 31,   85,    0,        50,    "ms",            100,   0,  0,      0,     0, 0, _
 31,   86,    0,        30,    "ms",            100,   0,  0,      0,     0, 0, _
                                                                  _
 32,   62,    0,       0.13,   "s",              0,  100,  0,    0,    0, 0, _
 32,   63,    0,       0.142,  "s",              0,  100,  0,    0,    0, 0, _
 32,   64,    0,       1.062,  "min",            0,  100,  0,    0,    0, 0, _
 32,   65,    0,      30.9,    "s",              0,  100,  0.01, 0,    0, 0, _  ' 0.01% beta-plus - p
 32,   66,    0,       2.26,   "h",              0,  100,  0,    0,    0, 0, _
 32,   67,    0,      18.9,    "min",            0,  100,  0,    0,    0, 0, _ 
 32,   68,    0,     270.95,   "d",              0,  100,  0,    0,    0, 0, _ 
 32,   69,    0,       1.627,  "d",              0,  100,  0,    0,    0, 0, _
 32,   70,    0,       1,      "stable",         0,   0,   0,    0,    0, 0, _
 32,   71,    0,      11.43,   "d",              0,  100,  0,    0,    0, 0, _
 32,   71,    1,       0.02,   "s",              0,   0,   0,    0,  100, 0, _                                                                 
 32,   72,    0,       1,      "stable",         0,   0,   0,    0,    0, 0, _
 32,   73,    0,       1,      "stable",         0,   0,   0,    0,    0, 0, _
 32,   73,    1,       0.5,    "s",              0,   0,   0,    0,  100, 0, _  
 32,   74,    0,       1,      "stable",         0,   0,   0,    0,    0, 0, _
 32,   75,    0,       1.38,   "h",             100,  0,   0,    0,    0, 0, _
 32,   75,    1,       47.7,   "s",              0,   0,   0,    0,   99.97, 0, _  ' 99.97% IT 
-32,   75,    1,       47.7,   "s",             0.03, 0,   0,    0,    0, 0, _  '  0.03% beta-m
 32,   76,    0,       1,      "stable",         0,   0,   0,    0,    0, 0, _
 32,   77,    0,       11.30,  "h",             100,  0,   0,    0,    0, 0, _
 32,   77,    1,       52.9,   "s",             81,   0,   0,    0,   19, 0, _  ' 19% IT
 32,   78,    0,       1.467,  "h",             100,  0,   0,    0,    0, 0, _
 32,   79,    0,       18.98,  "s",             100,  0,   0,    0,    0, 0, _
 32,   79,    1,       39,     "s",             96,   0,   0,    0,    4, 0, _  ' 4% IT
 32,   80,    0,       29.5,   "s",             100,  0,   0,    0,    0, 0, _
 32,   81,    0,       8,      "s",             100,  0,   0,    0,    0, 0, _
 32,   81,    1,       7.6,    "s",             81,   0,   0,    0,   19, 0, _  ' 19% IT
 32,   82,    0,       4.55,   "s",             100,  0,   0,    0,    0, 0, _
 32,   83,    0,       1.85,   "s",             100,  0,   0,    0,    0, 0, _
 32,   84,    0,       0.954,  "s",             55.4, 0, 10.8,   0,    0, 0, _
-32,   84,    0,       0.954,  "s",             44.6, 0,   0,    0,    0, 0, _ ' 44.6% beta -> m 
 32,   85,    0,       540,    "ms",            93,   0,   7,    0,    0, 0, _
-32,   85,    0,       540,    "ms",             7,   0,   7,    0,    0, 0, _ '* 7% beta-n -> m
 32,   86,    0,       300,    "ms",            100,  0,   0,    0,    0, 0, _
 32,   87,    0,       0.15,   "s",             100,  0,   0,    0,    0, 0, _
 32,   88,    0,        80,    "ms",            100,  0,   0,    0,    0, 0, _
 32,   89,    0,        50,    "ms",            100,  0,   0,    0,    0, 0, _
                                                                  _
 33,   64,    0,       0.04,   "s",              0,  100,  0,    0,    0, 0, _
 33,   65,    0,       0.17,   "s",              0,  100,  0,    0,    0, 0, _ 
 33,   66,    0,       0.096,  "s",              0,  100,  0,    0,    0, 0, _
 33,   67,    0,      42.5,    "s",              0,  100,  0,    0,    0, 0, _       
 33,   68,    0,       2.527,  "min",            0,  100,  0,    0,    0, 0, _
 33,   69,    0,      15.23,   "min",            0,  100,  0,    0,    0, 0, _ 
 33,   70,    0,      52.6,    "min",            0,  100,  0,    0,    0, 0, _
 33,   71,    0,       2.72,   "d",              0,  100,  0,    0,    0, 0, _
 33,   72,    0,       1.083,  "d",              0,  100,  0,    0,    0, 0, _
 33,   73,    0,      80.3,    "d",              0,   0,   0,    0,    0, 0, _   
-33,   73,    0,      80.3,    "d",              0,  100,  0,    0,    0, 0, _ ' 100% beta-plus -> m   
 33,   74,    0,      17.78,   "d",             34,   66,  0,    0,    0, 0, _ ' 34% beta-minus                                                       
 33,   75,    0,       1,      "stable",         0,   0,   0,    0,    0, 0, _
 33,   75,    1,       0.018,  "s",              0,   0,   0,    0,  100, 0, _  ' 100% IT
 33,   76,    0,       1.093,  "d",             100,  0,   0,    0,    0, 0, _
 33,   77,    0,       1.618,  "d",             100,  0,   0,    0,    0, 0, _
 33,   78,    0,       1.512,  "h",             100,  0,   0,    0,    0, 0, _
 33,   79,    0,       9.01,   "min",            2.37, 0,  0,    0,    0, 0, _ 
-33,   79,    0,       9.01,   "min",           97.63, 0,  0,    0,    0, 0, _ ' 97.63% beta -> m 
 33,   80,    0,       15.2,   "s",             100,   0,  0,    0,    0, 0, _
 33,   81,    0,       33.3,   "s",             96.41, 0,  0,    0,    0, 0, _ 
-33,   81,    0,       33.3,   "s",              3.59, 0,  0,    0,    0, 0, _ ' 3.59% beta -> m 
 33,   82,    0,       19.1,   "s",             100,   0,  0,    0,    0, 0, _
 33,   82,    1,       13.6,   "s",             100,   0,  0,    0,    0, 0, _   
 33,   83,    0,       13.4,   "s",              36,   0,  0,    0,    0, 0, _ 
-33,   83,    0,       13.4,   "s",              64,   0,  0,    0,    0, 0, _ ' 64% beta -> m 
 33,   84,    0,       4.02,   "s",              99.86, 0,  0.14,  0,  0, 0, _
-33,   84,    0,       4.02,   "s",              0.14,  0,  0.14,  0,  0, 0, _ ' 0.14% beta-n -> m 
 33,   84,    1,       0.65,   "s",             100,    0,  0,     0,  0, 0, _
 33,   85,    0,       2.04,   "s",             100,    0,  22,   0,   0, 0, _
 33,   86,    0,       0.945,  "s",             100,    0,  33,   0,   0, 0, _
 33,   87,    0,       0.61,   "s",             100,    0, 15.4,  0,   0, 0, _
 33,   88,    0,       300,    "ms",            100,    0,   0,   0,   0, 0, _
 33,   89,    0,       200,    "ms",            100,    0,   0,   0,   0, 0, _
 33,   90,    0,        80,    "ms",            100,    0,   0,   0,   0, 0, _
 33,   91,    0,        50,    "ms",            100,    0,   0,   0,   0, 0, _
 33,   92,    0,        30,    "ms",            100,    0,   0,   0,   0, 0, _
                                                                  _
 34,   68,    0,      35.5,    "s",              0,   100,   0,   0,   0, 0, _
 34,   69,    0,      27.4,    "s",              0,   100,   0,   0,   0, 0, _
 34,   70,    0,      41.1,    "min",            0,   100,   0,   0,   0, 0, _
 34,   71,    0,       4.74,   "min",            0,   100,   0,   0,   0, 0, _
 34,   72,    0,       8.4,    "d",              0,   100,   0,   0,   0, 0, _
 34,   73,    0,       7.15,   "h",              0,   100,   0,   0,   0, 0, _
 34,   73,    1,      39.8,    "min",            0,  27.4,   0,   0,  73.6, 0, _ 
 34,   74,    0,       1,      "stable",         0,    0,    0,   0,   0, 0, _
 34,   75,    0,     119.64,   "d",              0,   100,   0,   0,   0, 0, _                                                              
 34,   76,    0,       1,      "stable",         0,    0,    0,   0,   0, 0, _
 34,   77,    0,       1,      "stable",         0,    0,    0,   0,   0, 0, _
 34,   77,    1,      17.55,   "s",              0,    0,    0,   0, 100, 0, _
 34,   78,    0,       1,      "stable",         0,    0,    0,   0,   0, 0, _
 34,   79,    0,       3.77E+5, "y",            100,   0,    0,   0,   0, 0, _
 34,   79,    1,       3.9,     "min",           0.06, 0,    0,   0, 99.94, 0, _
 34,   80,    0,       1,      "stable",         0,    0,    0,   0,   0, 0, _
 34,   81,    0,       18.39,  "min",           100,   0,    0,   0,   0, 0, _
 34,   81,    1,       57.28,  "min",           0.06,  0,    0,   0,  99.94, 0, _  ' 99.94% IT
 34,   82,    0,       1,      "stable",         0,    0,    0,   0,   0, 0, _
 _'34,   82,    1,       6.6,    "ns",           0,    0,    0,   0,  100, 0, _  ' 100% IT
 34,   83,    0,       22.3,   "min",           100,   0,    0,   0,   0, 0, _
 34,   83,    1,       1.168,  "min",           100,   0,    0,   0,   0, 0, _
 34,   84,    0,       3.10,   "min",           100,   0,    0,   0,   0, 0, _
 34,   85,    0,       31.7,   "s",             100,   0,    0,   0,   0, 0, _
 34,   86,    0,       15.3,   "s",             100,   0,    0,   0,   0, 0, _
 34,   87,    0,       5.50,   "s",             100,   0,    0,   0,   0, 0, _
 34,   88,    0,       1.53,   "s",             100,   0,   0.99, 0,   0, 0, _
 34,   89,    0,       0.41,   "s",             100,   0,   7.80, 0,   0, 0, _
 34,   90,    0,       300,    "ms",            100,   0,    0,   0,   0, 0, _
 34,   91,    0,       0.27,   "s",             100,   0,  21.00, 0,   0, 0, _
 34,   92,    0,       100,    "ms",            100,   0,    0,   0,   0, 0, _
 34,   93,    0,        50,    "ms",            100,   0,    0,   0,   0, 0, _
 34,   94,    0,        20,    "ms",            100,   0,    0,   0,   0, 0, _
                                                                  _
 35,   70,    0,      79,      "ms",             0,   100,   0,   0,   0, 0, _ 
 35,   70,    1,       2.2,    "s",              0,    50,   0,   0,  50, 0, _
 35,   71,    0,      21.4,    "s",              0,   100,   0,   0,   0, 0, _
 35,   72,    0,       1.31,   "min",            0,   100,   0,   0,   0, 0, _
 35,   72,    1,      10.6,    "s",              0,    0,    0,   0,  100, 0, _
 35,   73,    0,       3.4,    "min",            0,    0,    0,   0,   0, 0, _   
-35,   73,    0,       3.4,    "min",            0,   100,   0,   0,   0, 0, _ ' beta-plus -> m   
 35,   74,    0,      25.4,    "min",            0,   100,   0,   0,   0, 0, _
 35,   74,    1,      46,      "min",            0,   100,   0,   0,   0, 0, _
 35,   75,    0,       1.612,  "h",              0,   100,   0,   0,   0, 0, _
 35,   76,    0,      16.2,    "h",              0,   100,   0,   0,   0, 0, _
 35,   76,    1,       1.31,   "s",              0,   0.6,   0,   0,  99.4, 0, _
 35,   77,    0,       2.377,  "d",              0,   100,   0,   0,   0, 0, _
 35,   77,    1,       4.28,   "min",            0,    0,    0,   0,  100, 0, _
 35,   78,    0,       6.46,   "min",            0,   100,   0,   0,   0, 0, _                                                               
 35,   79,    0,       1,      "stable",         0,    0,    0,   0,   0, 0, _
 35,   79,    1,       4.864,  "s",              0,    0,    0,   0, 100, 0, _
 35,   80,    0,       17.6,   "min",           91.7, 8.3,   0,   0,   0, 0, _
 35,   80,    1,       4.41,   "h",              0,    0,    0,   0, 100, 0, _
 35,   81,    0,       1,      "stable",         0,    0,    0,   0,   0, 0, _
 35,   82,    0,       1.472,  "d",             100,   0,    0,   0,   0, 0, _
 35,   82,    1,       6.09,   "min",           2.4,   0,    0,   0,  97.6, 0, _  ' 97.6% IT
 35,   83,    0,       2.40,   "h",             0.09,  0,    0,   0,   0, 0, _  
-35,   83,    0,       2.40,   "h",             99.91, 0,    0,   0,   0, 0, _  ' 99.91% beta -> m 
 35,   84,    0,       31.80,  "min",           100,   0,    0,   0,   0, 0, _  
 35,   84,    1,       6.0,    "min",           100,   0,    0,   0,   0, 0, _
 35,   85,    0,       2.90,   "min",            0.16, 0,    0,   0,   0, 0, _  
-35,   85,    0,       2.90,   "min",           99.84, 0,    0,   0,   0, 0, _  ' 99.84% beta -> m 
 35,   86,    0,       55.0,   "s",             100,   0,    0,   0,   0, 0, _
 35,   87,    0,       55.7,   "s",             100,   0,  2.51,  0,   0, 0, _
 35,   88,    0,       16.5,   "s",             100,   0,  6.58,  0,   0, 0, _
 _'35,   88,    1,       5300,   "ns",            0,   0,    0,   0,  100, 0, _  ' 100% IT
 35,   89,    0,       4.37,   "s",             100,   0,  14.1,  0,   0, 0, _
 35,   90,    0,       1.90,   "s",             100,   0,  24.60, 0,   0, 0, _
 35,   91,    0,       0.538,  "s",             100,   0,  20.00, 0,   0, 0, _
 35,   92,    0,       0.343,  "s",             100,   0,  33.10, 0,   0, 0, _
 35,   93,    0,       102,    "ms",            100,   0,  68.00, 0,   0, 0, _
 35,   94,    0,       70,     "ms",            100,   0,  70.00, 0,   0, 0, _
 35,   95,    0,       50,     "ms",            100,   0,    0,   0,   0, 0, _
 35,   96,    0,       20,     "ms",            100,   0,    0,   0,   0, 0, _
 35,   97,    0,       10,     "ms",            100,   0,    0,   0,   0, 0, _
                                                                  _
 36,   69,    0,       32,     "ms",             0,   100,   0,   0,   0, 0, _
 36,   70,    0,       52,     "ms",             0,    0,    0,   0,   0, 0, _
-36,   70,    0,       52,     "ms",             0,   100,   0,   0,   0, 0, _
 36,   71,    0,       64,     "ms",             0,   100,   0,   0,   0, 0, _
 36,   72,    0,      17.16,   "s",              0,    0,    0,   0,   0, 0, _  
-36,   72,    0,      17.16,   "s",              0,   100,   0,   0,   0, 0, _
 36,   73,    0,      27.3,    "s",              0,   100,   0,   0,   0, 0, _
 36,   74,    0,      11.5,    "min",            0,   100,   0,   0,   0, 0, _
 36,   75,    0,       4.29,   "min",            0,   100,   0,   0,   0, 0, _
 36,   76,    0,      14.8,    "h",              0,   100,   0,   0,   0, 0, _
 36,   77,    0,       1.24,   "h",              0,   100,   0,   0,   0, 0, _
 36,   78,    0,       1,      "stable",         0,    0,    0,   0,   0, 0, _  ' t1/2 = 1.1E20 years
 36,   79,    0,       1.46,   "d",              0,   100,   0,   0,   0, 0, _
 36,   79,    1,      50,      "s",              0,    0,    0,   0, 100, 0, _
 36,   80,    0,       1,      "stable",         0,    0,    0,   0,   0, 0, _
 36,   81,    0,       2.1E5,  "y",              0,   100,   0,   0,   0, 0, _
 36,   81,    1,      13.2,    "s",              0,    0,    0,   0, 100, 0, _                                                                  
 36,   82,    0,       1,      "stable",         0,    0,    0,   0,   0, 0, _
 36,   83,    0,       1,      "stable",         0,    0,    0,   0,   0, 0, _
 36,   83,    1,       1.83,   "h",              0,    0,    0,   0,  100, 0, _  ' 100% IT
 36,   84,    0,       1,      "stable",         0,    0,    0,   0,   0, 0, _
 36,   85,    0,      10.752,  "y",             100,   0,    0,   0,   0, 0, _
 36,   85,    1,       4.48,   "h",             78.6,  0,    0,   0,  21.4, 0, _  ' 21.4% IT
 36,   86,    0,       1,      "stable",         0,    0,    0,   0,   0, 0, _
 36,   87,    0,       1.272,  "h",             100,   0,    0,   0,   0, 0, _
 36,   88,    0,       2.84,   "h",             100,   0,    0,   0,   0, 0, _
 36,   89,    0,       3.15,   "min",           100,   0,    0,   0,   0, 0, _
 36,   90,    0,       32.32,  "s",              86.92, 0,   0,   0,   0, 0, _  
-36,   90,    0,       32.32,  "s",              13.08, 0,   0,   0,   0, 0, _  ' 13.08% beta -> m 
 36,   91,    0,       8.57,   "s",             100,   0,    0,   0,   0, 0, _
 36,   92,    0,       1.840,  "s",             100,   0,    0,   0,   0, 0, _
 36,   93,    0,       1.286,  "s",             100,   0,    0,   0,   0, 0, _
 36,   94,    0,       21,     "ms",            100,   0,  1.11,  0,   0, 0, _
 36,   95,    0,       114,    "ms",            100,   0,  2.87,  0,   0, 0, _
 36,   96,    0,       80,     "ms",             51.85, 0, 3.70,  0,   0, 0, _ 
-36,   96,    0,       80,     "ms",             48.15, 0,   0,   0,   0, 0, _ ' 48.15% beta -> m
 36,   97,    0,       63,     "ms",            96.65,  0, 3.35,  0,   0, 0, _
-36,   97,    0,       63,     "ms",             5.50,  0, 5.50,  0,   0, 0, _ ' 5.5% beta-n -> m
 36,   98,    0,       46,     "ms",             7.00,  0, 7.00,  0,   0, 0, _
-36,   98,    0,       46,     "ms",            93.00,  0,   0,   0,   0, 0, _ ' 93% beta -> m
 36,   99,    0,       40,     "ms",            94.50,  0,  5.50, 0,   0, 0, _
-36,   99,    0,       40,     "ms",             5.50,  0,  5.50, 0,   0, 0, _ ' 5.5% beta-n -> m
 36,   100,   0,       10,     "ms",            100,    0,   0,   0,   0, 0, _
                                                                  _
 37,   74,    0,       0.065,  "s",              0,   100,   0,   0,   0, 0, _
 37,   75,    0,      19,      "s",              0,   100,   0,   0,   0, 0, _ 
 37,   76,    0,      36.5,    "s",              0,   100,   0,   0,   0, 0, _
 37,   77,    0,       3.77,   "min",            0,   100,   0,   0,   0, 0, _
 37,   78,    0,      17.66,   "min",            0,   100,   0,   0,   0, 0, _ 
 37,   78,    1,       5.74,   "min",            0,    90,   0,   0,  10, 0, _
 37,   79,    0,      22.9,    "min",            0,   100,   0,   0,   0, 0, _
 37,   80,    0,      34,      "s",              0,   100,   0,   0,   0, 0, _
 37,   81,    0,      4.576,   "h",             4.52,   0,   0,   0,   0, 0, _  
-37,   81,    0,      4.576,   "h",            95.48,   0,   0,   0,   0, 0, _  ' 95.48% beta-plus -> m 
 37,   81,    1,     30.25,    "min",           3.77,   0,   0,   0,  96.2, 0, _ 
-37,   81,    1,     30.25,    "min",           0.03,   0,   0,   0,   0, 0, _  ' 0.03% beta-plus -> m  
 37,   82,    0,      1.273,   "min",            0,   100,   0,   0,   0, 0, _   
 37,   82,    1,      6.472,   "h",              0,   100,   0,   0,   0, 0, _
 37,   83,    0,     86.2,     "d",              0,    25,   0,   0,   0, 0, _   
-37,   83,    0,     86.2,     "d",              0,    75,   0,   0,   0, 0, _  ' 75% beta-plus -> m  
 37,   83,    1,      7.8,     "ms",             0,     0,   0,   0,  100, 0, _ 
 37,   84,    0,     33.5,     "d",             3.20,  96.8, 0,   0,   0, 0, _  ' 3.2% beta-minus     
 37,   84,    1,     20.4,     "min",            0,     0,   0,   0,  100, 0, _                                           
 37,   85,    0,       1,      "stable",         0,     0,   0,   0,   0, 0, _
 37,   86,    0,       18.64,  "d",             99.99,  0.01, 0,  0,   0, 0, _
 37,   86,    1,       1.017,  "min",            0,     0,    0,  0, 100, 0, _
 37,   87,    0,       1,      "stable",         0,     0,    0,  0,   0, 0, _
 37,   88,    0,       17.8,   "min",           100,    0,    0,  0,   0, 0, _
 37,   89,    0,       15.4,   "min",           100,    0,    0,  0,   0, 0, _
 37,   90,    0,       2.633,  "min",           100,    0,    0,  0,   0, 0, _
 37,   90,    1,       4.3,    "min",            97.4,  0,    0,  0,   2.6, 0, _  ' 2.6% IT 
 37,   91,    0,       58.4,   "s",             100,    0,    0,  0,   0, 0, _
 37,   92,    0,       4.492,  "s",             100,    0,    0,  0,   0, 0, _
 37,   93,    0,       5.8,    "s",             100,    0,   1.4, 0,   0, 0, _
 37,   94,    0,       2.702,  "s",             100,    0,  10.10, 0,  0, 0, _
 37,   95,    0,       381,    "ms",            100,    0,   8.6, 0,   0, 0, _
 37,   96,    0,       199,    "ms",            100,    0,  13.40, 0,  0, 0, _
 37,   96,    1,       0.2,    "s",              50,    0,    0,   0, 50, 0, _ 
 37,   97,    0,       170,    "ms",            100,    0, 25.10,  0,  0, 0, _
 37,   98,    0,       114,    "ms",            100,    0, 13.80,  0.05,  0, 0, _ ' 0.05% beta-2n
 37,   98,    1,        96,    "ms",            100,    0,    0,   0,  0, 0, _
 37,   99,    0,       50,     "ms",            100,    0, 15.90,  0,  0, 0, _
 37,   100,   0,       51,     "ms",            100,    0,   5.6,  0.15,  0, 0, _ ' 0.15% beta-2n
 37,   101,   0,       32,     "ms",            100,    0,   0,    0,  0, 0, _
 37,   102,   0,       37,     "ms",            100,    0,  18,    0,  0, 0, _
                                                                  _
 38,   73,    0,       25,     "ms",             0,   100,   0,   0,   0, 0, _      
 38,   74,    0,       50,     "ms",             0,   100,   0,   0,   0, 0, _
 38,   75,    0,       88,     "ms",             0,   100,   5.2, 0,   0, 0, _
 38,   76,    0,        8.9,   "s",              0,   100,   0,   0,   0, 0, _ 
 38,   77,    0,        9,     "s",              0,   100,   0,   0,   0, 0, _ 
 38,   78,    0,        2.65,  "min",            0,   100,   0,   0,   0, 0, _
 38,   79,    0,        2.25,  "min",            0,   100,   0,   0,   0, 0, _
 38,   80,    0,        1.772, "h",              0,   100,   0,   0,   0, 0, _ 
 38,   81,    0,       22.3,   "min",            0,    99.9, 0,   0,   0, 0, _ 
-38,   81,    0,       22.3,   "min",            0,    0.1,  0,   0,   0, 0, _ ' 0.1% beta-plus -> m 
 38,   82,    0,       25.55,  "d",              0,   100,   0,   0,   0, 0, _
 38,   83,    0,       1.35,   "d",              0,   100,   0,   0,   0, 0, _ 
 38,   83,    1,       4.95,   "s",              0,    0,    0,   0,  100, 0, _      
 38,   84,    0,        1,   "stable",           0,    0,    0,   0,   0, 0, _
 38,   85,    0,       64.849, "d",              0,   100,   0,   0,   0, 0, _
 38,   85,    1,        1.127, "h",              0,  13.40,  0,   0,   0, 0, _
 38,   86,    0,       1,      "stable",         0,    0,    0,   0,   0, 0, _                                                           
 38,   87,    0,       1,      "stable",         0,    0,    0,   0,   0, 0, _
 38,   87,    1,       2.816,  "h",              0.3,  0,    0,   0,  99.7, 0, _  ' 99.7% IT
 38,   88,    0,       1,      "stable",        0,     0,    0,   0,   0, 0, _
 38,   89,    0,       50.57,  "d",            99.99,  0,    0,   0,   0, 0, _  
-38,   89,    0,       50.57,  "d",            0.01,   0,    0,   0,   0, 0, _  ' 0.01% beta -> m 
 38,   90,    0,       28.79,  "y",             100,   0,    0,   0,   0, 0, _
 38,   91,    0,       9.63,   "h",             41.16, 0,    0,   0,   0, 0, _  
-38,   91,    0,       9.63,   "h",             58.84, 0,    0,   0,   0, 0, _  ' 58.84% beta -> m 
 38,   92,    0,       2.71,   "h",             100,   0,    0,   0,   0, 0, _
 38,   93,    0,       7.423,  "min",           74.98,  0,   0,   0,   0, 0, _  
-38,   93,    0,       7.423,  "min",           25.02,  0,   0,   0,   0, 0, _  ' 25.02% beta -> m 
 38,   94,    0,       1.255,  "min",           100,    0,   0,   0,   0, 0, _
 38,   95,    0,       23.90,  "s",             100,    0,   0,   0,   0, 0, _
 38,   96,    0,       1.06,   "s",             100,    0,   0,   0,   0, 0, _
 38,   97,    0,       429,    "ms",             85.11, 0,  0.03, 0,   0, 0, _  
-38,   97,    0,       429,    "ms",             14.90, 0,  0.03, 0,   0, 0, _  ' 14,90% beta -> m 
 38,   98,    0,       0.653,  "s",             100,    0,   0,   0,   0, 0, _
 38,   99,    0,       0.27,   "s",             100,    0,   0,   0,   0, 0, _
 38,   100,   0,       202,    "ms",            100,    0,  0.78, 0,   0, 0, _
 38,   101,   0,       118,    "ms",             98.82, 0,  1.19, 0,   0, 0, _
-38,   101,   0,       118,    "ms",             1.19,  0,  1.19, 0,   0, 0, _  ' 1.19% beta-n -> m
 38,   102,   0,       69,     "ms",            52.75,  0,  5.50, 0,   0, 0, _  
-38,   102,   0,       69,     "ms",            47.25,  0,   0,   0,   0, 0, _  ' 47.25% beta -> m 
 38,   103,   0,        50,    "ms",            100,    0,   0,   0,   0, 0, _
 38,   104,   0,        30,    "ms",            100,    0,   0,   0,   0, 0, _
 38,   105,   0,        20,    "ms",            100,    0,   0,   0,   0, 0, _
                                                                  _
 39,   78,    0,      54,      "ms",             0,    100,  0,   0,   0, 0, _
 39,   78,    1,       5.8,    "ms",             0,    100,  0,   0,   0, 0, _
 39,   79,    0,      14.8,    "s",              0,    100,  0,   0,   0, 0, _   
 39,   80,    0,      35,      "s",              0,    100,  0,   0,   0, 0, _
 39,   80,    1,       4.8,    "s",              0,     19,  0,   0,  81, 0, _
 39,   81,    0,       1.173,  "min",            0,    100,  0,   0,   0, 0, _
 39,   82,    0,       8.3,    "s",              0,    100,  0,   0,   0, 0, _
 39,   83,    0,       7.08,   "min",            0,   97.78, 0,   0,   0, 0, _  
-39,   83,    0,       7.08,   "min",            0,    2.22, 0,   0,   0, 0, _  ' 2.22% beta-plus -> m 
 39,   83,    1,       2.85,   "min",            0,     60,  0,   0,  40, 0, _
 39,   84,    0,       4.6,    "s",              0,    100,  0,   0,   0, 0, _
 39,   84,    1,      40,      "min",            0,    100,  0,   0,   0, 0, _
 39,   85,    0,       2.68,   "h",              0,    100,  0,   0,   0, 0, _
 39,   85,    1,       4.86,   "h",              0,    88.82, 0,  0,   0, 0, _  
-39,   85,    1,       4.86,   "h",              0,    11.18, 0,  0,   0, 0, _  ' 11.18% beta-plus -> m 
 39,   86,    0,      14.74,   "h",              0,    100,   0,  0,   0, 0, _ 
 39,   86,    1,      48,      "min",            0,    0.69,  0,  0, 99.31, 0, _
 39,   87,    0,       3.325,  "d",              0,    0 ,   0,   0,   0, 0, _   
-39,   87,    0,       3.325,  "d",              0,    100,  0,   0,   0, 0, _  ' beta-plus -> m  
 39,   87,    1,      13.37,   "h",              0,   1.57,  0,   0,  98.43, 0, _
 39,   88,    0,     106.629,  "d",              0,    100,  0,   0,   0, 0, _  
 39,   88,    1,       0.014,  "s",              0,     0,   0,   0,  100, 0, _
 39,   89,    0,       1,      "stable",         0,     0,   0,   0,   0, 0, _
 39,   89,    1,       15.663, "s",              0,     0,   0,   0,  100, 0, _  ' 100% IT
 39,   90,    0,       1.671,  "d",             100,    0,   0,   0,   0, 0, _
 39,   90,    1,       3.19,   "h",              0,     0,   0,   0,  100, 0, _  ' almost 100% IT  
 39,   91,    0,       58.51,  "d",             100,    0,   0,   0,   0, 0, _
 39,   91,    1,       49.71,  "min",            0,     0,   0,   0,  100, 0, _  ' 100% IT
 39,   92,    0,       3.54,   "h",             100,    0,   0,   0,   0, 0, _
 39,   93,    0,       10.18,  "h",             100,    0,   0,   0,   0, 0, _
 39,   93,    1,       0.82,   "s",              0,     0,   0,   0,  100, 0, _  ' 100% IT
 39,   94,    0,       18.7,   "min",           100,    0,   0,   0,   0, 0, _
 39,   95,    0,       10.3,   "min",           100,    0,   0,   0,   0, 0, _
 39,   96,    0,       5.34,   "s",             100,    0,   0,   0,   0, 0, _
 39,   96,    1,       9.62,   "s",             100,    0,   0,   0,   0, 0, _
 39,   97,    0,       3.75,   "s",             100,    0,  0.06, 0,   0, 0, _
 39,   97,    1,       1.17,   "s",             99.3,   0,  0.05, 0,   0.7, 0, _' < 0.7% IT     
 39,   97,    2,       142,    "ms",            1.6,    0,   0,   0,   0, 0, _  
-39,   97,    2,       142,    "ms",             0,     0,   0,   0,  98.4, 0, _  ' 98.4% IT -> m
 39,   98,    0,       0.59,   "s",             100,    0,  0.27, 0,   0, 0, _
 39,   98,    1,       2.0,    "s",             100,    0,  3.44, 0,   0, 0, _   
 39,   99,    0,       1.477,  "s",             100,    0,  1.70, 0,   0, 0, _
 _'39,   99,    1,       8600,   "ns",            0,    0,   0,   0,  100, 0, _  ' 100% IT
 39,   100,   0,       735,    "ms",            100,    0,   0.92, 0,  0, 0, _
 39,   100,   1,       0.94,   "s",             100,    0,   0,    0,  0, 0, _
 39,   101,   0,       0.45,   "s",             100,    0,   0,    0,  0, 0, _
 39,   102,   0,       0.3,    "s",             100,    0,   4.90, 0,  0, 0, _
 39,   102,   1,       0.36,   "s",             100,    0,   4.90, 0,  0, 0, _ 
 39,   103,   0,       0.224,  "s",             100,    0,   8.0,  0,  0, 0, _
 39,   104,   0,       0.13,   "s",             100,    0,   8.78, 0,  0, 0, _
 39,   105,   0,       150,    "ms",            100,    0,   19.75, 0, 0, 0, _
 39,   106,   0,        50,    "ms",            100,    0,   0,    0,  0, 0, _
 39,   107,   0,       30,     "ms",            100,    0,   0,    0,  0, 0, _
 39,   108,   0,       20,     "ms",            100,    0,   0,    0,  0, 0, _
                                                                  _
 40,   78,    0,       50,     "ms",             0,   100,   0,   0,   0, 0, _
 40,   79,    0,       56,     "ms",             0,   100,   0,   0,   0, 0, _
 40,   80,    0,        4.6,   "s",              0,    0,    0,   0,   0, 0, _  
-40,   80,    0,        4.6,   "s",              0,   100,   0,   0,   0, 0, _ ' beta-plus -> m  
 40,   81,    0,        5.5,   "s",              0,   100,   0.12, 0,  0, 0, _ ' 0.12% beta-plus-p
 40,   82,    0,       32,     "s",              0,   100,   0,   0,   0, 0, _
 40,   83,    0,       41.6,   "s",              0,   3.9,   0,   0,   0, 0, _ 
-40,   83,    0,       41.6,   "s",              0,  96.1,   0,   0,   0, 0, _ ' 96.1% beta-plus -> m 
 40,   84,    0,       25.9,   "min",            0,   100,   0,   0,   0, 0, _ 
 40,   85,    0,        7.86,  "min",            0,   100,   0,   0,   0, 0, _
 40,   85,    1,       10.9,   "s",              0,   8.0,   0,   0,  92, 0, _
 40,   86,    0,       16.5,   "h",              0,   50,    0,   0,   0, 0, _ 
-40,   86,    0,       16.5,   "h",              0,   50,    0,   0,   0, 0, _ ' 50% beta-plus -> m 
 40,   87,    0,        1.68,  "h",              0,   0.28,  0,   0,   0, 0, _ 
-40,   87,    0,        1.68,  "h",              0,  99.72,  0,   0,   0, 0, _ ' 99.72 beta-plus -> m 
 40,   87,    1,       14,     "s",              0,    0,    0,   0,  100, 0, _
 40,   88,    0,       83,     "d",              0,   100,   0,   0,   0, 0, _ 
 40,   89,    0,        3.267, "d",              0,   0.13,  0,   0,   0, 0, _ 
-40,   89,    0,        3.267, "d",              0,   99.87, 0,   0,   0, 0, _ ' 99.87% beta-plus -> m 
 40,   89,    1,        4.18,  "min",            0,   6.66,  0,   0,  93.34, 0, _
 40,   90,    0,       1,      "stable",         0,    0,    0,   0,   0, 0, _
 40,   90,    1,       0.809,  "s",              0,    0,    0,   0,  100, 0, _
 40,   91,    0,       1,      "stable",         0,    0,    0,   0,   0, 0, _
 40,   92,    0,       1,      "stable",         0,    0,    0,   0,   0, 0, _
 40,   93,    0,       1.53E+6, "y",             2.5,  0,    0,   0,   0, 0, _ 
-40,   93,    0,       1.53E+6, "y",            97.5,  0,    0,   0,   0, 0, _ ' 97.5% beta -> m 
 40,   94,    0,       1,      "stable",         0,    0,    0,   0,   0, 0, _
 40,   95,    0,       64.032, "d",             98.92, 0,    0,   0,   0, 0, _ 
-40,   95,    0,       64.032, "d",             1.08,  0,    0,   0,   0, 0, _ ' 1.08% beta -> m 
 40,   96,    0,       1,      "stable",         0,    0,    0,   0,   0, 0, _
 40,   97,    0,       16.744, "h",             4.95,  0,    0,   0,   0, 0, _ 
-40,   97,    0,       16.744, "h",            95.05,  0,    0,   0,   0, 0, _ ' 95.05 % beta -> m 
 40,   98,    0,       30.7,   "s",             100,   0,    0,   0,   0, 0, _
 40,   99,    0,       2.2,    "s",            63.2,   0,    0,   0,   0, 0, _ 
-40,   99,    0,       2.2,    "s",            36.8,   0,    0,   0,   0, 0, _ ' 36.8% beta -> m 
 40,   100,   0,       7.1,    "s",             100,   0,    0,   0,   0, 0, _
 40,   101,   0,       2.3,    "s",             100,   0,    0,   0,   0, 0, _
 40,   102,   0,       2.9,    "s",             100,   0,    0,   0,   0, 0, _
 40,   103,   0,       1.3,    "s",             100,   0,    0,   0,   0, 0, _
 40,   104,   0,       1.2,    "s",             100,   0,    0,   0,   0, 0, _
 40,   105,   0,       0.6,    "s",             100,   0,  1.40,  0,   0, 0, _
 40,   106,   0,       900,    "ns",            100,   0,  1.52,  0,   0, 0, _
 40,   107,   0,       240,    "ms",            100,   0,  3.71,  0,   0, 0, _
 40,   108,   0,       80,     "ms",            100,   0,    0,   0,   0, 0, _
 40,   109,   0,        60,    "ms",            100,   0,    0,   0,   0, 0, _
 40,   110,   0,        30,    "ms",            100,   0,    0,   0,   0, 0, _
                                                                  _
 41,   82,    0,       50,     "ms",           0,   100,   0,    0,    0, 0, _
 41,   83,    0,        4.1,   "s",            0,   100,   0,    0,    0, 0, _
 41,   84,    0,      12,      "s",            0,   100,   0,    0,    0, 0, _
 41,   85,    0,      20.9,    "s",            0,   100,   0,    0,    0, 0, _
 41,   85,    1,      12,      "s",            0,     0,   0,    0,    0, 0, _  
-41,   85,    1,      12,      "s",            0,   100,   0,    0,    0, 0, _  ' beta-plus -> m 
 41,   86,    0,       1.467,  "min",          0,   100,   0,    0,    0, 0, _
 41,   86,    1,      56,      "s",            0,   100,   0,    0,    0, 0, _
 41,   87,    0,       3.75,   "min",          0,   100,   0,    0,    0, 0, _
 41,   87,    1,       2.6,    "min",          0,   100,   0,    0,    0, 0, _
 41,   88,    0,      14.5,    "min",          0,   100,   0,    0,    0, 0, _ 
 41,   88,    1,       7.8,    "min",          0,   100,   0,    0,    0, 0, _
 41,   89,    0,       2.03,   "h",            0,   98.77, 0,    0,    0, 0, _  
-41,   89,    0,       2.03,   "h",            0,    1.23, 0,    0,    0, 0, _  ' 1.23% beta-plus -> m 
 41,   89,    1,       1.1,    "h",            0,     0,   0,    0,    0, 0, _  
-41,   89,    1,       1.1,    "h",            0,   100,   0,    0,    0, 0, _  'beta-plus -> m 
 41,   90,    0,      14.6,    "h",            0,    1.18, 0,    0,    0, 0, _ 
-41,   90,    0,      14.6,    "h",            0,   98.19, 0,    0,    0, 0, _  ' 98.19% beta-plus -> m 
 41,   90,    1,      18.81,   "s",            0,     0,   0,    0,   100, 0, _
 41,   90,    2,       6.19,   "ms",           0,     0,   0,    0,    0, 0, _  
-41,   90,    2,       6.19,   "ms",           0,     0,   0,    0,   100, 0, _  ' IT -> m 
 41,   91,    0,     680.016,  "y",            0,   100,   0,    0,    0, 0, _
 41,   91,    1,      60.9,    "d",            0,   2.40,  0,    0,   97.6, 0, _
 41,   92,    0,       3.5E7,  "y",            0,   100,   0,    0,    0, 0, _
 41,   92,    1,      10.15,   "d",            0,   100,   0,    0,    0, 0, _                                                            
 41,   93,    0,       1,      "stable",       0,     0,   0,    0,    0, 0, _
 41,   93,    1,      16.126,  "y",            0,     0,   0,    0,    0, 0, _  ' 100% IT
 41,   94,    0,       1.9993E+4,"y",          100,    0,   0,    0,    0, 0, _
 41,   94,    1,       6.26,   "min",          0.5,   0,   0,    0,  99.5, 0, _  ' 99.5% IT 
 41,   95,    0,       34.991, "d",           100,    0,   0,    0,    0, 0, _
 41,   95,    1,       3.608,  "d",            5.6,   0,   0,    0,  94.4, 0, _  ' 94.4% IT
 41,   96,    0,       23.35,  "h",           100,    0,   0,    0,    0, 0, _
 41,   97,    0,       1.202,  "h",           100,    0,   0,    0,    0, 0, _
 41,   97,    1,       52.7,   "s",            0,     0,   0,    0,  100, 0, _  ' 100% IT
 41,   98,    0,       2.86,   "s",           100,    0,   0,    0,    0, 0, _
 41,   98,    1,       51.3,   "min",         100,    0,   0,    0,    0, 0, _  ' <0.2% IT
 41,   99,    0,       15.0,   "s",           100,    0,   0,    0,    0, 0, _
 41,   99,    1,       2.6,    "min",          98,    0,   0,    0,    2, 0, _  ' 2% IT
 41,   100,   0,       1.5,    "s",           100,    0,   0,    0,    0, 0, _
 41,   100,   1,       2.9,    "s",           100,    0,   0,    0,    0, 0, _   
 _'41,   100,   2,       2.99,   "s",         100,    0,   0,    0,    0, 0, _
 _'41,   100,   3,       0.013,  "ms",          0,    0,   0,    0,   100, 0, _  ' 100% IT
 41,   101,   0,       7.1,    "s",           100,    0,   0,    0,    0, 0, _
 41,   102,   0,       1.3,    "s",           100,    0,   0,    0,    0, 0, _
 41,   102,   1,       4.3,    "s",           100,    0,   0,    0,    0, 0, _
 41,   103,   0,       1.5,    "s",           100,    0,   0,    0,    0, 0, _
 41,   104,   0,       4.9,    "s",           100,    0,   0.06, 0,    0, 0, _
 41,   104,   1,       0.94,   "s",           100,    0,   0.05, 0,    0, 0, _
 41,   105,   0,       2.95,   "s",           100,    0,   1.70, 0,    0, 0, _
 41,   106,   0,       0.92,   "s",           100,    0,   4.5,  0,    0, 0, _
 41,   107,   0,       300,    "ms",          100,    0,   6.00, 0,    0, 0, _
 41,   108,   0,       0.193,  "s",           100,    0,   6.20, 0,    0, 0, _
 41,   109,   0,       0.19,   "s",           100,    0,   12.65, 0,   0, 0, _
 41,   110,   0,       0.17,   "s",           100,    0,   40.00, 0,   0, 0, _
 41,   111,   0,       80,     "ms",          100,    0,   0,     0,   0, 0, _
 41,   112,   0,       60,     "ms",          100,    0,   0,     0,   0, 0, _
 41,   113,   0,       30,     "ms",          100,    0,   0,     0,   0, 0, _
                                                                  _
 42,   83,    0,       23,     "ms",           0,   100,   0,     0,   0, 0, _ 
 42,   84,    0,        3.8,   "ms",           0,   100,   0,     0,   0, 0, _
 42,   85,    0,        3.2,   "s",            0,     0,   0,     0,   0, 0, _
-42,   85,    0,        3.2,   "s",            0,   100,   0,     0,   0, 0, _
 42,   86,    0,      19.6,    "s",            0,    50,   0,     0,   0, 0, _
-42,   86,    0,      19.6,    "s",            0,    50,   0,    0,    0, 0, _
 42,   87,    0,      14.02,   "s",            0,   100,   0,    0,   0, 0, _
 42,   88,    0,       8,      "min",          0,    50,   0,    0,   0, 0, _  
-42,   88,    0,       8,      "min",          0,    50,   0,    0,   0, 0, _  ' 50% beta-plus -> m 
 42,   89,    0,       2.11,   "min",          0,   100,   0,    0,   0, 0, _
 42,   89,    1,       0.19,   "s",            0,     0,   0,    0,  100, 0, _
 42,   90,    0,       5.56,   "h",            0,    6.7,  0,    0,   0, 0, _  
-42,   90,    0,       5.56,   "h",            0,    0,    0,    0,   0, 0, _  ' 
-42,   90,    0,       5.56,   "h",            0,   93.3,  0,    0,   0, 0, _  ' 93.3% beta-plus -> n 
 42,   91,    0,      15.49,   "min",          0,   99.97, 0,    0,   0, 0, _  
-42,   91,    0,      15.49,   "min",          0,    0.03, 0,    0,   0, 0, _  ' 0.03% beta-plus -> m 
 42,   91,    1,       1.077,  "min",          0,     0,   0,    0,  50, 0, _  
 42,   91,    1,       1.077,  "min",          0,    50,   0,    0,   0, 0, _  ' 50% beta-plus -> m 
 42,   92,    0,       1,      "stable",       0,     0,   0,    0,   0, 0, _
 42,   93,    0,    4000.009,  "y",            0,    12,   0,    0,   0, 0, _   
-42,   93,    0,    4000.009,  "y",            0,    88,   0,    0,   0, 0, _  ' 88% beta-plus -> m 
 42,   93,    1,       6.85,   "h",            0,   0.12,  0,    0,  99.88, 0, _ 
 42,   94,    0,       1,      "stable",       0,     0,   0,    0,   0, 0, _                                                 
 42,   95,    0,       1,      "stable",       0,     0,   0,    0,   0, 0, _
 42,   96,    0,       1,      "stable",       0,     0,   0,    0,   0, 0, _
 42,   97,    0,       1,      "stable",       0,     0,   0,    0,   0, 0, _
 42,   98,    0,       1,      "stable",       0,     0,   0,    0,   0, 0, _
 42,   99,    0,       2.748,  "d",           11.94,  0,   0,    0,   0, 0, _  
-42,   99,    0,       2.748,  "d",           88.06,  0,   0,    0,   0, 0, _  ' 88.06% beta-plus -> m 
 42,   100,   0,       1,      "stable",       0,     0,   0,    0,   0, 0, _
 42,   101,   0,       14.61,  "min",         100,    0,   0,    0,   0, 0, _
 42,   102,   0,       11.3,   "min",         100,    0,   0,    0,   0, 0, _
 42,   103,   0,       1.132,  "min",         100,    0,   0,    0,   0, 0, _
 42,   104,   0,       60,     "s",           100,    0,   0,    0,   0, 0, _
 42,   105,   0,       35.6,   "s",           100,    0,   0,    0,   0, 0, _
 42,   106,   0,       8.73,   "s",           100,    0,   0,    0,   0, 0, _
 42,   107,   0,       3.5,    "s",           100,    0,   0,    0,   0, 0, _
 42,   108,   0,       1.09,   "s",           100,    0,   0,    0,   0, 0, _
 42,   109,   0,       0.5,    "s",           100,    0,   0.53, 0,   0, 0, _
 42,   110,   0,       0.3,    "s",           100,    0,   0,    0,   0, 0, _
 42,   111,   0,       500,    "ms",          100,    0,   1.03, 0,   0, 0, _
 42,   112,   0,       1,      "s",           100,    0,   2.08, 0,   0, 0, _
 42,   113,   0,       100,    "ms",          100,    0,   0,    0,   0, 0, _
 42,   114,   0,       80,     "ms",          100,    0,   0,    0,   0, 0, _
 42,   115,   0,       60,     "ms",          100,    0,   0,    0,   0, 0, _
                                                                  _
 43,   86,    0,       55,     "ms",           0,   100,   0,    0,   0, 0, _
 43,   87,    0,        2.2,   "s",            0,   100,   0,    0,   0, 0, _
 43,   87,    1,        2,     "s",            0,    50,   0,    0,  50, 0, _
 43,   88,    0,        5.8,   "s",            0,   100,   0,    0,   0, 0, _
 43,   88,    1,        6.4,   "s",            0,   100,   0,    0,   0, 0, _
 43,   89,    0,       12.8,   "s",            0,    50,   0,    0,   0, 0, _ 
-43,   89,    0,       12.8,   "s",            0,    50,   0,    0,   0, 0, _  ' 50% beta-plus -> m
 43,   89,    1,       12.9,   "s",            0,    49.99, 0,   0,  0.01, 0, _ 
-43,   89,    1,       12.9,   "s",            0,    49.99, 0,   0,   0, 0, _  ' 49.99% beta-plus -> m
 43,   90,    0,        8.7,   "s",            0,   100,    0,   0,   0, 0, _         
 43,   90,    1,       49.2,   "s",            0,   100,    0,   0,   0, 0, _
 43,   91,    0,        3.14,  "min",          0,    99.32, 0,   0,   0, 0, _   
-43,   91,    0,        3.14,  "min",          0,    0.68,  0,   0,   0, 0, _  ' 0.68% beta-plus -> m 
 43,   91,    1,        3.3,   "min",          0,    2.46,  0,   0,   1.0, 0, _  
-43,   91,    1,        3.3,   "min",          0,   96.54,  0,   0,   0, 0, _  ' 96.54% beta-plus -> m
 43,   92,    0,        4.25,  "min",          0,   100,    0,   0,   0, 0, _
 43,   93,    0,        2.75,  "h",            0,   100,    0,   0,   0, 0, _
 43,   93,    1,       43.5,   "min",          0,    23.4,  0,   0, 76.60, 0, _           
 43,   94,    0,        4.883, "h",            0,   100,    0,   0,   0, 0, _
 43,   94,    1,       52,     "min",          0,   100,    0,   0,   0, 0, _
 43,   95,    0,       20,     "h",            0,   100,    0,   0,   0, 0, _
 43,   95,    1,       61,     "d",            0,    96.12, 0,   0,  3.88, 0, _  
 43,   96,    0,        4.28,  "d",            0,   100,    0,   0,   0, 0, _
 43,   96,    1,       51.5,   "min",          0,     2.0,  0,   0,  98, 0, _
 43,   97,    0,     2.6E6,    "y",            0,   100,    0,   0,   0, 0, _
 43,   97,    1,       90.2,   "d",            0,     0,    0,   0, 100, 0, _
 43,   98,    0,     4.2E6,    "y",           100,    0,    0,   0,   0, 0, _
 43,   99,    0,     2.14E+5,  "y",           100,    0,    0,   0,   0, 0, _
 43,   99,    1,       6.01,   "h",             0,    0,    0,   0,  100, 0, _  ' 100% IT
 43,   100,   0,       15.8,   "s",           100,    0,    0,   0,   0, 0, _
 _'43,   100,   1,       8320,   "ns",          0,    0,    0,   0,  100, 0, _  ' 100% IT
 _'43,   100,   2,       3200,   "ns",          0,    0,    0,   0,  100, 0, _  ' 100% IT
 43,   101,   0,       14.2,   "min",         100,    0,    0,   0,   0, 0, _
 43,   101,   1,       0.636,  "ms",          100,    0,    0,   0,   0, 0, _  ' not in JEFF report 20   
 43,   102,   0,       5.28,   "s",           100,    0,    0,   0,   0, 0, _
 43,   102,   1,       4.35,   "min",         100,    0,    0,   0,   0, 0, _   
 43,   103,   0,       54.2,   "s",           100,    0,    0,   0,   0, 0, _
 43,   104,   0,       18.3,   "min",         100,    0,    0,   0,   0, 0, _
 43,   105,   0,       7.6,    "min",         100,    0,    0,   0,   0, 0, _
 43,   106,   0,       36.0,   "s",           100,    0,    0,   0,   0, 0, _
 43,   107,   0,       21.2,   "s",           100,    0,    0,   0,   0, 0, _
 43,   108,   0,       5.17,   "s",           100,    0,    0,   0,   0, 0, _
 43,   109,   0,       0.86,   "s",           100,    0,   0.08, 0,   0, 0, _
 43,   110,   0,       0.92,   "s",           100,    0,   0.04, 0,   0, 0, _  
 43,   111,   0,       290,    "ms",          100,    0,    0,   0,   0, 0, _
 43,   112,   0,       0.29,   "s",           100,    0,   1.5,  0,   0, 0, _
 43,   113,   0,       130,    "ms",          100,    0,   7.19, 0,   0, 0, _
 43,   114,   0,       200,    "ms",          100,    0,   6.54, 0,   0, 0, _
 43,   115,   0,       270,    "ms",          100,    0,  14.34, 0,   0, 0, _
 43,   116,   0,       120,    "ms",          100,    0,  12.22, 0,   0, 0, _
 43,   117,   0,        40,    "ms",          100,    0,   0,    0,   0, 0, _
 43,   118,   0,        30,    "ms",          100,    0,   0,    0,   0, 0, _
                                                                  _
 44,   87,    0,        50,    "ms",           0,   100,   0,    0,   0, 0, _  
 44,   88,    0,         1.3,  "s",            0,    50,   0,    0,   0, 0, _
-44,   88,    0,         1.3,  "s",            0,    50,   0,    0,   0, 0, _
 44,   89,    0,         1.38, "s",            0,    50,   0,    0,   0, 0, _
-44,   89,    0,         1.38, "s",            0,    50,   0,    0,   0, 0, _
 44,   90,    0,        11,    "s",            0,    50,   0,    0,   0, 0, _
-44,   90,    0,        11,    "s",            0,    50,   0,    0,   0, 0, _
 44,   91,    0,         9,    "s",            0,   100,   0,    0,   0, 0, _
 44,   91,    1,         7.6,  "s",            0,     0,   0,    0,   0, 0, _
-44,   91,    1,         7.6,  "s",            0,   100,   0,    0,   0, 0, _
 44,   92,    0,         3.65, "min",          0,   100,   0,    0,   0, 0, _    
 44,   93,    0,      59.7,    "s",            0,   100,   0,    0,   0, 0, _
 44,   93,    1,      10.8,    "s",            0,     0,   0,    0,  22, 0, _ 
-44,   93,    1,      10.8,    "s",            0,    78,   0,    0,   0, 0, _ 
 44,   94,    0,      51.8,    "min",          0,     0,   0,    0,   0, 0, _  
-44,   94,    0,      51.8,    "min",          0,   100,   0,    0,   0, 0, _  ' beta-plus -> m
 44,   95,    0,       1.643,  "h",            0,   97.39, 0,    0,   0, 0, _  
-44,   95,    0,       1.643,  "h",            0,    2.61, 0,    0,   0, 0, _  ' 2.61% beta-plus -> m
 44,   96,    0,       1,      "stable",       0,     0,   0,    0,   0, 0, _  ' t1/2 = 6.7E16 years
 44,   97,    0,       2.9,    "d",            0,   99.96, 0,    0,   0, 0, _  
-44,   97,    0,       2.9,    "d",            0,    0.04, 0,    0,   0, 0, _  ' 0.04% beta-plus -> m
 44,   98,    0,       1,      "stable",       0,     0,   0,    0,   0, 0, _                                                              
 44,   99,    0,       1,      "stable",       0,     0,   0,    0,   0, 0, _
 44,   100,   0,       1,      "stable",       0,     0,   0,    0,   0, 0, _
 44,   101,   0,       1,      "stable",       0,     0,   0,    0,   0, 0, _
 44,   102,   0,       1,      "stable",       0,     0,   0,    0,   0, 0, _
 44,   103,   0,       39.26,  "d",            1.2,   0,   0,    0,   0, 0, _   
-44,   103,   0,       39.26,  "d",           98.80,  0,   0,    0,   0, 0, _  ' 98.80% beta -> m
 44,   103,   1,       1.69,   "ms",           0,     0,   0,    0,  100, 0, _  ' 100% IT
 44,   104,   0,       1,      "stable",       0,     0,   0,    0,   0, 0, _
 44,   105,   0,       4.44,   "h",           71.61,  0,   0,    0,   0, 0, _  
-44,   105,   0,       4.44,   "h",           28.39,  0,   0,    0,   0, 0, _  ' 28.39% beta -> m
 44,   106,   0,       1.02,   "y",           100,    0,   0,    0,   0, 0, _
 44,   107,   0,       3.75,   "min",         100,    0,   0,    0,   0, 0, _
 44,   108,   0,       4.55,   "min",         100,    0,   0,    0,   0, 0, _
 44,   109,   0,       34.5,   "s",           100,    0,   0,    0,   0, 0, _
 44,   110,   0,       11.6,   "s",           100,    0,   0,    0,   0, 0, _
 44,   111,   0,       2.12,   "s",           100,    0,   0,    0,   0, 0, _
 44,   112,   0,       1.75,   "s",           100,    0,   0,    0,   0, 0, _               
 44,   113,   0,       0.80,   "s",           100,    0,   0,    0,   0, 0, _
 44,   113,   1,       510,    "ms",           50,    0,   0,    0,  50, 0, _  ' 50% IT
 44,   114,   0,       0.53,   "s",           100,    0,   0,    0,   0, 0, _
 44,   115,   0,       700,    "ms",          100,    0,   0.23, 0,   0, 0, _
 44,   116,   0,       1.7,    "s",           100,    0,   1.08, 0,   0, 0, _
 44,   117,   0,       340,    "ms",          100,    0,   2.05, 0,   0, 0, _
 44,   118,   0,       0.7,    "s",           100,    0,   4.11, 0,   0, 0, _
 44,   119,   0,       190,    "ms",          100,    0,   4.36, 0,   0, 0, _
 44,   120,   0,        80,    "ms",          100,    0,   0,    0,   0, 0, _
                                                                  _
 45,    89,   0,        10,    "ms",            0,  100,   0,    0,   0, 0, _
 45,    90,   0,        15,    "ms",            0,  100,   0,    0,   0, 0, _
 45,    90,   1,         1.1,  "ms",            0,  100,   0,    0,   0, 0, _
 45,    91,   0,         1.74, "s",             0,  100,   0,    0,   0, 0, _
 45,    92,   0,         4.3,  "s",             0,  100,   0,    0,   0, 0, _
 45,    93,   0,        13.9,  "s",             0,   50,   0,    0,   0, 0, _
-45,    93,   0,        13.9,  "s",             0,   50,   0,    0,   0, 0, _
 45,    94,   0,         1.177, "min",          0,  100,   0,    0,   0, 0, _
 45,    94,   1,        25.8,  "s",             0,  100,   0,    0,   0, 0, _
 45,    95,   0,         5.02, "min",           0,  100,   0,    0,   0, 0, _
 45,    95,   1,         1.96, "min",           0,   12,   0,    0,  88, 0, _
 45,    96,   0,         9.9,  "min",           0,  100,   0,    0,   0, 0, _
 45,    96,   1,         1.51, "min",           0,   40,   0,    0,  60, 0, _
 45,    97,   0,        30.7,  "min",           0,  100,   0,    0,   0, 0, _
 45,    97,   1,        46.2,  "min",           0,   94.4, 0,    0,   5.6, 0, _
 45,    98,   0,         8.72, "min",           0,  100,   0,    0,   0, 0, _
 45,    98,   1,         3.6,  "min",           0,   11,   0,    0,  89, 0, _
 45,    99,   0,        16.1,  "d",             0,  100,   0,    0,   0, 0, _
 45,    99,   1,         4.7,  "h",             0,  99.84,  0,   0,   0.16, 0, _
 45,   100,   0,        20.8,  "h",             0,  100,   0,    0,   0, 0, _
 45,   100,   1,         4.6,  "min",           0,   1.7,  0,    0,  98.3, 0, _
 45,   101,   0,         3.2,  "y",             0,  100,   0,    0,   0, 0, _
 45,   101,   1,         4.34, "d",             0,  92.56, 0,    0,   7.44, 0, _
 45,   102,   0,         2.902, "y",            0,  100,   0,    0,   0, 0, _
 45,   102,   1,     208,       "d",           20,   75,   0,    0,   5, 0, _                                                             
 45,   103,   0,       1,      "stable",        0,    0,   0,    0,   0, 0, _
 45,   103,   1,       56.114, "min",           0,    0,   0,    0, 100, 0, _  ' 100% IT
 45,   104,   0,       42.3,   "s",            99.55, 0.45, 0,   0,   0, 0, _  
 45,   104,   1,       4.34,   "min",           0.13, 0,   0,    0,  99.87, 0, _ ' 99.87% IT
 45,   105,   0,       1.473,  "d",           100,    0,   0,    0,   0, 0, _
 45,   105,   1,       40,     "s",             0,    0,   0,    0, 100, 0, _  ' 100% IT
 45,   106,   0,       30,     "s",           100,    0,   0,    0,   0, 0, _
 45,   106,   1,       2.2,    "h",           100,    0,   0,    0,   0, 0, _
 45,   107,   0,       21.7,   "min",         100,    0,   0,    0,   0, 0, _
 45,   108,   0,       16.8,   "s",           100,    0,   0,    0,   0, 0, _
 45,   108,   1,       6.0,    "min",         100,    0,   0,    0,   0, 0, _
 45,   109,   0,       1.333,  "min",          50,    0,   0,    0,   0, 0, _  
-45,   109,   0,       1.333,  "min",          50,    0,   0,    0,   0, 0, _  ' 50§ beta -> m 
 45,   110,   0,       28.5,   "s",           100,    0,   0,    0,   0, 0, _
 45,   110,   1,       3.2,    "s",           100,    0,   0,    0,   0, 0, _
 45,   111,   0,       12,     "s",           100,    0,   0,    0,   0, 0, _
 45,   112,   0,       2.1,    "s",           100,    0,   0,    0,   0, 0, _
 45,   112,   1,       6.8,    "s",           100,    0,   0,    0,   0, 0, _
 45,   113,   0,       2.80,   "s",           100,    0,   0,    0,   0, 0, _
 45,   114,   0,       1.85,   "s",           100,    0,   0,    0,   0, 0, _
 45,   114,   1,       1.85,   "s",           100,    0,   0,    0,   0, 0, _
 45,   115,   0,       0.99,   "s",            85.48, 0,   0,    0,   0, 0, _  
-45,   115,   0,       0.99,   "s",            14.52, 0,   0,    0,   0, 0, _  ' 14.52% beta -> m 
 45,   116,   0,       0.68,   "s",           100,    0,   0,    0,   0, 0, _
 45,   116,   1,       0.57,   "s",           100,    0,   0,    0,   0, 0, _
 45,   117,   0,       0.44,   "s",           100,    0,   0,    0,   0, 0, _
 45,   118,   0,       320,    "ms",          100,    0,   2.92, 0,   0, 0, _
 45,   119,   0,       300,    "ns",          100,    0,   0,    0,   0, 0, _
 45,   120,   0,       170,    "ms",          100,    0,   5.93, 0,   0, 0, _
 45,   121,   0,       250,    "ms",          100,    0,   13.57,0,   0, 0, _
 45,   122,   0,        50,    "ms",          100,    0,   0,    0,   0, 0, _
                                                                  _
 46,    91,   0,        10,    "ms",            0,  100,   0,    0,   0, 0, _
 46,    92,   0,         1.1,  "s",             0,  100,   0,    0,   0, 0, _
 46,    93,   0,         1.007, "s",            0,  100,   0,    0,   0, 0, _
 46,    94,   0,         9,    "s",             0,  100,   0,    0,   0, 0, _
 46,    95,   0,        10,    "s",             0,   50,   0,    0,   0, 0, _
-46,    95,   0,        10,    "s",             0,   50,   0,    0,   0, 0, _
 46,    95,   1,        13.3,  "s",             0,   95,   0.9,  0,   5, 0, _
 46,    96,   0,         2.033, "min",          0,    0,   0,    0,   0, 0, _ 
-46,    96,   0,         2.033, "min",          0,  100,   0,    0,   0, 0, _ 
 46,    97,   0,         3.1,   "min",          0,   98.31,0,    0,   0, 0, _
-46,    97,   0,         3.1,   "min",          0,    1.69,0,    0,   0, 0, _
 46,    98,   0,       17.7,    "min",          0,  100,   0,    0,   0, 0, _
 46,    99,   0,       21.4,    "min",          0,    2.95, 0,   0,   0, 0, _
-46,    99,   0,       21.4,    "min",          0,   97.05, 0,   0,   0, 0, _
 46,   100,   0,       3.63,   "d",             0,  100,   0,    0,   0, 0, _
 46,   101,   0,       8.47,   "h",             0,   0.27, 0,    0,   0, 0, _                                                                    
-46,   101,   0,       8.47,   "h",             0,  99.73, 0,    0,   0, 0, _  ' 99.73% beta-plus -> m                                                                   
 46,   102,   0,       1,      "stable",        0,    0,   0,    0,   0, 0, _
 46,   103,   0,      16.98,   "d",             0,   0.03, 0,    0,   0, 0, _   
-46,   103,   0,      16.98,   "d",             0,  99.97, 0,    0,   0, 0, _  ' 99.97% beta-plus -> m  
 46,   104,   0,       1,      "stable",        0,    0,   0,    0,   0, 0, _ 
 46,   105,   0,       1,      "stable",        0,    0,   0,    0,   0, 0, _
 46,   106,   0,       1,      "stable",        0,    0,   0,    0,   0, 0, _
 46,   107,   0,       6.5E+6, "y",             100,  0,   0,    0,   0, 0, _
 46,   107,   1,       21.3,   "s",             0,    0,   0,    0,  100, 0, _  ' 100% IT
 46,   108,   0,       1,      "stable",        0,    0,   0,    0,   0, 0, _
 46,   109,   0,       13.701,  "h",            0.05, 0,   0,    0,   0, 0, _  
-46,   109,   0,       13.701,  "h",           99.95, 0,   0,    0,   0, 0, _  ' 99.95% beta -> m 
 46,   109,   1,       4.69,   "min",           0,    0,   0,    0,  100, 0, _  
 46,   110,   0,       1,      "stable",        0,    0,   0,    0,   0, 0, _
 46,   111,   0,       23.4,   "min",           0.7,  0,   0,    0,   0, 0, _  
-46,   111,   0,       23.4,   "min",          99.3,  0,   0,    0,   0, 0, _  ' 99.3% beta -> m 
 46,   111,   1,       5.5,    "h",             7.81, 0,   0,    0,  73, 0, _  
-46,   111,   1,       5.5,    "h",            19.19, 0,   0,    0,   0, 0, _  ' 19.19% beta -> m 
 46,   112,   0,       20.3,   "h",           100,    0,   0,    0,   0, 0, _
 46,   113,   0,       1.517,  "min",           5,    0,   0,    0,   0, 0, _  
-46,   113,   0,       1.517,  "min",          95,    0,   0,    0,   0, 0, _  ' 95.00% beta -> m 
 46,   113,   1,       0.3,    "s",             0,    0,   0,    0, 100, 0, _  ' 100% IT
 46,   114,   0,       2.42,   "min",         100,    0,   0,    0,   0, 0, _
 46,   115,   0,       25,     "s",            73,    0,   0,    0,   0, 0, _  
-46,   115,   0,       25,     "s",            27,    0,   0,    0,   0, 0, _  ' 27.00% beta -> m 
 46,   115,   1,       50,     "s",            92,    0,   0,    0,   8, 0, _  ' 8% IT
 46,   116,   0,       11.8,   "s",           100,    0,   0,    0,   0, 0, _
 46,   117,   0,       4.3,    "s",            50,    0,   0,    0,   0, 0, _    
-46,   117,   0,       4.3,    "s",            50,    0,   0,    0,   0, 0, _  ' 50.00% beta -> m   
 46,   117,   1,       19,     "ms",            0,    0,   0,    0,   0, 0, _  ' 100% IT
 46,   118,   0,       1.9,    "s",            85.7,  0,   0,    0,   0, 0, _  ' 14.30% beta -> m 
 46,   119,   0,       0.92,   "s",            50,    0,   0,    0,   0, 0, _  ' 50.00% beta -> m 
 46,   120,   0,       0.5,    "s",            50,    0,   0,    0,   0, 0, _  ' 50.00% beta -> m 
 46,   121,   0,       0.6,    "s",           100,    0,   0.27, 0,   0, 0, _
 46,   122,   0,       0.3,    "s",           100,    0,   0,    0,   0, 0, _
 46,   123,   0,       200,    "ms",          100,    0,   0,    0,   0, 0, _
 46,   124,   0,       100,    "ms",          100,    0,   0,    0,   0, 0, _
                                                                  _
 47,    97,   0,        25.3,  "s",             0,  100,   0,    0,   0, 0, _
 47,    98,   0,        47.5,  "s",             0,  100,   0,    0,   0, 0, _
 47,    99,   0,         2.067, "min",          0,  100,   0,    0,   0, 0, _
 47,    99,   1,        10.5,  "s",             0,    0,   0,    0, 100, 0, _
 47,   100,   0,         2.01, "min",           0,  100,   0,    0,   0, 0, _ 
 47,   100,   1,         2.24, "min",           0,   50,   0,    0,  50, 0, _
 47,   101,   0,        11.1,  "min",           0,  100,   0,    0,   0, 0, _
 47,   101,   1,         3.1,  "s",             0,    0,   0,    0, 100, 0, _
 47,   102,   0,        12.9,  "min",           0,  100,   0,    0,   0, 0, _
 47,   102,   1,         7.7,  "min",           0,   51,   0,    0,  49, 0, _
 47,   103,   0,       1.095,  "h",             0,  100,   0,    0,   0, 0, _
 47,   103,   1,       5.7,    "s",             0,    0,   0,    0, 100, 0, _
 47,   104,   0,       1.153,  "h",             0,  100,   0,    0,   0, 0, _
 47,   104,   1,      33.5,    "min",           0,   99.93, 0,   0,  0.07, 0, _
 47,   105,   0,      41.3,    "d",             0,  100,   0,    0,   0,  0, _
 47,   105,   1,       7.23,   "min",           0,   0.34, 0,    0,  99.66,  0, _
 47,   106,   0,      24,      "min",           0.5, 99.5, 0,    0,   0, 0, _  ' 0.5% beta-minus
 47,   106,   1,       8.46,   "d",             0,  100,   0,    0,   0, 0, _
 47,   107,   0,       1,      "stable",        0,   0,    0,    0,   0, 0, _
 47,   107,   1,       44.3,   "s",             0,   0,    0,    0,  100, 0, _  ' 100% IT
 47,   108,   0,       2.4,    "min",          97.2, 2.9,  0,    0,   0, 0, _
 47,   108,   1,       418.01, "y",            91.3, 0,    0,    0,   8.7, 0, _  ' 8.7% IT
 47,   109,   0,       1,      "stable",        0,   0,    0,    0,   0, 0, _
 47,   109,   1,       39.7,   "s",             0,   0,    0,    0,  100, 0, _  ' 100% IT
 47,   110,   0,       24.56,  "s",            99.7, 0.3,  0,    0,   0, 0, _  ' 
 47,   110,   1,       249.78, "d",            98.64, 0,   0,    0,   1.36, 0, _ ' 1.36% IT
 47,   111,   0,       7.45,   "d",           100,    0,   0,    0,   0, 0, _
 47,   111,   1,       1.08,   "min",           0.5,  0,   0,    0,  99.5, 0, _  ' 99.5% IT
 47,   112,   0,       3.13,   "h",            100,   0,   0,    0,   0, 0, _
 47,   113,   0,       5.37,   "h",             98.27, 0,  0,    0,   0, 0, _  
-47,   113,   0,       5.37,   "h",              1.73, 0,  0,    0,   0, 0, _  ' 1.73% beta -> m 
 47,   113,   1,       1.145,  "min",           36,   0,   0,    0,  64, 0, _  ' 64% IT
 47,   114,   0,       4.6,    "s",            100,   0,   0,    0,   0, 0, _
 47,   114,   1,       1.5,    "ms",             0,   0,   0,    0, 100, 0, _
 47,   115,   0,       20.0,   "min",           94.27, 0,  0,    0,   0, 0, _  
-47,   115,   0,       20.0,   "min",            5.76, 0,  0,    0,   0, 0, _  ' 5.76% beta -> m 
 47,   115,   1,       18.6,   "s",             76.7,  0,  0,    0,  21, 0, _  
-47,   115,   1,       18.6,   "s",              2.3,  0,  0,    0,  21, 0, _ ' 21% IT, 2.3% beta -> m
 47,   116,   0,       2.68,   "min",          100,    0,  0,    0,   0, 0, _
 47,   116,   1,       8.6,    "s",             94,    0,  0,    0,   6, 0, _ ' 6% IT
 47,   117,   0,       1.227,  "min",           83.07, 0,  0,    0,   0, 0, _  
-47,   117,   0,       1.227,  "min",           16.93, 0,  0,    0,   0, 0, _ ' 16.93% beta -> m 
 47,   117,   1,       5.34,   "s",             70.72, 0,  0,    0,   6, 0, _ ' 6% IT
-47,   117,   1,       5.34,   "s",             23.28, 0,  0,    0,   0, 0, _ ' 23.28% beta -> m 
 47,   118,   0,       3.76,   "s",            100,    0,  0,    0,   0, 0, _
 47,   118,   1,       2.0,    "s",             59,    0,  0,    0,  41, 0, _ ' 41% IT
 47,   119,   0,       6.0,    "s",             50,    0,  0,    0,   0, 0, _ 
-47,   119,   0,       6.0,    "s",             50,    0,  0,    0,   0, 0, _ ' 50.00% beta -> m 
 47,   119,   1,       2.1,    "s",            100,    0,  0,    0,   0, 0, _
 47,   120,   0,       1.23,   "s",            100,    0,  0,    0,   0, 0, _
 47,   120,   1,       0.371,  "s",             63,    0,  0,    0,  37, 0, _ ' 37% IT
 47,   121,   0,       0.78,   "s",             89.05, 0,  0,    0,   0, 0, _  
-47,   121,   0,       0.78,   "s",             10.95, 0,  0,    0,   0, 0, _ ' 10.95% beta -> m 
 47,   122,   0,       0.48,   "s",            100,    0,  0,    0,   0, 0, _ ' Pbeta = 99.80% in ENSDF
 47,   122,   1,       1.5,    "s",            100,    0,  0,    0,   0, 0, _ ' branchings not known
 47,   123,   0,       0.31,   "s",             81.82, 0,  0,    0,   0, 0, _ 
-47,   123,   0,       0.31,   "s",             18.18, 0,  0,    0,   0, 0, _  ' 18.18% beta -> m 
 47,   124,   0,       0.172,  "s",             99.95, 0,  0.05, 0,  0, 0, _
-47,   124,   0,       0.172,  "s",              0.05, 0,  0.05, 0,  0, 0, _
 47,   124,   1,       0.2,    "s",              50,   0,  0,    0, 50, 0, _
 47,   125,   0,       166,    "ms",             50,   0,  0,    0,  0, 0, _  
-47,   125,   0,       166,    "ms",             50,   0,  0,    0,  0, 0, _  ' 50% beta -> m 
 47,   126,   0,       107,    "ms",            100,   0,  0,    0,  0, 0, _
 47,   127,   0,       79,     "ms",            100,   0,  0,    0,  0, 0, _
 47,   128,   0,       58,     "ms",            100,   0,  0,    0,  0, 0, _
 47,   129,   0,       44,     "ms",             50,   0,  0,    0,  0, 0, _  
-47,   129,   0,       44,     "ms",             50,   0,  0,    0,  0, 0, _  ' 50% beta -> m 
_'47,   129,   1,       160,    "ms",          100,   0,  0,    0,  0, 0, _  ' branchings not known
 47,   130,   0,       50,     "ms",            100,   0,  0,    0,  0, 0, _
                                                                  _
 48,    95,   0,        5,     "ms",              0, 100,  0,    0,  0, 0, _
 48,    96,   0,        1,     "s",               0,   0,  0,    0,  0, 0, _
-48,    96,   0,        1,     "s",               0, 100,  0,    0,  0, 0, _
 48,    97,   0,        2.8,   "s",               0, 100,  0,    0,  0, 0, _ 
 48,    98,   0,        9.2,   "s",               0, 100,  0,    0,  0, 0, _ 
 48,    99,   0,       16,     "s",               0,  50.1, 0.21,  0,  0, 0, _
-48,    99,   0,       16,     "s",               0,  49.9, 0,   0,  0, 0, _
 48,   100,   0,       49.1,   "s",               0, 100,  0,    0,  0, 0, _
 48,   101,   0,        1.36,  "min",             0,  88.95, 0,  0,  0, 0, _
-48,   101,   0,        1.36,  "min",             0,  11.05, 0,  0,  0, 0, _
 48,   102,   0,        5.5,   "min",             0,   5.77, 0,  0,  0, 0, _
-48,   102,   0,        5.5,   "min",             0,  94.23, 0,  0,  0, 0, _
 48,   103,   0,        7.3,   "min",             0,  81.31, 0,  0,  0, 0, _
-48,   103,   0,        7.3,   "min",             0,  18.69, 0,  0,  0, 0, _
 48,   104,   0,       57.7,   "min",             0,   0,   0,   0,  0, 0, _
-48,   104,   0,       57.7,   "min",             0,  100,  0,   0,  0, 0, _ ' beta-plus -> m 
 48,   105,   0,       55.5,   "min",             0,  17.79, 0,  0,  0, 0, _   
-48,   105,   0,       55.5,   "min",             0,  82.21, 0,  0,  0, 0, _  ' 82.21% beta-plus -> m  
 48,   106,   0,        1,     "stable",          0,   0,   0,   0,  0, 0, _
 48,   107,   0,        6.52,  "h",               0,  0.06, 0,   0,  0, 0, _  
-48,   107,   0,        6.52,  "h",               0, 99.94, 0,   0,  0, 0, _ ' 99.94% beta-plus -> m 
 48,   108,   0,        1,     "stable",           0,  0,   0,   0,  0, 0, _
 48,   109,   0,        1.267, "y",               0,   0,   0,   0,  0, 0, _ 
-48,   109,   0,        1.267, "y",               0, 100,   0,   0,  0, 0, _ ' 100% beta-plus -> m 
 48,   110,   0,       1,      "stable",          0,   0,   0,   0,  0, 0, _
 48,   111,   0,       1,      "stable",          0,   0,   0,   0,  0, 0, _
 48,   111,   1,       48.54,  "min",             0,   0,   0,   0, 100, 0, _ ' 100% IT
 48,   112,   0,       1,      "stable",          0,   0,   0,   0,  0, 0, _
 48,   113,   0,       1,      "stable",          0,   0,   0,   0,  0, 0, _ ' t1/2 = 7.7E15 years
 48,   113,   1,       14.1,   "y",             99.86, 0,   0,   0,  0.14, 0, _  ' 0.14% IT
 48,   114,   0,       1,      "stable",          0,   0,   0,   0,  0, 0, _  ' t1/2 = 6.E17 years
 48,   115,   0,       2.228,  "d",               0,   0,   0,   0,  0,  0, _  
-48,   115,   0,       2.228,  "d",             100,   0,   0,   0,  0,  0, _  ' 100% beta -> m 
 48,   115,   1,       44.6,   "d",             99.99, 0,   0,   0,  0,  0, _  
-48,   115,   1,       44.6,   "d",              0.01, 0,   0,   0,  0,  0, _  ' 0.01% beta -> m 
 48,   116,   0,       1,      "stable",          0,   0,   0,   0,  0,  0, _
 48,   117,   0,       2.49,   "h",               8.36,0,   0,   0,  0,  0, _  
-48,   117,   0,       2.49,   "h",              91.64,0,   0,   0,  0,  0, _  ' 91.64% beta -> m  
 48,   117,   1,       3.36,   "h",              98.48,0,   0,   0,  0,  0, _  
-48,   117,   1,       3.36,   "h",               1.52,0,   0,   0,  0,  0, _  ' 1.52% beta -> m 
 48,   118,   0,       50.3,   "min",           100,   0,   0,   0,  0,  0, _
 48,   119,   0,       2.69,   "min",             9.72,0,   0,   0,  0,  0, _  
-48,   119,   0,       2.69,   "min",            90.86,0,   0,   0,  0,  0, _  ' 90.86% beta -> m 
 48,   119,   1,       2.20,   "min",            99.78,0,   0,   0,  0,  0, _  
-48,   119,   1,       2.20,   "min",             0.22,0,   0,   0,  0,  0, _  ' 0.22% beta -> m 
 48,   120,   0,       50.80,  "s",             100,   0,   0,   0,  0,  0, _
 48,   121,   0,       13.5,   "s",              32.56,0,   0,   0,  0,  0, _  
-48,   121,   0,       13.5,   "s",              67.44,0,   0,   0,  0,  0, _  ' 67.44% beta -> m 
 48,   121,   1,       8.3,    "s",             100,   0,   0,   0,  0,  0, _
 48,   122,   0,       5.24,   "s",             100,   0,   0,   0,  0,  0, _
 48,   123,   0,       2.10,   "s",              30.79,0,   0,   0,  0,  0, _  
-48,   123,   0,       2.10,   "s",              69.03,0,   0,   0,  0,  0, _  ' 69.03% beta -> m 
 48,   123,   1,       1.82,   "s",              98.78,0,   0,   0,  0,  0, _  
-48,   123,   1,       1.82,   "s",               1.22,0,   0,   0,  0,  0, _  ' 1.22% beta -> m 
 48,   124,   0,       1.25,   "s",             100,   0,   0,   0,  0,  0, _
 48,   125,   0,       0.65,   "s",              47.86,0,   0,   0,  0,  0, _  
-48,   125,   0,       0.65,   "s",              52.14,0,   0,   0,  0,  0, _  ' 52.14% beta -> m 
 48,   125,   1,       0.48,   "s",             100,   0,   0,   0,  0,  0, _
 48,   126,   0,       0.515,  "s",             100,   0,   0,   0,  0,  0, _
 48,   127,   0,       0.37,   "s",               0,   0,   0,   0,  0,  0, _  
-48,   127,   0,       0.37,   "s",             100,   0,   0,   0,  0,  0, _  ' 100% beta -> m 
 48,   128,   0,       0.28,   "s",               0,   0,   0,   0,  0,  0, _  
-48,   128,   0,       0.28,   "s",             100,   0,   0,   0,  0,  0, _  ' 100% beta -> m 
 48,   129,   0,       0.242,  "s",               0,   0,   0,   0,  0,  0, _  
-48,   129,   0,       0.242,  "s",             100,   0,   0,   0,  0,  0, _  ' 100% beta -> m 
 48,   129,   1,       0.104,  "s",             100,   0,   0,   0,  0,  0, _   
 48,   130,   0,       162,    "ms",             98.25,0,  1.75, 0,  0,  0, _
-48,   130,   0,       162,    "ms",             1.75, 0,  1.75, 0,  0,  0, _
 48,   131,   0,       68,     "ms",            100,   0,  3.50, 0,  0,  0, _
 48,   132,   0,       97,     "ms",             40,   0,   0,   0,  0, 0, _
-48,   132,   0,       97,     "ms",             60,   0,  60,   0,  0, 0, _  ' 60% beta-n -> m 
                                                                  _
 49,    98,   0,       45,     "ms",              0, 100,   0,   0,  0, 0, _
 49,    98,   1,        1.7,   "s",               0, 100,   0,   0,  0, 0, _ 
 49,    99,   0,        3.1,   "s",               0, 100,   0,   0,  0, 0, _
 49,    99,   1,        1,     "s",               0,  50,   0,   0, 50, 0, _ 
 49,   100,   0,        5.9,   "s",               0,  96.1, 1.95, 0, 0, 0, _
-49,   100,   0,        5.9,   "s",               0,  1.95, 1.95, 0, 0, 0, _
 49,   101,   0,       15.1,   "s",               0, 100,   0,   0,  0, 0, _
 49,   101,   1,       10,     "s",               0,  95,   0,   0,  5, 0, _ 
 49,   102,   0,       22,     "s",               0, 100,   0,   0,  0, 0, _           
 49,   103,   0,        1,     "min",             0, 100,   0,   0,  0, 0, _
 49,   103,   1,       34,     "s",               0,  67,   0,   0, 33, 0, _
 49,   104,   0,        1.8,   "min",             0, 100,   0,   0,  0, 0, _
 49,   105,   0,        5.07,  "min",             0, 100,   0,   0,  0, 0, _
 49,   106,   0,        6.2,   "min",             0, 100,   0,   0,  0, 0, _
 49,   106,   1,        5.2,   "min",             0, 100,   0,   0,  0, 0, _
 49,   107,   0,       32.4,   "min",             0, 100,   0,   0,  0, 0, _
 49,   107,   1,       50.4,   "s",               0,   0,   0,   0, 100, 0, _
 49,   108,   0,       58,     "min",             0, 100,   0,   0,  0, 0, _
 49,   108,   1,       39.6,   "min",             0, 100,   0,   0,  0, 0, _
 49,   109,   0,       4.2,    "h",             0,  100,   0,    0,    0, 0, _
 49,   109,   1,       1.34,   "min",           0,    0,   0,    0,  100, 0, _
 49,   109,   2,       209,    "ms",            0,    0,   0,    0,  100, 0, _
 49,   110,   0,       4.9,    "h",             0,  100,   0,    0,    0, 0, _
 49,   110,   1,       1.152,  "h",             0,  100,   0,    0,    0, 0, _
 49,   111,   0,       2.805,  "d",             0,   99.99,0,    0,    0, 0, _ 
-49,   111,   0,       2.805,  "d",             0,    0.01,0,    0,    0, 0, _ ' 0.01% beta-plus -> m
 49,   111,   1,       7.9,    "min",           0,    0,   0,    0,  100, 0, _
 49,   112,   0,      14.7,    "min",          44,   56,   0,    0,    0, 0, _ ' 44% beta-minus
 49,   112,   1,      20.7,    "min",           0,    0,   0,    0,  100, 0, _
 49,   113,   0,       1,      "stable",        0,    0,   0,    0,    0, 0, _
 49,   113,   1,       1.658,  "h",             0,    0,   0,    0,  100, 0, _  ' 100% IT
 49,   114,   0,       1.198,  "min",          99.5, 0.5,  0,    0,    0, 0, _  ' 0.5% beta-plus
 49,   114,   1,       50,     "d",             0,   3.5,  0,    0,   961.5, 0, _  ' 96.5% IT 
 49,   114,   2,       43,     "ms",            0,    0,   0,    0,    0, 0, _  
-49,   114,   2,       43,     "ms",            0,    0,   0,    0,  100, 0, _  ' 100% IT -> m 
 49,   115,   0,       1,      "stable",        0,    0,   0,    0,    0, 0, _
 49,   115,   1,       4.486,  "h",             5,    0,   0,    0,   95, 0, _  ' 95% IT    
 49,   116,   0,       14.20,  "s",           100,    0,   0,    0,    0, 0, _
 49,   116,   1,       54.6,   "min",         100,    0,   0,    0,    0, 0, _
 49,   116,   2,       2.18,   "s",             0,    0,   0,    0,    0, 0, _  
-49,   116,   2,       2.18,   "s",             0,    0,   0,    0,  100, 0, _  ' 100% IT -> m 
 49,   117,   0,       43.2,   "min",          99.66, 0,   0,    0,    0, 0, _  
-49,   117,   0,       43.2,   "min",           0.34, 0,   0,    0,    0, 0, _  ' 0.34% beta-minus -> m
 49,   117,   1,       1.937,  "h",            52.9,  0,   0,    0,   47.1, 0, _  ' 47.1% IT
 49,   118,   0,       5.0,    "s",           100,    0,   0,    0,    0, 0, _
 49,   118,   1,       4.45,   "min",         100,    0,   0,    0,    0,   0, _
 49,   118,   2,       8.5,    "s",             1.4,  0,   0,    0,   98.6, 0, _  ' 98.6% IT
 49,   119,   0,       2.4,    "min",           9.66, 0,   0,    0,    0, 0, _  
-49,   119,   0,       2.4,    "min",          90.34, 0,   0,    0,    0, 0, _  ' 90.34% beta -> m 
 49,   119,   1,       18.0,   "min",           94.4, 0,   0,    0,    5.6, 0, _  ' 5.6% IT
 49,   120,   0,       3.08,   "s",             100,  0,   0,    0,    0, 0, _
 49,   120,   1,       46.2,   "s",             100,  0,   0,    0,    0, 0, _  ' ground" state ?
 49,   120,   2,       47.3,   "s",             100,  0,   0,    0,    0, 0, _
 49,   121,   0,       23.1,   "s",              88.67, 0, 0,    0,    0, 0, _  
-49,   121,   0,       23.1,   "s",              11.33, 0, 0,    0,    0, 0, _  ' 11.33% beta -> m 
 49,   121,   1,       3.88,   "min",           98.8,  0,  0,    0,    1.2, 0, _  ' 1.2% IT
 49,   122,   0,       1.5,    "s",             100,   0,  0,    0,    0,  0, _
 49,   122,   1,       10.8,   "s",             100,   0,  0,    0,    0,  0, _
 49,   122,   2,       10.8,   "s",             100,   0,  0,    0,    0,  0, _
 49,   123,   0,       5.98,   "s",               7.62, 0, 0,    0,    0,  0, _  
-49,   123,   0,       5.98,   "s",              92.38, 0, 0,    0,    0,  0, _  ' 92.38% beta -> m 
 49,   123,   1,       47.8,   "s",               0,   0,  0,    0,    0,  0, _  
-49,   123,   1,       47.8,   "s",             100,   0,  0,    0,    0,  0, _  ' 100% beta -> m 
 49,   124,   0,       3.11,   "s",             100,   0,  0,    0,    0,  0, _
 49,   124,   1,       3.7,    "s",             100,   0,  0,    0,    0,  0, _
 49,   125,   0,       2.36,   "s",              16.89, 0, 0,    0,    0,  0, _  
-49,   125,   0,       2.36,   "s",              83.11, 0, 0,    0,    0,  0, _  ' 83.11% beta -> m 
 49,   125,   1,       12.2,   "s",               0,   0,  0,    0,    0,  0, _  
-49,   125,   1,       12.2,   "s",             100,   0,  0,    0,    0,  0, _  ' 100% beta -> m 
 49,   126,   0,       1.53,   "s",             100,   0,  0,    0,    0,  0, _
 49,   126,   1,       1.64,   "s",             100,   0,  0,    0,    0,  0, _
 49,   127,   0,       1.09,   "s",              38.98, 0, 0,    0,    0,  0, _  
-49,   127,   0,       1.09,   "s",              61.02, 0, 0,    0,    0,  0, _  ' 61.02% beta -> m 
 49,   127,   1,       3.67,   "s",              0.69,  0, 0.69, 0,    0, 0,  _  
-49,   127,   1,       3.67,   "s",              99.31, 0, 0,    0,    0, 0,  _  ' 99.31% beta -> m 
 49,   128,   0,       0.84,   "s",             100,   0,  0,    0,    0, 0,  _
 49,   128,   1,       0.01,   "s",               0,   0,  0,    0,  100, 0,  _  ' IT 100%
 49,   128,   2,       0.72,   "s",               0,   0,  0,    0,    0, 0,  _  
-49,   128,   2,       0.72,   "s",             100,   0,  0,    0,    0, 0,  _  ' 100% beta -> m 
 49,   129,   0,       0.61,   "s",              89.35, 0, 0,    0,    0, 0,  _  
-49,   129,   0,       0.61,   "s",              10.65, 0, 0,    0,    0, 0,  _  ' 10.65% beta -> m 
 49,   129,   1,       1.23,   "s",             99.7,   0, 0,    0,    0.3, 0, _  ' <0.3% IT 
 49,   130,   0,       0.29,   "s",             71.06,  0, 0,    0,    0,  0, _ 
-49,   130,   0,       0.29,   "s",             28.94,  0, 0,    0,    0,  0, _ ' 28.94% beta -> m 
 49,   130,   1,       0.54,   "s",             0,      0, 0,   0,     0,  0, _
-49,   130,   1,       0.54,   "s",           100,      0, 0,   0,     0,  0, _ ' 100% beta -> m 
 49,   130,   2,       0.54,   "s",           100,      0, 0,   0,     0,  0, _  
_' 49,   130,   3,       0.54,   "s",          100,     0,  1.65, 0,   0,  0, _
 49,   131,   0,       0.28,   "s",             94.69,  0,  0,  0,     0,  0, _
-49,   131,   0,       0.28,   "s",              5.31,  0,  0,  0,     0,  0, _  ' 5.31% beta -> m 
 49,   131,   1,       0.35,   "s",             98.98,  0,  1,  0,     0.02,  0, _  
-49,   131,   1,       0.35,   "s",              1.0,   0,  1,  0,     0,  0, _  ' 1% beta-n -> m 
 49,   131,   2,       0.32,   "s",             98.98,  0,  0.01, 0,   1,  0, _  ' <1.00% IT
-49,   131,   2,       0.32,   "s",              0.01,  0,  0.01, 0,   0,  0, _  ' 0.01% beta-n -> m 
 49,   132,   0,       0.201,  "s",             100,    0,  0,    0,   0,  0, _
 49,   133,   0,       165,    "ms",            100,    0,  85.00, 0,  0,  0, _
 49,   133,   1,       180,    "ms",              0,    0,  0,     0, 100, 0, _ 
 49,   134,   0,       140,    "ms",            100,    0,  65.00, 4,  0,  0, _  ' 4% beta-2n
 49,   135,   0,        92,    "ms",            100,    0,   0,    0,  0,  0, _
                                                                  _
 50,    99,   0,         5,    "ms",             0,   100,   0,    0,  0,  0, _
 50,   100,   0,         1.1,  "s",              0,   100,  17,    0,  0,  0, _
 50,   101,   0,         3,    "s",              0,    50,   0,    0,  0,  0, _
-50,   101,   0,         3,    "s",              0,    50,   0,    0,  0,  0, _
 50,   102,   0,         4.6,  "s",              0,   100,   0,    0,  0,  0, _
 50,   103,   0,        7,     "s",              0,    50,   0,    0,  0,  0, _
-50,   103,   0,        7,     "s",              0,    50,   0,    0,  0,  0, _
 50,   104,   0,       20.8,   "s",              0,     9.32, 0,   0,  0,  0, _
-50,   104,   0,       20.8,   "s",              0,    90.68, 0,   0,  0,  0, _
 50,   105,   0,       34,     "s",              0,    50,   0,    0,   0, 0, _
-50,   105,   0,       34,     "s",              0,    50,   0,    0,   0, 0, _
 50,   106,   0,      1.917,   "min",            0,     0,   0,    0,   0, 0, _
-50,   106,   0,      1.917,   "min",            0,   100,   0,    0,   0, 0, _
 50,   107,   0,      2.9,     "min",            0,    50,   0,    0,   0, 0, _
-50,   107,   0,      2.9,     "min",            0,    50,   0,    0,   0, 0, _
 50,   108,   0,     10.3,     "min",            0,     0,   0,    0,   0, 0, _
-50,   108,   0,     10.3,     "min",            0,   100,   0,    0,   0, 0, _
 50,   109,   0,     18,       "min",            0,    69.15, 0,   0,   0, 0, _
-50,   109,   0,     18,       "min",            0,    30.85, 0,   0,   0, 0, _
 50,   110,   0,     4.1,      "h",              0,     0,    0,   0,   0, 0, _
-50,   110,   0,     4.1,      "h",              0,   100,    0,   0,   0, 0, _
 50,   111,   0,   35.3,       "min",            0,    99.8,  0,   0,   0, 0, _
-50,   111,   0,   35.3,       "min",            0,     0.2,  0,   0,   0, 0, _
 50,   112,   0,    1,         "stable",         0,     0,    0,   0,   0, 0, _
 50,   113,   0,   115.09,     "d",              0,     0.01, 0,   0,   0, 0, _
-50,   113,   0,   115.09,     "d",              0,    99.99, 0,   0,   0, 0, _
 50,   113,   1,    20.9,      "min",            0,     8.9,  0,   0,  91.1, 0, _
 50,   114,   0,      1,       "stable",         0,     0,    0,   0,   0, 0, _        
 50,   115,   0,       1,      "stable",         0,     0,    0,   0,   0, 0, _
 _'50,   115,   1,       3260,   "ns",           0,     0,    0,   0,  100, 0, _  ' 100% IT
 _'50,   115,   2,       0.159,  "ms",           0,     0,    0,   0,  100, 0, _  ' 100% IT
 50,   116,   0,       1,      "stable",         0,     0,    0,   0,   0,  0, _
 50,   117,   0,       1,      "stable",         0,     0,    0,   0,   0,  0, _
 50,   117,   1,       13.6,   "d",              0,     0,    0,   0,  100, 0, _  ' 100% IT
 50,   118,   0,       1,      "stable",         0,     0,    0,   0,   0,  0, _
 50,   119,   0,       1,      "stable",         0,     0,    0,   0,   0,  0, _
 50,   119,   1,       293,    "d",              0,     0,    0,   0,  100, 0, _  ' 100% IT
 50,   120,   0,       1,      "stable",         0,     0,    0,   0,   0,  0, _
 50,   121,   0,       1.126,  "d",             100,    0,    0,   0,   0,  0, _
 50,   121,   1,       55.001, "y",             22.4,   0,    0,   0,   77.6, 0, _  ' 77.6% IT
 50,   122,   0,       1,      "stable",         0,     0,    0,   0,   0,  0, _
 50,   123,   0,       129.2,  "h",             100,    0,    0,   0,   0,  0, _
 50,   123,   1,       40.06,  "min",           100,    0,    0,   0,   0,  0, _
_' 50,   123,   2,       8000,   "ns",            0,    0,    0,   0,  100, 0, _  ' 100% IT
 50,   124,   0,       1,      "stable",         0,     0,    0,   0,   0,  0, _
_' 50,   124,   1,       45000,  "ns",            0,    0,    0,   0,   0,  0, _  ' 100% IT, PRC 61, 024312 (2000)
 50,   125,   0,       9.64,   "d",             100,    0,    0,   0,   0,  0, _
 50,   125,   1,       9.52,   "min",           100,    0,    0,   0,   0,  0, _
_' 50,   125,   2,       6500,   "ns",            0,    0,    0,   0,  100,  0, _  ' 100% IT, PRC 61, 024312 (2000)
 50,   126,   0,       2.30E+5, "y",              0,    0,    0,   0,   0,   0, _
-50,   126,   0,       2.30E+5, "y",             33.07,  0,   0,   0,   0,   0, _   
-50,   126,   0,       2.30E+5, "y",             66.93,  0,   0,   0,   0,   0, _   ' 66.93% breta -> n
 50,   127,   0,       2.10,   "h",             100,     0,   0,   0,   0,   0, _
 50,   127,   1,       4.13,   "min",           100,     0,   0,   0,   0,   0, _
_' 50,   127,   2,       4500,   "ns",            0,     0,   0,   0,  100,  0, _  ' 100% IT, PRC 61, 024312 (2000)
 50,   128,   0,       59.07,  "min",           100,     0,   0,   0,   0,   0, _
 50,   128,   1,       6.5,    "s",             0,       0,   0,   0,  100,  0, _  ' 100% IT
 50,   129,   0,       2.23,   "min",           100,     0,   0,   0,   0,   0, _
 50,   129,   1,       7.2,    "min",            69,     0,   0,   0,   0,  0, _  ' <2.0E-3 IT
-50,   129,   1,       7.2,    "min",            31,     0,   0,   0,   0,  0, _  ' <2.0E-3 IT
_' 50,   129,   2,       3700,   "ns",            0,     0,   0,   0, 100,  0, _  ' 100% IT, PRC 61, 024312 (2000)
 50,   130,   0,       3.73,   "min",             0,     0,   0,   0,   0,  0, _
-50,   130,   0,       3.73,   "min",           100,     0,   0,   0,   0,  0, _
 50,   130,   1,       1.7,    "min",            84,     0,   0,   0,   0,  0, _
-50,   130,   1,       1.7,    "min",            16,     0,   0,   0,   0,  0, _
 50,   131,   0,       56.0,   "s",             100,     0,   0,   0,   0,  0, _
 50,   131,   1,       58.4,   "s",             100,     0,   0,   0,   0,  0, _
 50,   132,   0,       39.7,   "s",             100,     0,   0,   0,   0,  0, _
_' 50,   132,   1,       2030,   "ns",            0,     0,   0,   0,  100,  0, _  ' 100% IT
 50,   133,   0,       1.45,   "s",             100,     0,   0,   0,   0,   0, _
 50,   134,   0,       1.050,  "s",             100,     0,  17.00, 0,  0,  0, _
 50,   135,   0,       530,    "ms",             89.5,   0,  10.5,  0,  0,  0, _
-50,   135,   0,       530,    "ms",             10.5,   0,  10.5,  0,  0,  0, _
 50,   136,   0,       0.25,   "s",             100,     0,  30.00, 0,  0,  0, _
 50,   137,   0,       190,    "ms",            100,     0,  58.00, 0,  0,  0, _
                                                                    _
 51,   106,   0,       0.6,    "s",             0,   100,   0,   0,   0, 0, _ 
 51,   107,   0,       4.5,    "s",             0,   100,   0,   0,   0, 0, _
 51,   108,   0,       7.4,    "s",             0,   100,   0,   0,   0, 0, _
 51,   109,   0,      16.67,   "s",             0,   100,   0,   0,   0, 0, _
 51,   110,   0,      23,      "s",             0,   100,   0,   0,   0, 0, _
 51,   111,   0,       1.25,   "min",           0,   100,   0,   0,   0, 0, _
 51,   112,   0,      51.4,    "s",             0,   100,   0,   0,   0, 0, _
 51,   113,   0,       6.67,   "min",           0,    80.2, 0,   0,   0, 0, _
-51,   113,   0,       6.67,   "min",           0,    19.8, 0,   0,   0, 0, _
 51,   114,   0,       3.49,   "min",           0,   100,   0,   0,   0, 0, _
 51,   115,   0,      32.1,    "min",           0,   100,   0,   0,   0, 0, _
 51,   116,   0,      15.8,    "min",           0,   100,   0,   0,   0, 0, _
 51,   116,   1,    1.005,     "h",             0,   100,   0,   0,   0, 0, _
 51,   117,   0,     2.8,      "h",             0,   100,   0,   0,   0, 0, _
 51,   118,   0,     3.6,      "min",           0,   100,   0,   0,   0, 0, _
 51,   118,   1,       5,      "h",             0,   100,   0,   0,   0, 0, _ 
 51,   119,   0,     1.596,    "d",             0,   100,   0,   0,   0, 0, _
 51,   119,   1,     0.85,     "s",             0,     0,   0,   0,  100, 0, _
 51,   120,   0,     15.9,     "min",           0,   100,   0,   0,   0, 0, _  
 51,   120,   1,     5.76,     "d",             0,   100,   0,   0,   0, 0, _                          
 51,   121,   0,       1,      "stable",        0,     0,   0,   0,   0, 0, _
 51,   122,   0,       2.7,    "d",             97.4,  2.6, 0,   0,   0,  0, _
 51,   122,   1,       4.19,   "min",           0,     0,   0,   0,  100, 0, _  ' 100% IT
 51,   123,   0,       1,      "stable",        0,     0,   0,   0,   0, 0, _
 51,   124,   0,       60.20,  "d",             100,   0,   0,   0,   0, 0, _
 51,   124,   1,       1.55,   "min",           25,    0,   0,   0,   75, 0, _  ' 75% IT
 51,   124,   2,       20.2,   "min",           0,     0,   0,   0,  100, 0, _  ' 100% IT
 51,   125,   0,       2.759,  "y",             77.62, 0,   0,   0,    0, 0, _
-51,   125,   0,       2.759,  "y",             22.38, 0,   0,   0,    0, 0, _
 51,   126,   0,       12.4,   "d",             100,   0,   0,   0,    0, 0, _
 51,   126,   1,       19.1,   "min",           86,    0,   0,   0,   14, 0, _  ' 14% IT
 51,   126,   2,       11,     "s",             0,     0,   0,   0,  100, 0, _  ' 100% IT
 51,   127,   0,       3.85,   "d",             83.52, 0,   0,   0,    0, 0, _
-51,   127,   0,       3.85,   "d",             16.48, 0,   0,   0,    0, 0, _
 51,   128,   0,       9.01,   "h",             100,   0,   0,   0,    0, 0, _
 51,   128,   1,       10.4,   "min",           96.4,  0,   0,   0,    3.6,  0, _  ' 3.6% IT
 51,   129,   0,       4.36,   "h",             83.4,  0,   0,   0,    0,   0, _
 51,   129,   1,       17.7,   "min",           2,     0,   0,   0,   15,   0, _  ' 15% IT
-51,   129,   1,       17.7,   "min",          83,     0,   0,   0,    0,   0, _  
 51,   130,   0,       39.5,   "min",         100,     0,   0,   0,    0,   0, _
 51,   130,   1,       6.3,    "min",         100,     0,   0,   0,    0,   0, _
 51,   131,   0,       23.03,  "min",          91.99,  0,   0,   0,    0,   0, _
-51,   131,   0,       23.03,  "min",           8.01,  0,   0,   0,    0,   0, _
 51,   132,   0,       2.79,   "min",         100,     0,   0,   0,    0,   0, _
 51,   132,   1,       4.1,    "min",         100,     0,   0,   0,    0,   0, _
 51,   133,   0,       2.5,    "min",          82.71,  0,   0,   0,    0,   0, _
-51,   133,   0,       2.5,    "min",          17.29,  0,   0,   0,    0,   0, _
 51,   134,   0,       0.78,   "s",           100,     0,   0,   0,    0,   0, _
 51,   134,   1,       10.07,  "s",            99.95,  0, 0.05,  0,    0,  0, _
-51,   134,   1,       10.07,  "s",             0.05,  0, 0.05,  0,    0,  0, _
 51,   135,   0,       1.74,   "s",           100,     0, 15.7,  0,    0,  0, _
 51,   136,   0,       0.923,  "s",           100,     0, 16.30, 0.28,    0,  0, _ ' 0.28% beta-2n 
 51,   137,   0,       450,    "ms",          100,     0, 49.00, 0,    0,  0, _
 51,   138,   0,       500,    "ms",          100,     0,   0,   0,    0,  0, _
 51,   139,   0,       300,    "ms",          100,     0,   0,   0,    0,  0, _
                                                                     _
 52,   110,   0,        18.6,  "s",             0,   100,   0,    0,   0, 0, _
 52,   111,   0,        19.3,  "s",             0,   100,   0,    0,   0, 0, _
 52,   112,   0,         2,    "min",           0,   100,   0,    0,   0, 0, _
 52,   113,   0,         1.7,  "min",           0,   100,   0,    0,   0, 0, _
 52,   114,   0,        15.2,  "min",           0,   100,   0,    0,   0, 0, _
 52,   115,   0,         5.8,  "min",           0,   100,   0,    0,   0, 0, _
 52,   115,   1,         6.7,  "min",           0,   100,   0,    0,   0, 0, _
 52,   116,   0,         2.49, "h",             0,   100,   0,    0,   0, 0, _
 52,   117,   0,       1.033,  "h",             0,   100,   0,    0,   0, 0, _
 52,   117,   1,      103,     "ms",            0,     0,   0,    0, 100, 0, _
 52,   118,   0,        6,     "d",             0,   100,   0,   0,    0,  0, _
 52,   119,   0,      16.05,   "h",             0,   100,   0,   0,    0,  0, _
 52,   119,   1,       4.7,    "d",             0,   100,   0,   0,    0,  0, _
 52,   120,   0,        1,     "stable",        0,     0,   0,   0,    0,  0, _
 52,   121,   0,       19.16,  "d",             0,   100,   0,   0,    0,  0, _
 52,   121,   1,       154,    "d",             0,    11.3, 0,   0,  88.7, 0, _
 52,   122,   0,       1,      "stable",        0,     0,   0,   0,    0,  0, _
 52,   123,   0,       1,      "stable",        0,     0,   0,   0,    0,  0, _ ' t1/2 = 9.2E16 years
 52,   123,   1,      119.5,   "d",             0,     0,   0,   0,   100, 0, _
 52,   124,   0,       1,      "stable",        0,     0,   0,   0,    0,  0, _                                                  0, _
 52,   125,   0,       1,      "stable",        0,     0,   0,   0,    0,  0, _
 52,   125,   1,       57.4,   "d",             0,     0,   0,   0,   100, 0, _  ' 100% IT
 52,   126,   0,       1,      "stable",        0,     0,   0,   0,    0,  0, _
 52,   127,   0,       9.35,   "h",             100,   0,   0,   0,    0,  0, _
 52,   127,   1,       109,    "d",             2.4,   0,   0,   0,   97.6, 0, _  ' 97.6% IT
 52,   128,   0,       1,      "stable",        0,     0,   0,   0,    0,  0, _
 52,   129,   0,       1.16,   "h",             100,   0,   0,   0,    0,  0, _
 52,   129,   1,       33.6,   "d",             37,    0,   0,   0,   63,  0, _  ' 63% IT
 52,   130,   0,       1,      "stable",        0,     0,   0,   0,    0,  0, _
 52,   131,   0,       25.0,   "min",           100,   0,   0,   0,    0,  0, _
 52,   131,   1,       1.25,   "d",             79,    0,   0,   0,   21,  0, _  ' 21% IT
_' 52,   131,   2,       93,     "ms",           0,    0,   0,   0,   100, 0, _  ' 100% IT 
 52,   132,   0,       3.204,  "d",             100,   0,   0,   0,    0,  0, _
_' 52,   132,   1,       28100,  "ns",            0,   0,   0,   0,    0,  0, _  ' 100% IT
_' 52,   132,   2,       3700,   "ns",            0,   0,   0,   0,    0,  0, _  ' 100% IT
 52,   133,   0,       12.45,  "min",           100,   0,   0,   0,    0,  0, _
 52,   133,   1,       55.4,   "min",           82.5,  0,   0,   0,   17.5,  0, _  ' 17.5% IT
 52,   134,   0,       41.8,   "min",           100,   0,   0,   0,    0,  0, _
 52,   135,   0,       19.0,   "s",             100,   0,   0,   0,    0,  0, _
_' 52,   135,   1,       511,    "ns",            0,   0,   0,   0,   100,  0, _  ' 100% IT
 52,   136,   0,       17.5,   "s",             100,   0,   0,   0,    0,   0, _
 52,   137,   0,       2.49,   "s",              98.51, 0, 1.49, 0,    0,   0, _
-52,   137,   0,       2.49,   "s",               1.49, 0, 1.49, 0,    0,   0, _
 52,   138,   0,       1.4,    "s",             100,   0,  6.3,  0,    0,   0, _
 52,   139,   0,       500,    "ms",            100,   0,   0,   0,    0,   0, _
 52,   140,   0,       300,    "ms",            100,   0,   0,   0,    0,   0, _
 52,   141,   0,       100,    "ms",            100,   0,   0,   0,    0,   0, _
 52,   142,   0,        50,    "ms",            100,   0,   0,   0,    0,   0, _
                                                                  _
 53,   113,   0,       6.6,    "s",             0,  100,   0,    0,   0, 0, _  
 53,   114,   0,       2.1,    "s",             0,  100,   0,    0,   0, 0, _
 53,   114,   1,       6.2,    "s",             0,   91,   0,    0,   9, 0, _
 53,   115,   0,       1.3,    "min",           0,   50,   0,    0,   0, 0, _
-53,   115,   0,       1.3,    "min",           0,   50,   0,    0,   0, 0, _
 53,   116,   0,       2.91,   "s",             0,  100,   0,    0,   0, 0, _
 53,   117,   0,       2.22,   "min",           0,   50,   0,    0,   0, 0, _
-53,   117,   0,       2.22,   "min",           0,   50,   0,    0,   0, 0, _
 53,   118,   0,      13.7,    "min",           0,  100,   0,    0,   0, 0, _ 
 53,   118,   1,       8.5,    "min",           0,  100,   0,    0,   0, 0, _
 53,   119,   0,      19.1,    "min",           0,   99.5, 0,    0,   0, 0, _
-53,   119,   0,      19.1,    "min",           0,    0.95, 0,   0,    0,  0, _
 53,   120,   0,       1.36,   "h",             0,  100,    0,   0,    0,  0, _
 53,   120,   1,      53,      "min",           0,  100,    0,   0,    0,  0, _
 53,   121,   0,       2.12,   "h",              0,  99.71, 0,   0,    0,  0, _
-53,   121,   0,       2.12,   "h",              0,   0.29, 0,   0,    0,  0, _
 53,   122,   0,       3.63,   "min",            0,  100,   0,   0,    0,  0, _                                               0, _
 53,   122,   0,       3.63,   "min",            0,  100,   0,   0,    0,  0, _
 53,   123,   0,      13.223,  "h",              0,  100,   0,   0,    0,  0, _
 53,   124,   0,       4.176,  "d",              0,  100,   0,   0,    0,  0, _
 53,   125,   0,      59.407,  "d",              0,  100,   0,   0,    0,  0, _
 53,   126,   0,      12.98,   "d",            43.70, 56.30, 0,  0,    0,  0, _
 53,   127,   0,       1,      "stable",         0,    0,   0,   0,    0,  0, _
 53,   128,   0,       24.99,  "min",          93.10, 6.90, 0,   0,    0,  0, _
 53,   129,   0,       1.61E+7, "y",            100,   0,   0,   0,    0,  0, _
 53,   130,   0,       12.36,  "h",             100,   0,   0,   0,    0,  0, _
 53,   130,   1,       8.84,   "min",           16,    0,   0,   0,   84,  0, _  ' 84% IT
 53,   131,   0,       8.023,  "d",             98.91, 0,   0,   0,    0,  0, _
-53,   131,   0,       8.023,  "d",              1.09, 0,   0,   0,    0,  0, _
 53,   132,   0,       2.295,  "h",             100,   0,   0,   0,    0,  0, _
 53,   132,   1,       1.383,  "h",             14,    0,   0,   0,   86,  0, _  ' 86% IT
 53,   133,   0,       20.8,   "h",             97.15, 0,   0,   0,    0,  0, _
-53,   133,   0,       20.8,   "h",             2.85,  0,   0,   0,    0,  0, _
 53,   133,   1,       9,      "s",             0,     0,   0,   0,  100,  0, _  ' 100% IT
 53,   134,   0,       52.5,   "min",           100,   0,   0,   0,    0,  0, _
 53,   134,   1,       3.6,    "min",           0,     0,   0,   0,   97.7,   0, _  ' 97.7% IT
-53,   134,   1,       3.6,    "min",           2.3,   0,   0,   0,    0,  0, _   
 53,   135,   0,       6.57,   "h",             83.49, 0,   0,   0,    0,  0, _
-53,   135,   0,       6.57,   "h",             16.51, 0,   0,   0,    0,  0, _
 53,   136,   0,       1.39,   "min",           100,   0,   0,   0,    0,  0, _
 53,   136,   1,       46.9,   "s",             100,   0,   0,   0,    0,  0, _
 53,   137,   0,       24.51,  "s",             100,   0,   6.5, 0,    0,  0, _
 53,   138,   0,       6.46,   "s",             100,   0,   5.3, 0,    0,  0, _
 53,   139,   0,       2.3,    "s",             100,   0,   9.8, 0,    0,  0, _
 53,   140,   0,       0.86,   "s",             100,   0,   9.3, 0,    0,  0, _
 53,   141,   0,       0.43,   "s",             100,   0,  21.0, 0,    0,  0, _
 53,   142,   0,       0.2,    "s",             100,   0,  25.0, 0,    0,  0, _
 53,   143,   0,       100,    "ms",            100,   0,  40.0, 0,    0,  0, _
 53,   144,   0,        50,    "ms",            100,   0,  40.0, 0,    0,  0, _
                                                                  _
 54,   114,   0,        10,    "s",               0, 100,   0,   0,    0,  0, _
 54,   115,   0,        18,    "s",               0, 100,   0.34, 0,   0,  0, _
 54,   116,   0,        59,    "s",               0, 100,   0,   0,    0,  0, _
 54,   117,   0,       1.017,  "min",             0, 100,   0,   0,    0,  0, _
 54,   118,   0,       3.8,    "min",             0, 100,   0,   0,    0,  0, _
 54,   119,   0,       5.8,    "min",             0, 100,   0,   0,    0,  0, _
 54,   120,   0,      40,      "min",             0, 100,   0,   0,    0,  0, _
 54,   121,   0,      40.1,    "min",             0, 100,   0,   0,    0,  0, _
 54,   122,   0,      20.1,    "h",               0, 100,   0,   0,    0,  0, _ 
 54,   123,   0,       2.08,   "h",               0, 100,   0,   0,    0,  0, _
 54,   124,   0,       1,      "stable",          0,   0,   0,   0,    0,  0, _
 54,   125,   0,      16.9,    "h",               0, 100,   0,   0,    0,  0, _
 54,   125,   1,      56,      "s",               0,   0,   0,   0,  100,  0, _
 54,   126,   0,       1,      "stable",          0,   0,   0,   0,    0,  0, _
 54,   127,   0,      36.4,    "d",               0, 100,   0,   0,    0,  0, _
 54,   127,   1,       1.16,   "min",             0,   0,   0,   0,  100,  0, _
 54,   128,   0,       1,      "stable",          0,   0,   0,   0,    0,  0, _
 54,   129,   0,       1,      "stable",          0,   0,   0,   0,    0,  0, _
 54,   129,   1,       8.88,   "d",               0,   0,   0,   0,  100,  0, _  ' 100% IT
 54,   130,   0,       1,      "stable",          0,   0,   0,   0,    0,  0, _
 54,   131,   0,       1,      "stable",          0,   0,   0,   0,    0,  0, _
 54,   131,   1,       11.93,  "d",               0,   0,   0,   0,  100,  0, _  ' 100% IT 
 54,   132,   0,       1,      "stable",          0,   0,   0,   0,    0,  0, _
 54,   132,   1,       8.39,   "ms",              0,   0,   0,   0,  100,  0, _  ' 100% IT
 54,   133,   0,       5.244,  "d",             100,   0,   0,   0,    0,  0, _
 54,   133,   1,       2.188,  "d",               0,   0,   0,   0,  100,  0, _  ' 100% IT
 54,   134,   0,       1,      "stable",          0,   0,   0,   0,    0,  0, _
 54,   134,   1,       290,    "ms",              0,   0,   0,   0,  100,  0, _  ' 100% IT
 54,   135,   0,       9.14,   "h",             100,   0,   0,   0,    0,  0, _
 54,   135,   1,       15.29,  "min",           0.60,  0,   0,   0,   99.4, 0, _  ' >99.4% IT
 54,   136,   0,       1,      "stable",          0,   0,   0,   0,    0,  0, _
 54,   137,   0,       3.818,  "min",           100,   0,   0,   0,    0,  0, _
 54,   138,   0,       14.08,  "min",           100,   0,   0,   0,    0,  0, _
 54,   139,   0,       39.68,  "s",             100,   0,   0,   0,    0,  0, _
 54,   140,   0,       13.60,  "s",             100,   0,   0,   0,    0,  0, _
 54,   141,   0,       1.73,   "s",             100,   0,  0.04, 0,    0,  0, _
 54,   142,   0,       1.220,  "s",             100,   0,  0.36, 0,    0,  0, _
 54,   143,   0,       0.511,  "s",             100,   0,  1.00, 0,    0,  0, _
 54,   144,   0,       0.388,  "s",             100,   0,  3.00, 0,    0,  0, _
 54,   145,   0,       188,    "ms",             97.5, 0,  2.50, 0,    0,  0, _
-54,   145,   0,       188,    "ms",              2.5, 0,  2.50, 0,    0,  0, _
 54,   146,   0,       146,    "ms",            100,   0,  6.90, 0,    0,  0, _
 54,   147,   0,       0.13,   "s",             100,   0,  4.00, 0,    0,  0, _
                                                                  _
 55,   120,   0,       1.02,   "min",             0, 100,     0, 0,    0,  0, _
 55,   120,   1,      57,      "s",               0, 100,     0, 0,    0,  0, _ 
 55,   121,   0,       2.583,  "min",             0, 100,     0, 0,    0,  0, _
 55,   121,   1,       2.033,  "min",             0,  83,     0, 0,   17,  0, _
 55,   122,   0,      21.2,    "s",               0, 100,     0, 0,    0,  0, _
 55,   122,   1,       3.7,    "min",             0, 100,     0, 0,    0,  0, _
 55,   122,   2,     360,      "ms",              0,   0,     0, 0,   50,  0, _
-55,   122,   2,     360,      "ms",              0,   0,     0, 0,   50,  0, _
 55,   123,   0,       5.91,   "min",             0, 100,     0, 0,    0,  0, _
 55,   123,   1,       1.7,    "s",               0,   0,     0, 0,  100,  0, _
 55,   124,   0,      30.9,    "s",               0, 100,     0, 0,    0,  0, _
 55,   124,   1,       6.3,    "s",               0,   0,     0, 0,  100,  0, _   
 55,   125,   0,      46.7,    "min",             0, 100,    0,  0,    0,  0, _
 55,   126,   0,       1.64,   "min",             0, 100,    0,  0,    0,  0, _
 55,   127,   0,       6.25,   "h",               0, 100,    0,  0,    0,  0, _
 55,   128,   0,       3.62,   "min",             0, 100,    0,  0,    0,  0, _
 55,   129,   0,       1.342,  "d",               0, 100,    0,  0,    0,  0, _
 55,   130,   0,      29.21,   "min",           1.6, 98.40,  0,  0,    0,  0, _
 55,   130,   1,       3.46,   "min",           0.16, 0,     0,  0,  99.84, 0, _ 
 55,   131,   0,       9.69,   "d",               0, 100,    0,  0,    0,  0, _
 55,   132,   0,       6.53,   "d",             1.8,  98.2,  0,  0,    0,  0, _
 55,   133,   0,       1,      "stable",          0,   0,    0,  0,    0,  0, _
 55,   134,   0,       2.065,  "y",             100,   0,    0,  0,    0,  0, _
 55,   134,   1,       2.908,  "h",               0,   0,    0,  0,  100,  0, _  ' 100% IT
 55,   135,   0,       2.3E+6, "y",             100,   0,    0,  0,    0,  0, _
 55,   135,   1,       53,     "min",             0,   0,    0,  0,  100,  0, _  ' 100% IT
 55,   136,   0,       13.03,  "d",             100,   0,    0,  0,    0,  0, _
 55,   136,   1,       19,     "s",              50,   0,    0,  0,   50,  0, _
 55,   137,   0,       30.041, "y",               5.6, 0,    0,  0,    0,  0, _
-55,   137,   0,       30.041, "y",              94.4, 0,    0,  0,    0,  0, _
 55,   138,   0,       33.41,  "min",           100,   0,    0,  0,    0,  0, _
 55,   138,   1,       2.91,   "min",            19,   0,    0,  0,   81,  0, _  ' 81% IT
 55,   139,   0,       9.27,   "min",           100,   0,    0,  0,    0,  0, _
 55,   140,   0,       1.062,  "min",           100,   0,    0,  0,    0,  0, _
 55,   141,   0,       24.84,  "s",             100,   0,    0,  0,    0,  0, _
 55,   142,   0,       1.684,  "s",             100,   0,    0,  0,    0,  0, _
 55,   143,   0,       1.791,  "s",             100,   0,  1.64, 0,    0,  0, _
 55,   144,   0,       0.994,  "s",             100,   0,  3.20, 0,    0,  0, _
 55,   144,   1,       1,      "s",              50,   0,    0,  0,   50,  0, _
 55,   145,   0,       0.594,  "s",             100,   0, 14.30, 0,    0,  0, _
 55,   146,   0,       0.323,  "s",             100,   0, 14.20, 0,    0,  0, _
 55,   147,   0,       0.225,  "s",             100,   0, 28.50, 0,    0,  0, _
 55,   148,   0,       146,    "ms",            100,   0, 25.10, 0,    0,  0, _
 55,   149,   0,       150,    "ms",            100,   0,    0,  0,    0,  0, _
 55,   150,   0,       100,    "ms",            100,   0,    0,  0,    0,  0, _
 55,   151,   0,        60,    "ms",            100,   0,    0,  0,    0,  0, _
                                                                  _
 56,   122,   0,      1.59,    "min",            0,  100,    0,  0,    0,  0, _
 56,   123,   0,      2.7,     "min",            0,   50,    0,  0,    0,  0, _
-56,   123,   0,      2.7,     "min",            0,   50,    0,  0,    0,  0, _
 56,   124,   0,     11,       "min",            0,  100,    0,  0,    0,  0, _
 56,   125,   0,      3.5,     "min",            0,  100,    0,  0,    0,  0, _
 56,   126,   0,      1.667,   "h",              0,  100,    0,  0,    0, 0, _
 56,   127,   0,     12.7,     "min",            0,  100,    0,  0,    0, 0, _
 56,   127,   1,      1.9,     "s",              0,    0,    0,  0,  100, 0, _
 56,   128,   0,      2.43,    "d",              0,  100,    0,  0,    0, 0, _
 56,   129,   0,      2.38,    "h",              0,  100,    0,  0,    0, 0, _
 56,   129,   1,      2.14,    "h",              0,  100,    0,  0,    0, 0, _
 56,   130,   0,       1,      "stable",         0,    0,    0,  0,    0, 0, _
 56,   130,   1,      9.54,    "ms",             0,    0,    0,  0,  100, 0, _
 56,   131,   0,     11.55,    "d",              0,  100,    0,  0,    0, 0, _
 56,   131,   1,     14.6,     "min",            0,    0,    0,  0,  100, 0, _
 56,   132,   0,       1,      "stable",         0,    0,    0,  0,    0, 0, _
 56,   133,   0,     10.54,    "y",              0,  100,    0,  0,    0, 0, _
 56,   133,   1,      1.592,   "d",              0,    0.01, 0,  0,   99.99, 0, _
 56,   134,   0,       1,      "stable",         0,    0,    0,  0,    0, 0, _
 56,   135,   0,       1,      "stable",         0,    0,    0,  0,    0, 0, _
 56,   135,   1,       1.196,  "d",              0,    0,    0,  0,  100, 0, _  ' 100% IT
 56,   136,   0,       1,      "stable",         0,    0,    0,  0,    0, 0, _
 56,   136,   1,       0.308,  "s",              0,    0,    0,  0,  100, 0, _  ' 100% IT
 56,   137,   0,       1,      "stable",         0,    0,    0,  0,    0, 0, _
 56,   137,   1,       2.552,  "min",            0,    0,    0,  0,  100, 0, _  ' 100% IT
 56,   138,   0,       1,      "stable",         0,    0,    0,  0,    0, 0, _
 56,   139,   0,       1.384,  "h",             100,   0,    0,  0,    0, 0, _
 56,   140,   0,       12.765, "d",             100,   0,    0,  0,    0, 0, _
 56,   141,   0,       18.27,  "min",           100,   0,    0,  0,    0, 0, _
 56,   142,   0,       10.6,   "min",           100,   0,    0,  0,    0, 0, _
 56,   143,   0,       14.5,   "s",             100,   0,    0,  0,    0, 0, _
 56,   144,   0,       11.5,   "s",             100,   0,    0,  0,    0, 0, _
 56,   145,   0,       4.31,   "s",             100,   0,    0,  0,    0, 0, _
 56,   146,   0,       2.22,   "s",             100,   0,    0,  0,    0, 0, _
 56,   147,   0,       0.893,  "s",             100,   0,  0.02, 0,    0, 0, _
 56,   148,   0,       0.612,  "s",             100,   0,  0.40, 0,    0, 0, _
 56,   149,   0,       0.344,  "s",             100,   0,  0.43, 0,    0, 0, _
 56,   150,   0,       0.3,    "s",             100,   0,    0,  0,    0, 0, _
 56,   151,   0,       200,    "ms",            100,   0,    0,  0,    0, 0, _
 56,   152,   0,       0.1,    "s",             100,   0,    0,  0,    0, 0, _
 56,   153,   0,       0.08,   "s",             100,   0,    0,  0,    0, 0, _
                                                                _
 57,   125,   0,       1.08,   "min",            0,  100,    0,   0,   0, 0, _
 57,   125,   1,     390,      "ms",             0,    0,    0,   0, 100, 0, _
 57,   126,   0,      54,      "s",              0,  100,    0,   0,   0, 0, _
 57,   126,   1,      20,      "s",              0,  100,    0,   0,   0, 0, _
 57,   127,   0,       5.1,    "min",            0,    0,    0,   0,   0, 0, _
-57,   127,   0,       5.1,    "min",            0,  100,    0,   0,   0, 0, _
 57,   127,   1,       3.7,    "min",            0,  100,    0,   0,   0, 0, _
 57,   128,   0,       5.18,   "min",            0,  100,    0,   0,   0, 0, _
 57,   128,   1,       1.4,    "min",            0,  100,    0,   0,   0, 0, _
 57,   129,   0,      11.6,    "min",            0,   92.61, 0,   0,   0, 0, _
-57,   129,   0,      11.6,    "min",            0,    7.39, 0,   0,   0, 0, _
 57,   129,   1,     560,      "ms",             0,    0,    0,   0, 100, 0, _
 57,   130,   0,       8.7,    "min",            0,  100,    0,   0,   0, 0, _
 57,   131,   0,      59,      "min",            0,  100,    0,   0,   0, 0, _
 57,   132,   0,       4.8,    "h",              0,  100,    0,   0,   0, 0, _ 
 57,   132,   1,      24.3,    "min",            0,   24,    0,   0,  76, 0, _
 57,   133,   0,       3.912,  "h",              0,  100,    0,   0,   0, 0, _
 57,   134,   0,       6.45,   "min",            0,  100,    0,   0,   0, 0, _
 57,   135,   0,      19.5,    "h",              0,  100,    0,   0,   0, 0, _
 57,   136,   0,       9.87,   "min",            0,  100,    0,   0,   0, 0, _
 57,   136,   1,       0.114,  "s",              0,    0,    0,   0, 100, 0, _
 57,   137,   0,      60000,   "h",              0,  100,    0,   0,   0, 0, _
 57,   138,   0,      1.02E11, "y",             34.4, 65.6,  0,   0,   0, 0, _                                               0, _
 57,   139,   0,       1,      "stable",         0,    0,    0,   0,   0,  0, _
 57,   140,   0,       1.679,  "d",            100,   0,    0,   0,   0, 0, _
 57,   141,   0,       3.92,   "h",             100,   0,    0,   0,   0, 0, _
 57,   142,   0,       1.518,  "h",             100,   0,    0,   0,   0, 0, _
 57,   143,   0,       14.14,  "min",           100,   0,    0,   0,   0, 0, _
 57,   144,   0,       40.8,   "s",             100,   0,    0,   0,   0, 0, _
 57,   145,   0,       24.8,   "s",             100,   0,    0,   0,   0, 0, _
 57,   146,   0,       6.27,   "s",             100,   0,    0,   0,   0, 0, _
 57,   146,   1,       10,     "s",             100,   0,    0,   0,   0, 0, _
 57,   147,   0,       4.015,  "s",             100,   0,    0,   0,   0, 0, _
 57,   148,   0,       1.26,   "s",             100,   0,    0,   0,   0, 0, _
 57,   149,   0,       1.05,   "s",             100,   0,   1.4,  0,   0, 0, _
 57,   150,   0,       0.51,   "s",             100,   0,   2.7,  0,   0, 0, _
 57,   151,   0,       300,    "ns",            100,   0,    0,   0,   0, 0, _
 57,   152,   0,       280,    "ms",            100,   0,   6.04, 0,   0, 0, _
 57,   153,   0,       150,    "ms",            100,   0,    0,   0,   0, 0, _
 57,   154,   0,       0.1,    "s",             100,   0,    0,   0,   0, 0, _
 57,   155,   0,       0.06,   "s",             100,   0,    0,   0,   0, 0, _
                                                                  _
 58,   130,   0,      22.9,    "min",            0,   100,   0,   0,   0, 0, _
 58,   131,   0,      10.2,    "min",            0,   100,   0,   0,   0, 0, _
 58,   131,   1,       5,      "min",            0,   100,   0,   0,   0, 0, _
 58,   132,   0,       3.51,   "h",              0,   100,   0,   0,   0, 0, _
 58,   132,   1,       9.4,    "ms",             0,     0,   0,   0, 100, 0, _
 58,   133,   0,       1.617,  "h",              0,   100,   0,   0,   0, 0, _
 58,   133,   1,       4.9,    "h",              0,   100,   0,   0,   0, 0, _
 58,   134,   0,       3.16,   "d",              0,   100,   0,   0,   0, 0, _ 
 58,   135,   0,      17.7,    "h",              0,   100,   0,   0,   0, 0, _
 58,   135,   1,      20,      "s",              0,     0,   0,   0, 100, 0, _
 58,   136,   0,       1,      "stable",         0,     0,   0,   0,   0, 0, _
 58,   137,   0,       9,      "h",              0,   100,   0,   0,   0, 0, _
 59,   137,   1,       1.433,  "d",              0,     0.78, 0,  0,  99.22, 0, _
 58,   138,   0,       1,      "stable",         0,     0,   0,   0,   0, 0, _
 58,   138,   1,       8.65,   "ms",             0,     0,   0,   0, 100, 0, _ 
 58,   139,   0,     137.641,  "d",              0,   100,   0,   0,   0, 0, _
 58,   139,   1,      56.1,    "s",              0,     0,   0,   0, 100, 0, _
 58,   140,   0,       1,      "stable",         0,     0,   0,   0,   0, 0, _
 58,   141,   0,       32.50,  "d",             100,    0,   0,   0,   0, 0, _
 58,   142,   0,       1,      "stable",         0,     0,   0,   0,   0, 0, _
 58,   143,   0,       1.377,  "d",             100,    0,   0,   0,   0, 0, _
 58,   144,   0,       285,    "d",              98.62, 0,   0,   0,   0, 0, _
-58,   144,   0,       285,    "d",               1.38, 0,   0,   0,   0, 0, _
 58,   145,   0,       2.95,   "min",           100,    0,   0,   0,   0, 0, _
 58,   146,   0,       13.52,  "min",           100,    0,   0,   0,   0, 0, _
 58,   147,   0,       57,     "s",             100,    0,   0,   0,   0, 0, _
 58,   148,   0,       56,     "s",             100,    0,   0,   0,   0, 0, _
 58,   149,   0,       5.3,    "s",             100,    0,   0,   0,   0, 0, _
 58,   150,   0,       4.0,    "s",             100,    0,   0,   0,   0, 0, _
 58,   151,   0,       1.02,   "s",             100,    0,   0,   0,   0, 0, _
 58,   152,   0,       1.1,    "s",             100,    0,   0,   0,   0, 0, _
 58,   153,   0,       1.5,    "s",             100,    0,  0.62, 0,   0, 0, _
 58,   154,   0,        2,     "s",             100,    0,  0.64, 0,   0, 0, _
 58,   155,   0,       200,    "ms",            100,    0,   0,   0,   0, 0, _
 58,   156,   0,       0.15,   "s",             100,    0,   0,   0,   0, 0, _
 58,   157,   0,       0.05,   "s",             100,    0,   0,   0,   0, 0, _
                                                                  _
 59,   133,   0,       6.5,    "min",            0,   100,   0,   0,   0, 0, _
 59,   134,   0,      17,      "min",            0,   100,   0,   0,   0, 0, _
 59,   134,   1,      17,      "min",            0,   100,   0,   0,   0, 0, _
 59,   135,   0,      24,      "min",            0,   100,   0,   0,   0, 0, _
 59,   136,   0,      13.1,    "min",            0,   100,   0,   0,   0, 0, _
 59,   137,   0,       1.28,   "h",              0,   100,   0,   0,   0, 0, _
 59,   138,   0,       1.45,   "min",            0,   100,   0,   0,   0, 0, _
 59,   138,   1,       2.12,   "h",              0,   100,   0,   0,   0, 0, _
 59,   139,   0,       4.41,   "h",              0,    99.98, 0,  0,   0, 0, _
-59,   139,   0,       4.41,   "h",              0,     0.02, 0,  0,   0, 0, _
 59,   140,   0,       3.39,   "min",            0,   100,   0,   0,   0, 0, _
 59,   141,   0,       1,      "stable",         0,    0,    0,   0,   0, 0, _
 59,   142,   0,       19.12,  "h",             99.98, 0.02, 0,   0,   0, 0, _
 59,   142,   1,       14.6,   "min",            0,    0,    0,   0,  100, 0, _  ' 100% IT
_' 59,   142,   2,       61,     "ns",           0,    0,    0,   0,  100, 0, _  ' 100% IT
 59,   143,   0,       13.56,  "d",             100,   0,    0,   0,   0, 0, _
 59,   144,   0,       17.28,  "min",           100,   0,    0,   0,   0, 0, _
 59,   144,   1,       6.9,    "min",           0.07,  0,    0,   0,   99.93, 0, _  ' 99.93% IT
 59,   145,   0,       5.984,  "h",             100,   0,    0,   0,   0, 0, _
 59,   146,   0,       24.15,  "min",           100,   0,    0,   0,   0, 0, _
 59,   147,   0,       13.4,   "min",           100,   0,    0,   0,   0, 0, _
 59,   148,   0,       2.29,   "min",           100,   0,    0,   0,   0, 0, _
 59,   148,   1,       2.02,   "min",           100,   0,    0,   0,   0, 0, _
 59,   149,   0,       2.26,   "min",           100,   0,    0,   0,   0, 0, _
 59,   150,   0,       6.1,    "s",             100,   0,    0,   0,   0, 0, _
 59,   151,   0,       18.90,  "s",             100,   0,    0,   0,   0, 0, _
 59,   152,   0,       3.63,   "s",             100,   0,    0,   0,   0, 0, _
 59,   153,   0,       4.28,   "s",             100,   0,    0,   0,   0, 0, _
 59,   154,   0,       2.3,    "s",             100,   0,    0,   0,   0, 0, _
 59,   155,   0,       1,      "s",             100,   0,    0,   0,   0, 0, _
 59,   156,   0,       500,    "ms",            100,   0,   2.72, 0,   0, 0, _
 59,   157,   0,       0.3,    "s",             100,   0,   6.39, 0,   0, 0, _
 59,   158,   0,       0.2,    "s",             100,   0,    0,   0,   0, 0, _
 59,   159,   0,       0.1,    "s",             100,   0,    0,   0,   0, 0, _
                                                                  _
 60,   131,   0,      33,      "s",              0,  100,    0,   0,   0, 0, _
 60,   132,   0,       1.467,  "min",            0,  100,    0,   0,   0, 0, _ 
 60,   133,   0,       1.167,  "min",            0,  100,    0,   0,   0, 0, _
 60,   133,   1,       1.167,  "min",            0,  100,    0,   0,   0, 0, _
 60,   134,   0,       8.5,    "min",            0,  100,    0,   0,   0, 0, _
 60,   135,   0,      12.5,    "min",            0,  100,    0,   0,   0, 0, _
 60,   135,   1,       5.5,    "min",            0,  99.97,    0,   0, 0.03, 0, _
 60,   136,   0,      50.65,   "min",            0,  100,    0,   0,   0, 0, _
 60,   137,   0,      38.5,    "min",            0,  100,    0,   0,   0, 0, _
 60,   137,   1,       1.6,    "s",              0,    0,    0,   0,  100, 0, _
 60,   138,   0,       5.04,   "h",              0,  100,    0,   0,   0, 0, _
 60,   139,   0,      29.7,    "min",            0,  100,    0,   0,   0, 0, _
 60,   139,   1,       5.5,    "h",              0,   88.2,  0,   0,  11.8, 0, _
 60,   140,   0,       3.37,   "d",              0,  100,    0,   0,   0, 0, _
 60,   141,   0,       2.49,   "h",              0,  100,    0,   0,   0, 0, _
 60,   141,   1,       1.033,  "min",            0,   0.03,  0,   0, 99.97, 0, _
 60,   142,   0,       1,      "stable",         0,    0,    0,   0,   0, 0, _
 60,   143,   0,       1,      "stable",         0,    0,    0,   0,   0, 0, _
 60,   144,   0,       1,      "stable",         0,    0,    0,   0,   0, 0, _
 60,   145,   0,       1,      "stable",         0,    0,    0,   0,   0, 0, _
 60,   146,   0,       1,      "stable",         0,    0,    0,   0,   0, 0, _
 60,   147,   0,       10.98,  "d",             100,   0,    0,   0,   0, 0, _
 60,   148,   0,       1,      "stable",         0,    0,    0,   0,   0, 0, _
 60,   149,   0,       1.728,  "h",             100,   0,    0,   0,   0, 0, _
 60,   150,   0,       1,      "stable",         0,    0,    0,   0,   0, 0, _
 60,   151,   0,       12.44,  "min",           100,   0,    0,   0,   0, 0, _
 60,   152,   0,       11.4,   "min",           100,   0,    0,   0,   0, 0, _
 60,   153,   0,       31.6,   "s",             100,   0,    0,   0,   0, 0, _
 60,   154,   0,       25.9,   "s",             100,   0,    0,   0,   0, 0, _
 60,   155,   0,       8.9,    "s",             100,   0,    0,   0,   0, 0, _
 60,   156,   0,       5.49,   "s",             100,   0,    0,   0,   0, 0, _
 60,   157,   0,       2.5,    "s",             100,   0,    0,   0,   0, 0, _
 60,   158,   0,       0.7,    "s",             100,   0,  0.01,  0,   0, 0, _
 60,   159,   0,       0.5,    "s",             100,   0,  0.24,  0,   0, 0, _
 60,   160,   0,       0.3,    "s",             100,   0,  0.95,  0,   0, 0, _
 60,   161,   0,       0.2,    "s",             100,   0,    0,   0,   0, 0, _
                                                                  _
 61,   135,   0,      10.3,    "s",              0,  50.01,  0.02,  0,  0, 0, _
-61,   135,   0,      10.3,    "s",              0,  59.99,  0,     0,  0, 0, _
 61,   135,   1,       2.4,    "s",              0,   100,   0,   0,    0, 0, _
 61,   136,   0,      47,      "s",              0,   100,   0,   0,    0, 0, _
 61,   137,   0,      45,      "s",              0,     0,   0,   0,    0, 0, _ 
-61,   137,   0,      45,      "s",              0,   100,   0,   0,    0, 0, _ 
 61,   137,   1,      20,      "s",              0,   100,   0,   0,   0, 0, _
 61,   138,   0,      10,      "s",              0,   100,   0,   0,   0, 0, _
 61,   138,   1,       3.24,   "min",            0,   100,   0,   0,   0, 0, _
 61,   139,   0,       4.15,   "min",            0,   100,   0,   0,   0, 0, _
 61,   139,   1,     180,      "ms",             0,     0,   0,   0,  100, 0, _
 61,   140,   0,       9.2,    "s",              0,   100,   0,   0,   0, 0, _
 61,   140,   1,       5.95,   "min",            0,   100,   0,   0,   0, 0, _
 61,   141,   0,      20.9,    "min",            0,  99.84,  0,   0,   0, 0, _
-61,   141,   0,      20.9,    "min",            0,   0.16,  0,   0,   0, 0, _
 61,   142,   0,      40.5,    "s",              0,   100,   0,   0,   0, 0, _
 61,   142,   1,       2,      "ms",             0,     0,   0,   0,  100, 0, _
 61,   143,   0,     266,      "d",              0,   100,   0,   0,   0, 0, _ 
 61,   144,   0,     363,      "d",              0,   100,   0,   0,   0, 0, _
 61,   145,   0,      17.7,    "y",              0,   100,   0,   0,   0, 0, _
 61,   146,   0,       5.531,  "y",             34,    66,   0,   0,   0, 0, _
 61,   147,   0,       2.623,  "y",             100,    0,   0,   0,   0, 0, _
 61,   148,   0,       5.368,  "d",             100,    0,   0,   0,   0, 0, _
 61,   148,   1,       41.05,  "d",             95,     0,   0,   0,   5, 0, _  ' 4.2% IT
 61,   149,   0,        2.212, "d",             100,    0,   0,   0,   0, 0, _
 61,   150,   0,       2.68,   "h",             100,    0,   0,   0,   0, 0, _
 61,   151,   0,       1.183,  "d",             100,    0,   0,   0,   0, 0, _
 61,   152,   0,       4.12,   "min",           100,    0,   0,   0,   0, 0, _
 61,   152,   1,       7.52,   "min",           100,    0,   0,   0,   0, 0, _
 61,   152,   2,       14.4,   "min",           100,    0,   0,   0,   0, 0, _  ' beta- <= 100%
 61,   153,   0,       5.25,   "min",           100,    0,   0,   0,   0, 0, _
 61,   154,   0,       1.73,   "min",           100,    0,   0,   0,   0, 0, _
 61,   154,   1,       2.68,   "min",           100,    0,   0,   0,   0, 0, _
 61,   155,   0,       41.5,   "s",             100,    0,   0,   0,   0, 0, _
 61,   156,   0,       26.70,  "s",             100,    0,   0,   0,   0, 0, _
 61,   157,   0,       10.56,  "s",             100,    0,   0,   0,   0, 0, _
 61,   158,   0,       4.8,    "s",             100,    0,   0,   0,   0, 0, _
 61,   159,   0,       3,      "s",             100,    0,  0.02,  0,  0, 0, _
 61,   160,   0,       2,      "s",             100,    0,  0.27,  0,  0, 0, _
 61,   161,   0,       0.7,    "s",             100,    0,   0,   0,   0, 0, _
 61,   162,   0,       0.5,    "s",             100,    0,   0,   0,   0, 0, _
 61,   163,   0,       0.2,    "s",             100,    0,   0,   0,   0, 0, _
                                                                  _
 62,   140,   0,      14.82,   "min",            0,   100,   0,   0,   0, 0, _
 62,   141,   0,      10.2,    "min",            0,   100,   0,   0,   0, 0, _
 62,   141,   1,      22.6,    "min",            0,   0.31,  0,   0,  99.69, 0, _
 62,   142,   0,       1.208,  "h",              0,   100,   0,   0,   0, 0, _
 62,   143,   0,       8.75,   "min",            0,   100,   0,   0,   0, 0, _ 
 62,   143,   1,       1.1,    "min",            0,   0.24,  0,   0,  99.76, 0, _          
 62,   143,   2,      30,      "ms",             0,     0,   0,   0,   0, 0, _
-62,   143,   2,      30,      "ms",             0,     0,   0,   0, 100, 0, _
 62,   144,   0,       1,      "stable",         0,     0,   0,   0,   0, 0, _
 62,   145,   0,     340,      "d",              0,   100,   0,   0,   0, 0, _ 
 62,   146,   0,       1,      "stable",         0,     0,   0,   0,   0, 0, _ ' t1/2 1.E8 years                   
 62,   147,   0,       1,      "stable",         0,     0,   0,   0,   0, 0, _
 62,   148,   0,       1,      "stable",         0,     0,   0,   0,   0, 0, _
 62,   149,   0,       1,      "stable",         0,     0,   0,   0,   0, 0, _
 62,   150,   0,       1,      "stable",         0,     0,   0,   0,   0, 0, _
 62,   151,   0,       90.002, "y",             100,    0,   0,   0,   0, 0, _
_' 62,   151,   1,       1400,   "ns",            0,    0,   0,   0,  100, 0, _ ' 100% IT
 62,   152,   0,       1,      "stable",         0,     0,   0,   0,   0, 0, _
 62,   153,   0,       1.928,  "d",             100,    0,   0,   0,   0, 0, _
 62,   153,   1,       11,     "ms",             0,     0,   0,   0, 100, 0, _  ' 100% IT
 62,   154,   0,       1,      "stable",         0,     0,   0,   0,   0, 0, _
 62,   155,   0,       22.3,   "min",           100,    0,   0,   0,   0, 0, _
 62,   156,   0,       9.4,    "h",             100,    0,   0,   0,   0, 0, _
 62,   157,   0,       8.03,   "min",           100,    0,   0,   0,   0, 0, _
 62,   158,   0,       5.30,   "min",           100,    0,   0,   0,   0, 0, _
 62,   159,   0,       11.37,  "s",             100,    0,   0,   0,   0, 0, _
 62,   160,   0,       9.6,    "s",             100,    0,   0,   0,   0, 0, _
 62,   161,   0,       4.8,    "s",             100,    0,   0,   0,   0, 0, _
 62,   162,   0,       2.4,    "s",             100,    0,   0,   0,   0, 0, _
 62,   163,   0,       1,      "s",             100,    0,   0,   0,   0, 0, _
 62,   164,   0,       0.5,    "s",             100,    0,   0,   0,   0, 0, _
 62,   165,   0,       0.2,    "s",             100,    0,   0,   0,   0, 0, _
                                                                  _
 63,   144,   0,      10.2,    "s",              0,   100,   0,   0,   0, 0, _ 
 63,   145,   0,       5.93,   "d",              0,   100,   0,   0,   0, 0, _ 
 63,   146,   0,       4.59,   "d",              0,   100,   0,   0,   0, 0, _ 
 63,   147,   0,      24,      "d",              0,   100,   0,   0,   0, 0, _ 
 63,   148,   0,      54.5,    "d",              0,   100,   0,   0,   0, 0, _ 
 63,   149,   0,      93.1,    "d",              0,   100,   0,   0,   0, 0, _ 
 63,   150,   0,      36.359,  "y",              0,   100,   0,   0,   0, 0, _ 
 63,   150,   1,      12.8,    "h",             88,    12,   0,   0,   0, 0, _ 
 63,   151,   0,       1,      "stable",         0,     0,   0,   0,   0, 0, _
_' 63,   151,   1,       0.0589, "ms",           0,     0,   0,   0,   0, 0, _  ' 100% IT 
 63,   152,   0,       13.525, "y",             27.9,  72.1, 0,   0,   0, 0, _
 63,   152,   1,       9.275,  "h",             72,    28,   0,   0,   0, 0, _
 63,   152,   2,       1.6,    "h",              0,     0,   0,   0, 100, 0, _  ' 100% IT
 63,   153,   0,       1,      "stable",         0,     0,   0,   0,   0, 0, _
 63,   154,   0,       8.593,  "y",             99.98, 0.02, 0,   0,   0, 0, _
 63,   154,   1,       46.4,   "min",            0,     0,   0,   0, 100, 0, _  ' 100% IT
 63,   155,   0,       4.753,  "y",             100,    0,   0,   0,   0, 0, _
 63,   156,   0,       15.19,  "d",             100,    0,   0,   0,   0, 0, _
 63,   157,   0,       15.18,  "h",             100,    0,   0,   0,   0, 0, _
 63,   158,   0,       45.9,   "min",           100,    0,   0,   0,   0, 0, _
 63,   159,   0,       18.1,   "min",           100,    0,   0,   0,   0, 0, _
 63,   160,   0,       38,     "s",             100,    0,   0,   0,   0, 0, _
 63,   161,   0,       26,     "s",             100,    0,   0,   0,   0, 0, _
 63,   162,   0,       10.6,   "s",             100,    0,   0,   0,   0, 0, _
 63,   163,   0,       6,      "s",             100,    0,   0,   0,   0, 0, _
 63,   164,   0,       2,      "s",             100,    0,   0,   0,   0, 0, _
 63,   165,   0,       1,      "s",             100,    0,   0,   0,   0, 0, _
 63,   166,   0,       0.4,    "s",             100,    0,   0,   0,   0, 0, _
 63,   167,   0,       0.2,    "s",             100,    0,   0,   0,   0, 0, _
                                                                  _
 64,   137,   0,       2.2,    "s",              0,   100,   0,   0,   0, 0, _
 64,   138,   0,       4.7,    "s",              0,   100,   0,   0,   0, 0, _
 64,   139,   0,       5.7,    "s",              0,   100,   0,   0,   0, 0, _
 64,   139,   1,       4.8,    "s",              0,   100,   0,   0,   0, 0, _
 64,   140,   0,      15.8,    "s",              0,   100,   0,   0,   0, 0, _
 64,   141,   0,      14,      "s",              0,   100,   0,   0,   0, 0, _
 64,   141,   1,      24.5,    "s",              0,     0,   0,   0,  11, 0, _
-64,   141,   1,      24.5,    "s",              0,    89,   0,   0,   0, 0, _
 64,   142,   0,       1.17,   "min",            0,   100,   0,   0,   0, 0, _
 64,   143,   0,      39,      "s",              0,   100,   0,   0,   0, 0, _
 64,   143,   1,       1.833,  "min",            0,   100,   0,   0,   0, 0, _
 64,   144,   0,       4.47,   "min",            0,   100,   0,   0,   0, 0, _
 64,   145,   0,      23,      "min",            0,   100,   0,   0,   0, 0, _
 64,   145,   1,       1.417,  "min",            0,     5.7, 0,   0,  94, 0, _
 64,   146,   0,      48.27,   "d",              0,   100,   0,   0,   0, 0, _
 64,   147,   0,       1.586,  "d",              0,   100,   0,   0,   0, 0, _
 64,   148,   0,      74.602,  "y",              0,     0,   0,   0,   0, 100, _ ' alpha decay
 64,   149,   0,       9.28,   "d",              0,   100,   0,   0,   0, 0, _
 64,   150,   0,       1,      "stable",         0,     0,   0,   0,   0, 0, _ ' t1/2 = 1.82E6 years
 64,   151,   0,    124,       "d",              0,   100,   0,   0,   0, 0, _
 64,   152,   0,       1,      "stable",         0,     0,   0,   0,   0, 0, _
 64,   153,   0,    240.4,     "d",              0,   100,   0,   0,   0, 0, _
 64,   154,   0,       1,      "stable",         0,     0,   0,   0,   0, 0, _
 64,   155,   0,       1,      "stable",         0,     0,   0,   0,   0, 0, _
 64,   155,   1,      32,      "ms",             0,     0,   0,   0, 100, 0, _ 
 64,   156,   0,       1,      "stable",         0,     0,   0,   0,   0, 0, _
 64,   157,   0,       1,      "stable",         0,     0,   0,   0,   0, 0, _
_' 64,   157,   1,       0.0185, "ms",           0,     0,   0,   0,  100, 0, _  ' 100% IT
 64,   158,   0,       1,      "stable",         0,     0,   0,   0,   0, 0, _
 64,   159,   0,       18.479, "h",             100,    0,   0,   0,   0, 0, _
 64,   160,   0,       1,      "stable",         0,     0,   0,   0,   0, 0, _
 64,   161,   0,       3.66,   "min",           100,    0,   0,   0,   0, 0, _
 64,   162,   0,       8.4,    "min",           100,    0,   0,   0,   0, 0, _
 64,   163,   0,       1.133,  "min",           100,    0,   0,   0,   0, 0, _
 64,   164,   0,       45,     "s",             100,    0,   0,   0,   0, 0, _
 64,   165,   0,       10.3,   "s",             100,    0,   0,   0,   0, 0, _
 64,   166,   0,       4.8,    "s",             100,    0,   0,   0,   0, 0, _
 64,   167,   0,       3,      "s",             100,    0,   0,   0,   0, 0, _
 64,   168,   0,       0.3,    "s",             100,    0,   0,   0,   0, 0, _
 64,   169,   0,       1,      "s",             100,    0,   0,   0,   0, 0, _
                                                                  _
 65,   147,   0,       1.7,    "h",              0,   100,   0,   0,   0, 0, _
 65,   147,   1,       1.83,   "min",            0,   100,   0,   0,   0, 0, _
 65,   148,   0,       1,      "h",              0,   100,   0,   0,   0, 0, _
 65,   148,   1,       2.2,    "min",            0,   100,   0,   0,   0, 0, _
 65,   149,   0,       4.118,  "h",              0,    83.3, 0,   0,   0, 16.7, _  ' 16.7% alpha
 65,   149,   1,       4.16,   "min",            0,    99.98, 0,   0,   0, 0.02, _ ' 0.02% alpha
 65,   150,   0,       3.48,   "h",              0,    99.95, 0,   0,   0, 0.05, _ ' 0.05% alpha
 65,   150,   1,       5.8,    "min",            0,   100,   0,   0,   0, 0, _ 
 65,   151,   0,      17.609,  "h",              0,   100,   0,   0,   0, 0, _
 65,   151,   1,      25,      "s",              0,    6.20, 0,   0,  93.8, 0, _
 65,   152,   0,      17.5,    "h",              0,   100,   0,   0,   0, 0, _
 65,   152,   1,       4.2,    "min",            0,   21.2,  0,   0,  78.8, 0, _
 65,   153,   0,       2.34,   "d",              0,   100,   0,   0,   0, 0, _
 65,   154,   0,      21.5,    "h",              0.1,  99.9, 0,   0,   0, 0, _
 65,   154,   1,       9.4,    "h",              0.1,  78.12, 0,  0,  21.78, 0, _
 65,   154,   2,      22.7,    "h",              0,    98.2,  0,  0,   0, 0, _
-65,   154,   2,      22.7,    "h",              0,     0,   0,   0,   1.8, 0, _
 65,   155,   0,       5.32,   "d",              0,   100,   0,   0,   0, 0, _
 65,   156,   0,       5.17,   "d",              0,   100,   0,   0,   0, 0, _
 65,   156,   1,       1.017,  "d",              0,     0,   0,   0, 100, 0, _
 65,   156,   2,       5.1,    "h",              0,   0.19,  0,   0,  99.81, 0, _
 65,   157,   0,      99.002,  "y",              0,   100,   0,   0,   0, 0, _
 65,   158,   0,     180,      "y",             16.8,  83.2, 0,   0,   0, 0, _
 65,   158,   1,      10.8,    "s",              0,     0,   0,   0,  100, 0, _
 65,   159,   0,       1,      "stable",         0,     0,   0,   0,   0, 0, _
 65,   160,   0,       72.3,   "d",             100,    0,   0,   0,   0, 0, _
 65,   161,   0,       6.89,   "d",             100,    0,   0,   0,   0, 0, _
 65,   162,   0,       7.60,   "min",           100,    0,   0,   0,   0, 0, _
 65,   163,   0,       19.5,   "min",           100,    0,   0,   0,   0, 0, _
 65,   164,   0,       3.0,    "min",           100,    0,   0,   0,   0, 0, _
 65,   165,   0,       2.11,   "min",           100,    0,   0,   0,   0, 0, _
 65,   166,   0,       25.6,   "s",             100,    0,   0,   0,   0, 0, _
 65,   167,   0,       19,     "s",             100,    0,   0,   0,   0, 0, _
 65,   168,   0,       8.2,    "s",             100,    0,   0,   0,   0, 0, _
 65,   169,   0,       2,      "s",             100,    0,   0,   0,   0, 0, _
 65,   170,   0,       3,      "s",             100,    0,   0,   0,   0, 0, _
 65,   171,   0,       0.5,    "s",             100,    0,   0,   0,   0, 0, _
                                                                  _
 66,   152,   0,       2.38,   "h",              0,    99.9,   0,   0,   0, 0.1, _ ' 0.1% alpha
 66,   153,   0,       6.4,    "h",              0,    99.99,  0,   0,   0, 0.01, _ ' 0.01% alpha
 66,   154,   0,       3.E6,   "y",              0,     0,   0,   0,   0, 100, _ ' 100% alpha
 66,   155,   0,       9.9,    "h",              0,   100,   0,   0,   0, 0, _
 66,   156,   0,       1,      "stable",         0,     0,   0,   0,   0, 0, _
 66,   157,   0,       8.14,   "h",              0,   100,   0,   0,   0, 0, _ 
 66,   157,   1,      22,      "ms",             0,     0,   0,   0, 100, 0, _
 66,   158,   0,       1,      "stable",         0,     0,   0,   0,   0, 0, _
 66,   159,   0,     144.4,    "d",              0,   100,   0,   0,   0, 0, _
 66,   160,   0,       1,      "stable",         0,     0,   0,   0,   0, 0, _
 66,   161,   0,       1,      "stable",         0,     0,   0,   0,   0, 0, _
 66,   162,   0,       1,      "stable",         0,     0,   0,   0,   0, 0, _
 66,   163,   0,       1,      "stable",         0,     0,   0,   0,   0, 0, _
 66,   164,   0,       1,      "stable",         0,     0,   0,   0,   0, 0, _
 66,   165,   0,       2.334,  "h",             100,    0,   0,   0,   0, 0, _
 66,   165,   1,       1.257,  "min",           2.24,   0,   0,   0,  97.76,  0, _  ' 100% IT
 66,   166,   0,       3.401,  "d",             100,    0,   0,   0,   0, 0, _
 66,   167,   0,       6.20,   "min",           100,    0,   0,   0,   0, 0, _
 66,   168,   0,       8.7,    "min",           100,    0,   0,   0,   0, 0, _
 66,   169,   0,       39,     "s",             100,    0,   0,   0,   0, 0, _
 66,   170,   0,       30,     "s",               0,    0,   0,   0,   0, 0, _
-66,   170,   0,       30,     "s",             100,    0,   0,   0,   0, 0, _
 66,   171,   0,       6,      "s",             100,    0,   0,   0,   0, 0, _
 66,   172,   0,       3,      "s",             100,    0,   0,   0,   0, 0, _
 66,   173,   0,       2,      "s",             100,    0,   0,   0,   0, 0, _
                                                                     _
 67,   155,   0,      48,      "min",            0,   100,   0,   0,   0, 0, _
 67,   156,   0,      56,      "min",            0,   100,   0,   0,   0, 0, _
 67,   156,   1,       9.5,    "s",              0,    50,   0,   0,  50, 0, _
 67,   156,   2,       7.8,    "min",            0,    75,   0,   0,  25, 0, _
 67,   157,   0,      12.6,    "min",            0,    50,   0,   0,   0, 0, _
-67,   157,   0,      12.6,    "min",            0,    50,   0,   0,   0, 0, _
 67,   158,   0,      11.3,    "min",            0,   100,   0,   0,   0, 0, _
 67,   159,   0,      33.05,   "min",            0,   100,   0,   0,   0, 0, _
 67,   160,   0,      25.3,    "min",            0,   100,   0,   0,   0, 0, _
 67,   160,   1,       5,      "h",              0,    35,   0,   0,  65, 0, _ 
 67,   160,   2,       2.9,    "s",              0,     0,   0,   0, 100, 0, _
 65,   161,   0,       2.48,   "h",              0,   100,   0,   0,   0, 0, _ 
 65,   161,   1,       6.77,   "s",              0,     0,   0,   0, 100, 0, _
 65,   162,   0,      15,      "min",            0,   100,   0,   0,   0, 0, _
 65,   162,   1,       1.117,  "h",              0,    38,   0,   0,  62, 0, _
 65,   163,   0,    4570.09,   "y",              0,   100,   0,   0,   0, 0, _
 65,   163,   1,       1.1,    "s",              0,     0,   0,   0, 100, 0, _
 65,   164,   0,      28.6,    "min",           51.7, 48.3,  0,   0,   0, 0, _
 65,   164,   1,      37.6,    "min",            0,     0,   0,   0, 100, 0, _                                            0, _
 67,   165,   0,       1,      "stable",         0,     0,   0,   0,   0, 0, _
 67,   166,   0,       1.117,  "d",             100,    0,   0,   0,   0, 0, _
 67,   166,   1,       1.20E3, "y",             100,    0,   0,   0,   0, 0, _
_' 67,   166,   2,       0.185,  "ms",            0,    0,   0,   0,  100, 0, _  ' 100% IT
 67,   167,   0,       3.1,    "h",              88.05, 0,   0,   0,   0, 0, _
-67,   167,   0,       3.1,    "h",              11.95, 0,   0,   0,   0, 0, _
 67,   168,   0,       2.99,   "min",           100,    0,   0,   0,   0, 0, _
 67,   168,   1,       2.2,    "min",           0.5,    0,   0,   0,   99.5, 0, _  ' >=99.5% IT
 67,   169,   0,       4.7,    "min",           100,    0,   0,   0,   0, 0, _
 67,   170,   0,       2.78,   "min",           100,    0,   0,   0,   0, 0, _
 67,   170,   1,       43,     "s",             100,    0,   0,   0,   0, 0, _
 67,   171,   0,       53,     "s",             100,    0,   0,   0,   0, 0, _
 67,   172,   0,       25,     "s",             100,    0,   0,   0,   0, 0, _
 67,   173,   0,       10,     "s",             100,    0,   0,   0,   0, 0, _
 67,   174,   0,       8,      "s",             100,    0,   0,   0,   0, 0, _
 67,   175,   0,       5,      "s",             100,    0,   0,   0,   0, 0, _
                                                                    _
 68,   158,   0,       2.29,   "h",              0,     0,   0,   0,   0, 0, _ 
-68,   158,   0,       2.29,   "h",              0,   100,   0,   0,   0, 0, _ 
 68,   159,   0,      36,      "min",            0,    76.43, 0,  0,   0, 0, _
-68,   159,   0,      36,      "min",            0,    23.57, 0,  0,   0, 0, _
 68,   160,   0,       1.191,  "d",              0,     0,   0,   0,   0, 0, _ 
-68,   160,   0,       1.191,  "d",              0,   100,   0,   0,   0, 0, _ 
 68,   161,   0,       3.21,   "h",              0,    73.40, 0,  0,   0, 0, _                                                                 0, _
-68,   161,   0,       3.21,   "h",              0,    26.60, 0,  0,   0, 0, _
 68,   162,   0,       1,      "stable",         0,     0,   0,   0,   0, 0, _ ' 1.4E14 years
 68,   163,   0,       1.25,   "h",              0,    99.98, 0,  0,   0, 0, _                                                                 0, _
-68,   163,   0,       1.25,   "h",              0,     0.02, 0,  0,   0, 0, _                                                                 0, _
 68,   164,   0,       1,      "stable",         0,     0,   0,   0,   0, 0, _
 68,   165,   0,      10.36,   "h",              0,   100,   0,   0,   0, 0, _
 68,   166,   0,       1,      "stable",         0,     0,   0,   0,   0, 0, _
 68,   167,   0,       1,      "stable",         0,     0,   0,   0,   0, 0, _
 68,   167,   1,       2.27,   "s",              0,     0,   0,   0, 100, 0, _
 68,   168,   0,       1,      "stable",         0,     0,   0,   0,   0, 0, _
 68,   169,   0,       9.4,    "d",             100,    0,   0,   0,   0, 0, _
 68,   170,   0,       1,      "stable",         0,     0,   0,   0,   0, 0, _
 68,   171,   0,       7.516,  "h",             100,    0,   0,   0,   0, 0, _
 68,   172,   0,       2.054,  "d",             100,    0,   0,   0,   0, 0, _
 68,   173,   0,       1.4,    "min",           100,    0,   0,   0,   0, 0, _
 68,   174,   0,       3.2,    "min",           100,    0,   0,   0,   0, 0, _
 68,   175,   0,       1.2,    "min",           100,    0,   0,   0,   0, 0, _
 68,   176,   0,       20,     "s",             100,    0,   0,   0,   0, 0, _
 68,   177,   0,       3,      "s",             100,    0,   0,   0,   0, 0, _
                                                                  _
 69,   160,   0,       9.4,    "min",            0,   100,   0,   0,   0, 0, _
 69,   160,   1,       1.424,  "min",            0,    15,   0,   0,  85, 0, _
 69,   161,   0,      30.2,    "min",            0,   100,   0,   0,   0, 0, _
 69,   161,   1,       5,      "min",            0,    50,   0,   0,  50, 0, _
 69,   162,   0,      21.7,    "min",            0,   100,   0,   0,   0, 0, _
 69,   162,   1,      24.3,    "s",              0,    18,   0,   0,  82, 0, _
 69,   163,   0,       1.81,   "h",              0,   100,   0,   0,   0, 0, _
 69,   164,   0,       2,      "min",            0,   100,   0,   0,   0, 0, _
 69,   164,   1,       5.1,    "min",            0,    20,   0,   0,  80, 0, _
 69,   165,   0,       1.252,  "d",              0,   100,   0,   0,   0, 0, _
 69,   166,   0,       7.7,    "h",              0,   100,   0,   0,   0, 0, _
 69,   166,   1,       0.34,   "s",              0,    0,    0,   0, 100, 0, _
 69,   167,   0,       9.246,  "d",              0,   1.71,  0,   0,   0, 0, _
-69,   167,   0,       9.246,  "d",              0,  98.29,  0,   0,   0, 0, _
 69,   168,   0,      90,      "d",             0.01, 99.99, 0,   0,   0, 0, _
 69,   169,   0,       1,      "stable",         0,    0,    0,   0,   0, 0, _
 69,   170,   0,       128.6,  "d",              99.87, 0.13, 0,  0,   0, 0, _
 69,   171,   0,       1.917,  "y",             100,   0,    0,   0,   0, 0, _
 69,   172,   0,       2.65,   "d",             100,   0,    0,   0,   0, 0, _
 69,   173,   0,       8.24,   "h",             100,   0,    0,   0,   0, 0, _
 69,   174,   0,       5.4,    "min",           100,   0,    0,   0,   0, 0, _
 69,   175,   0,       15.2,   "min",            23,   0,    0,   0,   0, 0, _
-69,   175,   0,       15.2,   "min",            77,   0,    0,   0,   0, 0, _
 69,   176,   0,       1.85,   "min",            50,   0,    0,   0,   0, 0, _
-69,   176,   0,       1.85,   "min",            50,   0,    0,   0,   0, 0, _
 69,   177,   0,       1.5,    "min",           100,   0,    0,   0,   0, 0, _
 69,   178,   0,       30,     "s",             100,   0,    0,   0,   0, 0, _
 69,   179,   0,       20,     "s",             100,   0,    0,   0,   0, 0, _
                                                                  _
 70,   167,   0,       17.5,   "min",            0,  100,    0,   0,   0, 0, _
 70,   168,   0,        1,     "stable",         0,    0,    0,   0,   0, 0, _
 70,   169,   0,       32.018, "d",              0,  100,    0,   0,   0, 0, _
 70,   169,   1,       46,     "s",              0,    0,    0,   0, 100, 0, _
 70,   170,   0,       1,      "stable",         0,    0,    0,   0,   0, 0, _
 70,   171,   0,       1,      "stable",         0,    0,    0,   0,   0, 0, _
 70,   171,   1,       5.25,   "ms",             0,    0,    0,   0, 100, 0, _
 70,   172,   0,       1,      "stable",         0,    0,    0,   0,   0, 0, _
 70,   173,   0,       1,      "stable",         0,    0,    0,   0,   0, 0, _
 70,   174,   0,       1,      "stable",         0,    0,    0,   0,   0, 0, _
_' 70,   174,   1,       0.83,   "ms",           0,    0,    0,   0,  100, 0, _  ' 100% IT
 70,   175,   0,       4.185,  "d",             100,   0,    0,   0,   0, 0, _
 70,   175,   1,       68,     "ms",             0,    0,    0,   0, 100, 0, _  ' 100% IT
 70,   176,   0,       1,      "stable",         0,    0,    0,   0,   0, 0, _
 70,   176,   1,       11.4,   "s",             10,    0,    0,   0,  90, 0, _  ' 100% IT
 70,   177,   0,       1.911,  "h",             100,   0,    0,   0,   0, 0, _
 70,   177,   1,       6.41,   "s",              0,    0,    0,   0, 100, 0, _  ' 100% IT
 70,   178,   0,       1.233,  "h",             100,   0,    0,   0,   0, 0, _
 70,   179,   0,       8.0,    "min",            0,    0,    0,   0,   0, 0, _
-70,   179,   0,       8.0,    "min",           100,   0,    0,   0,   0, 0, _
 70,   180,   0,       2.4,    "min",            0,    0,    0,   0,   0, 0, _
-70,   180,   0,       2.4,    "min",           100,   0,    0,   0,   0, 0, _
 70,   181,   0,       1,      "min",           100,   0,    0,   0,   0, 0, _
                                                                  _
 71,   170,   0,       2.012,  "d",              0,  100,    0,   0,   0, 0, _ 
 71,   170,   1,       0.67,   "s",              0,    0,    0,   0, 100, 0, _
 71,   171,   0,       8.25,   "d",              0,  100,    0,   0,   0, 0, _
 71,   171,   1,       1.3,    "min",            0,    0,    0,   0, 100, 0, _
 71,   172,   0,       6.7,    "d",              0,  100,    0,   0,   0, 0, _
 71,   172,   1,       3.7,    "min",            0,    0,    0,   0, 100, 0, _
 71,   173,   0,       1.336,  "y",              0,  100,    0,   0,   0, 0, _
 71,   174,   0,       3.559,  "y",              0,  100,    0,   0,   0, 0, _
 71,   174,   1,     142,      "d",              0,    0.58, 0,   0, 99.42, 0, _
 71,   175,   0,       1,      "stable",         0,    0,    0,   0,   0, 0, _
 71,   176,   0,       1,      "stable",         0,    0,    0,   0,   0, 0, _ ' t1/2 = 4.E10 years
 71,   176,   1,       3.635,  "h",             100,   0,    0,   0,   0, 0, _
 71,   177,   0,       6.647,  "d",             100,   0,    0,   0,   0, 0, _
 71,   177,   1,       160.3,  "d",               0,   0,    0,   0,  22.6, 0, _  ' 21.4% IT
-71,   177,   1,       160.3,  "d",             77.40, 0,    0,   0,   0, 0, _    ' 77.4% beta -> m
 71,   177,   2,       7,      "min",             0,   0,    0,   0,   0, 0, _
-71,   177,   2,       7,      "min",             0,   0,    0,   0,  50, 0, _    ' 50% IT-m
-71,   177,   2,       7,      "min",            50,   0,    0,   0,   0, 0, _    ' 50% beta -> n 
 71,   178,   0,       28.4,   "min",           100,   0,    0,   0,   0, 0, _
 71,   178,   1,       23.1,   "min",             0,   0,    0,   0,   0, 0, _
-71,   178,   1,       23.1,   "min",           100,   0,    0,   0,   0, 0, _
 71,   179,   0,       4.59,   "h",             100,   0,    0,   0,   0, 0, _
 71,   179,   1,       3.1,    "ms",              0,   0,    0,   0, 100, 0, _
 71,   180,   0,       5.7,    "min",           100,   0,    0,   0,   0, 0, _
 71,   180,   1,       1,      "s",              50,   0,    0,   0,  50, 0, _
 71,   180,   2,       1,      "ms",              0,   0,    0,   0,  50, 0, _ 
-71,   180,   2,       1,      "ms",             50,   0,    0,   0,   0, 0, _ 
 71,   181,   0,       3.5,    "min",           100,   0,    0,   0,   0, 0, _
 71,   182,   0,       2.0,    "min",           100,   0,    0,   0,   0, 0, _
 71,   183,   0,       58,     "s",             100,   0,    0,   0,   0, 0, _
 71,   184,   0,       20,     "s",              50,   0,    0,   0,   0, 0, _
-71,   184,   0,       20,     "s",              50,   0,    0,   0,   0, 0, _
                                                                  _
 72,   164,   0,        1.85,  "min",             0,  100,   0,   0,   0, 0, _
 72,   165,   0,        1.267, "min",             0,  100,   0,   0,   0, 0, _
 72,   166,   0,        6.77,  "min",             0,  100,   0,   0,   0, 0, _  ' Report 20 unclear
 72,   167,   0,        2.05,  "min",             0,   50,   0,   0,   0, 0, _
-72,   167,   0,        2.05,  "min",             0,   50,   0,   0,   0, 0, _
 72,   168,   0,       25.95,  "min",             0,    0,   0,   0,   0, 0, _
-72,   168,   0,       25.95,  "min",             0,  100,   0,   0,   0, 0, _
 72,   169,   0,        3.24,  "min",             0,   96.5, 0,   0,   0, 0, _
-72,   169,   0,        3.24,  "min",             0,    3.5, 0,   0,   0, 0, _
 72,   170,   0,       16.01,  "h",               0,   99.93, 0,  0,   0, 0, _
-72,   170,   0,       16.01,  "h",               0,    0.07, 0,  0,   0, 0, _
 72,   171,   0,       12.1,   "h",               0,  100,   0,   0,   0, 0, _
 72,   171,   1,       29.5,   "s",               0,    0,   0,   0, 100, 0, _
 72,   172,   0,        1.87,  "y",               0,    0,   0,   0,   0, 0, _
-72,   172,   0,        1.87,  "y",               0,  100,   0,   0,   0, 0, _
 72,   173,   0,       23.9,   "h",               0,  100,   0,   0,   0, 0, _
 72,   174,   0,       1,      "stable",         0,    0,    0,   0,   0, 0, _
 72,   175,   0,       70,     "d",              0,   100,   0,   0,   0, 0, _
 72,   176,   0,       1,      "stable",         0,    0,    0,   0,   0, 0, _
 72,   177,   0,       1,      "stable",         0,    0,    0,   0,   0, 0, _
 72,   177,   1,       1.08,   "s",              0,    0,    0,   0, 100, 0, _  ' 100% IT
 72,   177,   2,       51.4,   "min",            0,    0,    0,   0,   0, 0, _  
-72,   177,   2,       51.4,   "min",            0,    0,    0,   0, 100, 0, _  ' 100% IT -> m
 72,   178,   0,       1,      "stable",         0,    0,    0,   0,   0, 0, _
 72,   178,   1,       4.0,    "s",              0,    0,    0,   0, 100, 0, _  ' 100% IT
 72,   178,   2,       31.001, "y",              0,    0,    0,   0,   0, 0, _  
-72,   178,   2,       31.001, "y",              0,    0,    0,   0, 100, 0, _  ' 100% IT -> m 
 72,   179,   0,       1,      "stable",         0,    0,    0,   0,   0, 0, _
 72,   179,   1,       18.67,  "s",              0,    0,    0,   0, 100, 0, _  ' 100% IT  
 72,   179,   2,       25.1,   "d",              0,    0,    0,   0, 100, 0, _  ' 100% IT
 72,   180,   0,       1,      "stable",         0,    0,    0,   0,   0, 0, _
 72,   180,   1,       5.5,    "h",              0,    0,    0,   0,  99.69, 0, _  ' 99.70% IT
-72,   180,   1,       5.5,    "h",             0.31,  0,    0,   0,   0, 0, _  
 72,   181,   0,       42.38,  "d",             100,   0,    0,   0,   0, 0, _
_' 72,   181,   1,       1.5,    "ms",            0,   0,    0,   0, 100, 0, _  ' 100% IT
 72,   182,   0,       9.0E+6, "y",             100,   0,    0,   0,   0, 0, _
 72,   182,   1,       1.025,  "h",              0,    0,    0,   0,  42, 0, _  ' 42% IT 
-72,   182,   1,       1.025,  "h",              0,    0,    0,   0,   0, 0, _  ' 
-72,   182,   1,       1.025,  "h",             58,    0,    0,   0,   0, 0, _  ' 58% beta -> "n"  
 72,   183,   0,       1.067,  "h",             100,   0,    0,   0,   0, 0, _
 72,   184,   0,       4.12,   "h",             100,   0,    0,   0,   0, 0, _
 72,   184,   1,       48,     "s",             100,   0,    0,   0,   0, 0, _
 72,   185,   0,       3.5,    "min",           100,   0,    0,   0,   0, 0, _
 72,   186,   0,       2.6,    "min",           100,   0,    0,   0,   0, 0, _
 72,   187,   0,       30,     "s",             100,   0,    0,   0,   0, 0, _
 72,   188,   0,       20,     "s",             100,   0,    0,   0,   0, 0, _
                                                                  _
 73,   171,   0,       23.3,   "min",             0,  50,    0,   0,   0, 0, _
-73,   171,   0,       23.3,   "min",             0,  50,    0,   0,   0, 0, _
 73,   172,   0,       36.8,   "min",             0, 100,    0,   0,   0, 0, _
 73,   173,   0,        3.14,  "h",               0, 100,    0,   0,   0, 0, _
 73,   174,   0,        1.14,  "h",               0, 100,    0,   0,   0, 0, _
 73,   175,   0,       10.5,   "h",               0, 100,    0,   0,   0, 0, _
 73,   176,   0,        8.09,  "h",               0, 100,    0,   0,   0, 0, _
 73,   176,   1,        1.1,   "ms",              0,   0,    0,   0, 100, 0, _
 73,   176,   2,        0.97,  "ms",              0,   0,    0,   0,   0, 0, _
-73,   176,   2,        0.97,  "ms",              0,   0,    0,   0, 100, 0, _
 73,   177,   0,        2.35,  "d",               0, 100,    0,   0,   0, 0, _
 73,   178,   0,        9.29,  "min",             0, 100,    0,   0,   0, 0, _
 73,   178,   1,        2.36,  "h",               0,   0,    0,   0,   0, 0, _
-73,   178,   1,        2.36,  "h",               0, 100,    0,   0,   0, 0, _
 73,   178,   2,        59,    "ms",              0,   0,    0,   0,   0, 0, _
-73,   178,   2,        59,    "ms",              0,   0,    0,   0, 100, 0, _
 73,   179,   0,       1.61,   "y",               0, 100,    0,   0,   0, 0, _
 73,   179,   1,       9.0,    "ms",              0,   0,    0,   0, 100, 0, _
 73,   179,   2,      54,      "ms",              0,   0,    0,   0,   0, 0, _
-73,   179,   2,      54,      "ms",              0,   0,    0,   0, 100, 0, _
 73,   180,   0,       8.08,   "h",             18.10, 81.90, 0,  0,   0, 0, _
 73,   180,   1,       1,      "stable",        20,    80,    0,  0,   0, 0, _
 73,   181,   0,       1,      "stable",        0,      0,    0,  0,   0, 0, _
 73,   182,   0,       114.7,  "d",             100,    0,    0,  0,   0, 0, _
 73,   182,   1,       283,    "ms",            0,      0,    0,  0,  100, 0, _  ' 100% IT
 73,   182,   2,       15.84,  "min",           0,      0,    0,  0,   0,   0, _  
-73,   182,   2,       15.84,  "min",           0,      0,    0,  0,  100,  0, _  ' 100% IT-m
 73,   183,   0,       5.09,   "d",             96.6,   0,    0,  0,   0,   0, _
-73,   183,   0,       5.09,   "d",             3.4,    0,    0,  0,   0,   0, _
 73,   184,   0,       8.7,    "h",             100,    0,    0,  0,   0,   0, _
 73,   185,   0,       49,     "min",           100,    0,    0,  0,   0,   0, _
 73,   185,   1,       1,      "ms",            0,      0,    0,  0, 100,  0, _  ' branching not known 
 73,   186,   0,       10.5,   "min",           100,    0,    0,  0,   0,  0, _
_' 73,   186,   1,       1.54,   "min",          100,   0,    0,  0,   0,   0, _
 73,   187,   0,       2,      "min",           100,    0,    0,  0,   0,   0, _
 73,   188,   0,       20,     "s",             100,    0,    0,  0,   0,   0, _
 73,   189,   0,       3,      "s",             100,    0,    0,  0,   0,   0, _
 73,   190,   0,       0.3,    "s",             100,    0,    0,  0,   0,   0, _
                                                                  _
 74,   179,   0,      37.05,   "min",            0,   100,    0,  0,   0,  0, _ 
 74,   179,   1,       6.4,    "min",            0,     0.28, 0,  0, 99.72, 0, _
 74,   180,   0,       1,      "stable",         0,     0,    0,  0,   0, 0, _
 74,   180,   1,       5.47,   "ms",             0,     0,    0,  0,  100, 0, _
 74,   181,   0,     120.98,   "d",              0,   100,    0,  0,   0, 0, _
 74,   182,   0,       1,      "stable",         0,     0,    0,  0,   0, 0, _
 74,   183,   0,       1,      "stable",         0,     0,    0,  0,   0, 0, _
 74,   183,   1,       5.25,   "s",              0,     0,    0,  0, 100, 0, _  ' 100% IT
 74,   184,   0,       1,      "stable",         0,     0,    0,  0,   0,    0, _
 74,   185,   0,       75.1,   "d",             100,    0,    0,  0,   0,   0, _
 74,   185,   1,       1.667,  "min",            0,     0,    0,  0,  100,   0, _  ' 100% IT
 74,   186,   0,       1,      "stable",         0,     0,    0,  0,   0,    0, _
 74,   186,   1,       3,      "ms",             0,     0,    0,  0,  100, 0, _
 74,   187,   0,       23.85,  "h",             100,    0,    0,  0,   0,  0, _
 74,   188,   0,       69.78,  "d",             100,    0,    0,  0,   0,  0, _
 74,   189,   0,       10.7,   "min",           100,    0,    0,  0,   0,  0, _
 74,   190,   0,       30.0,   "min",           100,    0,    0,  0,   0,  0, _
 74,   190,   1,       3.1,    "ms",             0,     0,    0,  0,  100, 0, _
 74,   191,   0,       20,     "s",             100,    0,    0,  0,   0,  0, _
 74,   192,   0,       10,     "s",             100,    0,    0,  0,   0,  0, _
                                                                   _ 
 75,   178,   0,       13.2,   "min",            0,   100,    0,  0,   0,  0, _
 75,   179,   0,       19.5,   "min",            0,    76,    0,  0,   0,  0, _ 
 75,   179,   0,       19.5,   "min",            0,    24,    0,  0,   0,  0, _ 
 75,   180,   0,        2.44,  "min",            0,   100,    0,  0,   0,  0, _
 75,   181,   0,       19.9,   "h",              0,   100,    0,  0,   0,  0, _ 
 75,   182,   0,        2.667, "d",              0,   100,    0,  0,   0,  0, _ 
 75,   182,   1,       12.7,   "h",              0,   100,    0,  0,   0,  0, _ 
 75,   183,   0,       70,     "d",              0,   100,    0,  0,   0,  0, _
 75,   183,   1,        1.03,  "ms",             0,     0,    0,  0,  100, 0, _
 75,   184,   0,       37.9,   "d",              0,   100,    0,  0,   0,  0, _
 75,   184,   1,      168,     "d",              0,    25.2,  0,  0,  74.8, 0, _ 
 75,   185,   0,       1,      "stable",        0,      0,    0,  0,   0,  0, _
 75,   186,   0,       3.75,   "d",             93.3,  6.87,  0,  0,   0,  0, _
 75,   186,   1,       1.90E5, "y",             0,      0,    0,  0,  100,  0, _  ' 100% IT
 75,   187,   0,       1,      "stable",        0,      0,    0,  0,   0,   0, _  ' 4.35E+10 years
 75,   188,   0,       16.98,  "h",             100,    0,    0,  0,   0,   0, _
 75,   188,   1,       18.59,  "min",           0,      0,    0,  0,  100,   0, _  ' 100% IT  
 75,   189,   0,       1.012,  "d",             89.72,  0,    0,  0,   0,   0, _
-75,   189,   0,       1.012,  "d",             10.28,  0,    0,  0,   0,   0, _
 75,   190,   0,       3.1,    "min",           100,    0,    0,  0,   0,   0, _
 75,   190,   1,       3.2,    "h",              0,     0,    0,  0,  45.6, 0, _  ' 45.6% IT
-75,   190,   1,       3.2,    "h",             54.4,   0,    0,  0,   0,   0, _  ' 
 75,   191,   0,       9.7,    "min",           100,    0,    0,  0,   0,  0, _
 75,   192,   0,       6.2,    "s",             100,    0,    0,  0,   0,  0, _
 75,   193,   0,       30,     "s",             100,    0,    0,  0,   0,  0, _
 75,   194,   0,        2,     "s",             100,    0,    0,  0,   0,  0, _ 
                                                                     _
 76,   180,   0,       21.5,   "min",             0,  100,    0,  0,   0,  0, _
 76,   181,   0,        1.75,  "h",               0,  100,    0,  0,   0,  0, _
 76,   181,   1,        2.7,   "min",             0,  100,    0,  0,   0,  0, _ 
 76,   182,   0,       22.1,   "h",               0,  100,    0,  0,   0,  0, _
 76,   183,   0,       13,     "h",               0,  100,    0,  0,   0,  0, _
 76,   183,   1,        9.9,   "h",               0,   85,    0,  0,  15,  0, _
 76,   184,   0,        1,     "stable",          0,    0,    0,  0,   0,  0, _
 76,   185,   0,       93.8,   "d",               0,  100,    0,  0,   0,  0, _
 76,   186,   0,        1,     "stable",          0,    0,    0,  0,   0,  0, _
 76,   187,   0,        1,     "stable",          0,    0,    0,  0,   0,  0, _      
 76,   188,   0,        1,     "stable",          0,    0,    0,  0,   0,  0, _
 76,   189,   0,        1,     "stable",          0,    0,    0,  0,   0,  0, _
 76,   189,   1,        5.81,  "h",               0,    0,    0,  0, 100,  0, _
 76,   190,   0,        1,     "stable",          0,    0,    0,  0,   0,  0, _
 76,   190,   1,        9.9,   "min",             0,    0,    0,  0, 100,  0, _
 76,   191,   0,       15.3,   "d",               0,    0,    0,  0,   0,  0, _
-76,   191,   0,       15.3,   "d",             100,    0,    0,  0,   0,  0, _
 76,   191,   1,       13.1,   "h",               0,    0,    0,  0, 100,  0, _
 76,   192,   0,        1,     "stable",          0,    0,    0,  0,   0,  0, _
 76,   192,   1,        5.9,   "s",               0,    0,    0,  0,  87,  0, _
-76,   192,   1,        5.9,   "s",               0,    0,    0,  0,   0,  0, _
-76,   192,   1,        5.9,   "s",              13,    0,    0,  0,   0,  0, _  13% beta -> "n" 
 76,   193,   0,        1.255, "d",              99.65, 0,    0,  0,   0,  0, _
-76,   193,   0,        1.255, "d",               0.35, 0,    0,  0,   0,  0, _
 76,   194,   0,        6,     "y",             100,    0,    0,  0,   0,  0, _
 76,   195,   0,        6.5,   "min",           100,    0,    0,  0,   0,  0, _
 76,   196,   0,       34.9,   "min",           100,    0,    0,  0,   0,  0, _
                                                                     _ 
 77,   182,   0,       15,     "min",             0,  100,    0,  0,   0,  0, _
 77,   183,   0,       58,     "min",             0,   32.98, 0,  0,   0,  0, _   
-77,   183,   0,       58,     "min",             0,   66.97, 0,  0,   0,  0.05, _ ' 0.05% alpha     
 77,   184,   0,        3.09,  "h",               0,  100,    0,  0,   0, 0, _
 77,   185,   0,       14.4,   "h",               0,  100,    0,  0,   0, 0, _
 77,   186,   0,       16.64,  "h",               0,  100,    0,  0,   0, 0, _   
 77,   186,   1,        1.92,  "h",               0,   75,    0,  0,  15, 0, _
 77,   187,   0,       10.5,   "h",               0,  100,    0,  0,   0, 0, _
 77,   187,   1,        0.03,  "s",               0,    0,    0,  0, 100, 0, _
 77,   188,   0,        1.729, "d",               0,  100,    0,  0,   0, 0, _
 77,   188,   1,        4.2,   "ms",              0,    0,    0,  0, 100, 0, _
 77,   189,   0,       13.2,   "d",               0,   92.51, 0,  0,   0, 0, _
-77,   189,   0,       13.2,   "d",               0,    7.49, 0,  0,   0, 0, _
 77,   189,   1,       13,     "ms",              0,    0,    0,  0, 100, 0, _ 
 77,   189,   2,        3.7,   "ms",              0,    0,    0,  0,   0, 0, _
-77,   189,   2,        3.7,   "ms",              0,    0,    0,  0, 100, 0, _
 77,   190,   0,       12,     "d",               0,  100,    0,  0,   0, 0, _
 77,   190,   1,        1.12,  "h",               0,    0,    0,  0, 100, 0, _
 77,   190,   2,        3.087, "h",               0,    0,    0,  0,   8.6, 0, _
-77,   190,   2,        3.087, "h",               0,   91.4,  0,  0,   0, 0, _
 77,   191,   0,        1,     "stable",          0,    0,    0,  0,   0, 0, _
 77,   191,   1,        4.9,   "s",               0,    0,    0,  0, 100, 0, _
 77,   191,   2,        5.5,   "s",               0,    0,    0,  0,   0, 0, _
-77,   191,   2,        5.5,   "s",               0,    0,    0,  0, 100, 0, _
 77,   192,   0,       73.822, "d",              95.2,  4.8,  0,  0,   0, 0, _
 77,   192,   1,        1.44,  "min",             0.02, 0,    0,  0,  99.98, 0, _
 77,   192,   2,      241,     "y",               0,    0,    0,  0, 100, 0, _
 77,   193,   0,        1,     "stable",          0,    0,    0,  0,   0, 0, _ 
 77,   193,   1,       10.54,  "d",               0,    0,    0,  0, 100, 0, _
 77,   194,   0,       19.3,   "h",             100,    0,    0,  0,   0, 0, _
 77,   194,   1,       32,     "ms",              0,    0,    0,  0, 100, 0, _
 77,   194,   2,      171,     "d",             100,    0,    0,  0,   0, 0, _
 77,   195,   0,        2.5,   "h",             100,    0,    0,  0,   0, 0, _
 77,   195,   1,        3.8,   "h",              64.6,  0,    0,  0,   5, 0, _
-77,   195,   1,        3.8,   "h",              30.4,  0,    0,  0,   0, 0, _
 77,   196,   0,       52,     "s",             100,    0,    0,  0,   0, 0, _
 77,   196,   1,        1.4,   "h",              99.7,  0,    0,  0,   0.3, 0, _
 77,   197,   0,        5.8,   "min",           100,    0,    0,  0,   0, 0, _
 77,   197,   1,        8.9,   "min",             0,    0,    0,  0,   0.25, 0, _
-77,   197,   1,        8.9,   "min",            99.75, 0,    0,  0,   0, 0, _
 77,   198,   0,        8,     "s",             100,    0,    0,  0,   0, 0, _
 77,   199,   0,       20,     "s",             100,    0,    0,  0,   0, 0, _
                                                                   _
 78,   185,   0,        1.182, "h",               0,   99.99, 0,  0,   0, 0.01, _
 78,   185,   1,       33,     "min",             0,   98,    0,  0,   2, 0, _
 78,   186,   0,        2.08,  "h",               0,    0,    0,  0,   0, 0, _
-78,   186,   0,        2.08,  "h",               0,  100,    0,  0,   0, 0, _
 78,   187,   0,        2.35,  "h",               0,  100,    0,  0,   0, 0, _
 78,   188,   0,       10.2,   "d",               0,  100,    0,  0,   0, 0, _
 78,   189,   0,       10.87,  "h",               0,  100,    0,  0,   0, 0, _
 78,   190,   0,        1,     "stable",          0,    0,    0,  0,   0, 100, _ t1/2 = 6.5E11 y
 78,   191,   0,        2.802, "d",               0,   98.98, 0,  0,   0, 0, _
-78,   191,   0,        2.802, "d",               0,    1.02, 0,  0,   0, 0, _
 78,   192,   0,        1,     "stable",          0,    0,    0,  0,   0, 0, _
 78,   193,   0,       50.001, "y",               0,  100,    0,  0,   0, 0, _
 78,   193,   1,        4.34,  "d",               0,    0,    0,  0, 100, 0, _ 
 78,   194,   0,        1,     "stable",          0,    0,    0,  0,   0, 0, _
 78,   195,   0,        1,     "stable",          0,    0,    0,  0,   0, 0, _
 78,   195,   1,        4.1,   "d",               0,    0,    0,  0, 100, 0, _
 78,   196,   0,        1,     "stable",          0,    0,    0,  0,   0, 0, _
 78,   197,   0,       19.891, "h",             100,    0,    0,  0,   0, 0, _
 78,   197,   1,        1.588, "h",               0,    0,    0,  0,  96.7, 0, _ 
-78,   197,   1,        1.588, "h",               3.3,  0,    0,  0,   0, 0, _ 
 78,   198,   0,        1,     "stable",          0,    0,    0,  0,   0, 0, _          
 78,   199,   0,        1,     "stable",          0,    0,    0,  0,   0, 0, _          
 78,   199,   1,       13.6,   "s",               0,    0,    0,  0, 100, 0, _
 78,   200,   0,       12.5,   "h",             100,    0,    0,  0,   0, 0, _
 78,   201,   0,        2.5,   "min",           100,    0,    0,  0,   0, 0, _
 78,   202,   0,        1.833, "d",             100,    0,    0,  0,   0, 0, _
                                                                     _
 79,   188,   0,        8.84,  "min",             0,  100,    0,  0,   0, 0, _
 79,   189,   0,       28.7,   "min",             0,  100,    0,  0,   0, 0, _
 79,   189,   1,        4.59,  "min",             0,  100,    0,  0,   0, 0, _
 79,   190,   0,       42.8,   "min",             0,  100,    0,  0,   0, 0, _
 79,   190,   1,      125,     "ms",              0,    0,    0,  0, 100, 0, _  
 79,   191,   0,        3.18,  "h",               0,  100,    0,  0,   0, 0, _
 79,   191,   1,        0.92,  "s",               0,    0,    0,  0, 100, 0, _
 79,   192,   0,        4.94,  "h",               0,  100,    0,  0,   0, 0, _
 79,   192,   1,       29,     "ms",              0,    0,    0,  0, 100, 0, _
 79,   192,   2,      160,     "ms",              0,    0,    0,  0,   0, 0, _
-79,   192,   2,      160,     "ms",              0,    0,    0,  0, 100, 0, _
 79,   193,   0,       17.65,  "h",               0,  100,    0,  0,   0, 0, _
 79,   193,   1,        3.9,   "s",               0,    0.02, 0,  0,  99.97, 0, _
-79,   193,   1,        3.9,   "s",               0,    0.02, 0,  0,   0, 0, _
 79,   194,   0,        1.584, "d",               0,  100,    0,  0,   0, 0, _
 79,   194,   1,        0.6,   "s",               0,    0,    0,  0, 100, 0, _   
 79,   194,   2,        0.42,  "s",               0,    0,    0,  0,   0, 0, _
-79,   194,   2,        0.42,  "s",               0,    0,    0,  0, 100, 0, _
 79,   195,   0,      186.094, "d",               0,  100,    0,  0,   0, 0, _
 79,   195,   1,       30.5,   "s",               0,    0,    0,  0, 100, 0, _
 79,   196,   0,        6.183, "d",               7.2, 92.8,  0,  0,   0, 0, _
 79,   196,   1,        8.1,   "s",               0,    0,    0,  0, 100, 0, _
 79,   196,   2,        9.6,   "h",               0,    0,    0,  0,   0, 0, _
-79,   196,   2,        9.6,   "h",               0,    0,    0,  0, 100, 0, _
 79,   197,   0,        1,     "stable",          0,    0,    0,  0,   0, 0, _
 79,   197,   1,        7.74,  "s",               0,    0,    0,  0, 100, 0, _
 79,   198,   0,        2.694, "d",             100,    0,    0,  0,   0, 0, _
 79,   198,   1,        2.3,   "d",               0,    0,    0,  0, 100, 0, _
 79,   199,   0,        3.139, "d",             100,    0,    0,  0,   0, 0, _
 79,   200,   0,       48.4,   "min",           100,    0,    0,  0,   0, 0, _
 79,   200,   1,       18.7,   "h",              82,    0,    0,  0,  18, 0, _
 79,   201,   0,       26,     "min",           100,    0,    0,  0,   0, 0, _
 79,   202,   0,       28.8,   "s",             100,    0,    0,  0,   0, 0, _
 79,   203,   0,       53,     "s",             100,    0,    0,  0,   0, 0, _
 79,   204,   0,       39.8,   "s",             100,    0,    0,  0,   0, 0, _
 79,   205,   0,       31,     "s",             100,    0,    0,  0,   0, 0, _
                                                    _ 
 80,   190,   0,       10,     "min",             0,  100,    0,  0,   0, 0, _
 80,   191,   0,       49,     "min",             0,  100,    0,  0,   0, 0, _
 80,   191,   1,       50.8,   "min",             0,   56,    0,  0,   0, 0, _
-80,   191,   1,       50.8,   "min",             0,   44,    0,  0,   0, 0, _
 80,   192,   0,        4.85,  "h",               0,  100,    0,  0,   0, 0, _
 80,   193,   0,        3.8,   "h",               0,   96.64, 0,  0,   0, 0, _
-80,   193,   0,        3.8,   "h",               0,    3.36, 0,  0,   0, 0, _
 80,   193,   1,       11.8,   "h",               0,   40.83, 0,  0,   7.20, 0, _
-80,   193,   1,       11.8,   "h",               0,   41.57, 0,  0,   7.20, 0, _
 80,   194,   0,      444.001, "y",               0,  100,    0,  0,   0, 0, _
 80,   195,   0,        9.9,   "h",               0,   97.9,  0,  0,   0, 0, _
-80,   195,   0,        9.9,   "h",               0,    2.1,  0,  0,   0, 0, _
 80,   195,   1,        1.733, "d",               0,   22.9,  0,  0,  54.2, 0, _
-80,   195,   1,        1.733, "d",               0,   22.9,  0,  0,   0, 0, _
 80,   196,   0,        1,     "stable",          0,    0,    0,  0,   0, 0, _
 80,   197,   0,        2.692, "d",               0,  100,    0,  0,   0, 0, _
 80,   197,   1,       23.9,   "h",               0,    0,    0,  0,  91.4, 0, _
-80,   197,   1,       23.9,   "h",               0,    8.6,  0,  0,  91.4, 0, _
 80,   198,   0,        1,     "stable",          0,    0,    0,  0,   0, 0, _
 80,   199,   0,        1,     "stable",          0,    0,    0,  0,   0, 0, _
 80,   199,   1,       42.1,   "min",             0,    0,    0,  0,  100, 0, _
 80,   200,   0,        1,     "stable",          0,    0,    0,  0,   0, 0, _
 80,   201,   0,        1,     "stable",          0,    0,    0,  0,   0, 0, _ 
 80,   202,   0,        1,     "stable",          0,    0,    0,  0,   0, 0, _
 80,   203,   0,       46.603, "d",             100,    0,    0,  0,   0, 0, _
 80,   204,   0,        1,     "stable",          0,    0,    0,  0,   0, 0, _
 80,   205,   0,        5.2,   "min",           100,    0,    0,  0,   0, 0, _
 80,   205,   1,        1.03,  "ms",              0,    0,    0,  0, 100, 0, _
 80,   206,   0,        8.15,  "min",           100,    0,    0,  0,   0, 0, _
 80,   207,   0,        2.9,   "min",            54.2,  0,    0,  0,   0, 0, _
-80,   207,   0,        2.9,   "min",            45.8,  0,    0,  0,   0, 0, _
 80,   209,   0,       37,     "s",             100,    0,    0,  0,   0, 0, _
 80,   210,   0,       10,     "min",           100,    0,    0,  0,   0, 0, _
                                                    _
 81,   193,   0,       21.8,   "min",             0,  100,    0,  0,   0, 0, _
 81,   193,   1,        2.11,  "min",             0,   25,    0,  0,  75, 0, _
 81,   194,   0,       33,     "min",             0,  100,    0,  0,   0, 0, _
 81,   194,   1,       32.8,   "min",             0,  100,    0,  0,   0, 0, _
 81,   195,   0,       1.16,   "h",               0,  100,    0,  0,   0, 0, _
 81,   195,   1,       3.6,    "s",               0,    0,    0,  0, 100, 0, _
 81,   196,   0,       1.84,   "h",               0,  100,    0,  0,   0, 0, _
 81,   196,   1,       1.41,   "h",               0,   95.5,  0,  0,   4.5, 0, _
 81,   197,   0,       2.84,   "h",               0,  100,    0,  0,   0, 0, _
 81,   197,   1,       0.54,   "s",               0,    0,    0,  0, 100, 0, _
 81,   198,   0,       5.3,    "h",               0,  100,    0,  0,   0, 0, _
 81,   198,   1,       1.87,   "h",               0,   54,    0,  0,  46, 0, _
 81,   198,   2,      32,      "ms",              0,    0,    0,  0,   0, 0, _
-81,   198,   2,      32,      "ms",              0,    0,    0,  0, 100, 0, _
 81,   199,   0,       7.42,   "h",               0,  100,    0,  0,   0, 0, _
 81,   199,   1,      28,      "ms",              0,    0,    0,  0, 100, 0, _
 81,   200,   0,       1.087,  "d",               0,  100,    0,  0,   0, 0, _
 81,   200,   1,      34,      "ms",              0,    0,    0,  0, 100, 0, _
 81,   201,   0,       3.041,  "d",               0,  100,    0,  0,   0, 0, _
 81,   201,   1,       2.035,  "ms",              0,    0,    0,  0, 100, 0, _
 81,   202,   0,      12.24,   "d",               0,  100,    0,  0,   0, 0, _
 81,   203,   0,       1,      "stable",          0,    0,    0,  0,   0, 0, _
 81,   204,   0,       3.788,  "y",              97.08, 2.92, 0,  0,   0, 0, _ 
 81,   205,   0,       1,      "stable",          0,    0,    0,  0,   0, 0, _
 81,   206,   0,       4.202,  "min",           100,    0,    0,  0,   0, 0, _
 81,   206,   1,       3.76,   "min",             0,    0,    0,  0, 100, 0, _ 
 81,   207,   0,       4.77,   "min",           100,    0,    0,  0, 100, 0, _
 81,   207,   1,       1.33,   "s",               0,    0,    0,  0, 100, 0, _
 81,   208,   0,       3.053,  "min",           100,    0,    0,  0,   0, 0, _
 81,   209,   0,       2.2,    "min",           100,    0,    0,  0,   0, 0, _ 
 81,   210,   0,       1.3,    "min",           100,    0, 0.01,  0,   0, 0, _
 81,   211,   0,       1,      "min",           100,    0,    0,  0,   0, 0, _
 81,   212,   0,      30,      "s",             100,    0,    0,  0,   0, 0, _
                                                               _
 82,   196,   0,      37,      "min",             0,  100,    0,  0,   0, 0, _
 82,   197,   0,       8,      "min",             0,  100,    0,  0,   0, 0, _
 82,   197,   1,      43,      "min",             0,   40.5,  0,  0,  19, 0, _
-82,   197,   1,      43,      "min",             0,   40.5,  0,  0,   0, 0, _
 82,   198,   0,       2.4,    "h",               0,  100,    0,  0,   0, 0, _
 82,   199,   0,       1.5,    "h",               0,  100,    0,  0,   0, 0, _
 82,   199,   1,      12.2,    "min",             0,    0,    0,  0,  93, 0, _
-82,   199,   1,      12.2,    "min",             0,    7,    0,  0,   0, 0, _
 82,   200,   0,      21.5,    "h",               0,  100,    0,  0,   0, 0, _
 82,   201,   0,       9.4,    "h",               0,  100,    0,  0,   0, 0, _
 82,   201,   1,       1.017,  "min",             0,    0,    0,  0, 100, 0, _
 82,   202,   0,       5.3E4,  "y",               0,  100,    0,  0,   0, 0, _
 82,   202,   1,       3.57,   "h",               0,    9.1,  0,  0,  90.9, 0, _  
 82,   203,   0,       2.162,  "d",               0,  100,    0,  0,   0, 0, _
 82,   203,   1,       6.29,   "s",               0,    0,    0,  0, 100, 0, _
 82,   203,   2,       0.48,   "s",               0,    0,    0,  0,   0, 0, _
-82,   203,   2,       0.48,   "s",               0,    0,    0,  0, 100, 0, _
 82,   204,   0,       1,      "stable",          0,    0,    0,  0,   0, 0, _
 82,   204,   1,       1.125,  "h",               0,    0,    0,  0, 100, 0, _
 82,   205,   0,       1.53E7, "y",               0,  100,    0,  0,   0, 0, _
 82,   205,   1,       5.55,   "ms",              0,    0,    0,  0, 100, 0, _
 82,   206,   0,       1,      "stable",          0,    0,    0,  0,   0, 0, _
 82,   207,   0,       1,      "stable",          0,    0,    0,  0,   0, 0, _
 82,   207,   1,     806,      "ms",              0,    0,    0,  0, 100, 0, _  
 82,   208,   0,       1,      "stable",          0,    0,    0,  0,   0, 0, _
 82,   209,   0,       3.253,  "h",             100,    0,    0,  0,   0, 0, _
 82,   210,   0,      22.16,   "y",             100,    0,    0,  0,   0, 0, _
 82,   211,   0,      36.1,    "min",           100,    0,    0,  0,   0, 0, _
 82,   212,   0,      10.64,   "h",             100,    0,    0,  0,   0, 0, _
 82,   213,   0,      10.2,    "min",           100,    0,    0,  0,   0, 0, _
 82,   214,   0,      26.8,    "min",           100,    0,    0,  0,   0, 0, _
 82,   215,   0,      36,      "s",             100,    0,    0,  0,   0, 0, _
                                                                   _
 83,   198,   0,      10.3,    "min",             0,  100,    0,  0,   0, 0, _
 83,   198,   1,      11.6,    "min",             0,  100,    0,  0,   0, 0, _
 83,   198,   2,       7.7,    "s",               0,    0,    0,  0,   0, 0, _   
-83,   198,   2,       7.7,    "s",               0,    0,    0,  0, 100, 0, _   
 83,   199,   0,      27,      "min",             0,   53.9,  0,  0,   0, 0, _ 
-83,   199,   0,      27,      "min",             0,   46.1,  0,  0,   0, 0, _
 83,   199,   1,      24.7,    "min",             0,   97.99, 0,  0,   2, 0.01, _
 83,   200,   0,      36.4,    "min",             0,  100,    0,  0,   0, 0, _
 83,   200,   1,      31,      "min",             0,   90,    0,  0,  10, 0, _
 83,   200,   2,       0.4,    "s",               0,    0,    0,  0, 100, 0, _
 83,   201,   0,       1.8,    "h",               0,   55.3,  0,  0,   0, 0, _  
-83,   201,   0,       1.8,    "h",               0,   44.7,  0,  0,   0, 0, _
 83,   201,   1,      59.1,    "min",             0,   46.45, 0,  0,   6.8, 0.3, _
-83,   201,   1,      59.1,    "min",             0,   46.45, 0,  0,   0, 0, _
 83,   202,   0,       1.72,   "h",               0,  100,    0,  0,   0, 0, _
 83,   203,   0,      11.76,   "h",               0,   80,    0,  0,   0, 0, _
-83,   203,   0,      11.76,   "h",               0,   20,    0,  0,   0, 0, _
 83,   203,   1,     303,      "ms",              0,    0,    0,  0, 100, 0, _
 83,   204,   0,     11.22,    "h",               0,   91.1,  0,  0,   0, 0, _
-83,   204,   0,     11.22,    "h",               0,    8.9,  0,  0,   0, 0, _
 83,   204,   1,      13,      "ms",              0,    0,    0,  0, 100, 0, _
 83,   204,   2,       1.07,   "ms",              0,    0,    0,  0,   0, 0, _
-83,   204,   2,       1.07,   "ms",              0,    0,    0,  0, 100, 0, _
 83,   206,   0,       6.243,  "d",               0,  100,    0,  0,   0, 0, _
 83,   207,   0,      31.786,  "y",               0,  100,    0,  0,   0, 0, _
 83,   208,   0,     3.68E5,   "y",               0,  100,    0,  0,   0, 0, _
 83,   208,   1,     2.58,     "ms",              0,    0,    0,  0, 100, 0, _
 83,   209,   0,     1.9E19,   "y",               0,    0,    0,  0,   0, 100, _
 83,   210,   0,       5.0012, "d",             100,    0,    0,  0,   0, 0, _
 83,   210,   1,     3.E6,     "y",               0,    0,    0,  0,   0, 100, _
 83,   211,   0,       2.17,   "min",             0.27, 0,    0,  0,   0, 99.73, _
 83,   212,   0,       1.009,  "h",              64.07, 0,    0,  0,   0, 35.93, _  ' 0.01% beta-alpha  (->beta)
 83,   212,   1,      25,      "min",            33.2,  0,    0,  0,   0, 66.8,  _ ' 30% beta-alpha (->beta)
 83,   212,   2,       9,      "min",             0,    0,    0,  0,   0,  0, _
-83,   212,   2,       9,      "min",           100,    0,    0,  0,   0,  0, _
 83,   213,   0,      45.59,   "min",            97.84, 0,    0,  0,   0,  2.16, _
 83,   214,   0,      19.9,    "min",            99.98, 0,    0,  0,   0,  0.02, _
 83,   215,   0,       7.4,    "min",           100,    0,    0,  0,   0,  0, _
 83,   215,   1,      36.9,    "s",              50,    0,    0,  0,  50,  0, _
 83,   216,   0,       2.17,   "min",           100,    0,    0,  0,   0,  0, _    
 83,   217,   0,       1.624,  "min",           100,    0,    0,  0,   0,  0, _
 83,   218,   0,      33,      "s",             100,    0,    0,  0,   0,  0, _
                                                                     _
 84,   200,   0,      11.5,    "min",             0,    0,    0,  0,   0, 11.1, _                                                             
-84,   200,   0,      11.5,    "min",             0,   88.9,  0,  0,   0,  0, _                                                             
 84,   201,   0,      15.3,    "min",             0,    0,    0,  0,   0,  1.6, _
-84,   201,   0,      15.3,    "min",             0,   98.4,  0,  0,   0,  0, _
 84,   201,   1,       8.9,    "min",             0,   41.04, 0,  0,  56.6, 0, _ 
-84,   201,   1,       8.9,    "min",             0,    0,    0,  0,   0,  2.9, _ 
 84,   202,   0,      44.7,    "min",             0,   98.08, 0,  0,   0,  1.92, _  
 84,   203,   0,      36.7,    "min",             0,   99.89, 0,  0,   0,  0.11, _
 84,   203,   1,      45,      "s",               0,    0,    0,  0,  99.96, 0.04, _ 
 84,   204,   0,       3.53,   "h",               0,   49.67, 0,  0,   0,  0.66, _
-84,   204,   0,       3.53,   "h",               0,   49.67, 0,  0,   0,  0, _
 84,   205,   0,       1.66,   "h",               0,   99.90, 0,  0,   0,  0.04, _
 84,   205,   1,      57,      "ms",              0,    0,    0,  0, 100,  0, _  
 84,   206,   0,       8.8,    "d",               0,   94.55, 0,  0,   0,  5.45, _
 84,   207,   0,       5.8,    "h",               0,   99.98, 0,  0,   0,  0.02, _
 84,   207,   1,       2.79,   "s",               0,    0,    0,  0, 100,  0, _
 84,   208,   0,       2.93,   "y",               0,    0,    0,  0,   0, 100, _
 84,   209,   0,     102.002,  "y",               0,    0.26, 0,  0,   0,  99.74, _
 84,   210,   0,     138.388,  "d",               0,    0,    0,  0,   0, 100, _
 84,   211,   0,     516,      "ms",              0,    0,    0,  0,   0, 100, _
 84,   211,   1,      25.2,    "s",               0,    0,    0,  0,   0, 100, _
 84,   212,   0,     2.98E-7,  "s",               0,    0,    0,  0,   0, 100, _
 84,   212,   1,      45.1,    "s",               0,    0,    0,  0,   0, 100, _  
 84,   213,   0,     4.2E-6,   "s",               0,    0,    0,  0,   0, 100, _      
 84,   214,   0,     1.637E-4, "s",               0,    0,    0,  0,   0, 100, _
 84,   215,   0,       1.78,   "s",               0,    0,    0,  0,   0, 100, _
 84,   216,   0,     150,      "ms",              0,    0,    0,  0,   0, 100, _
 84,   217,   0,       1.47,   "s",               5,    0,    0,  0,   0,  95, _
 84,   218,   0,       3.098,  "min",             0.02, 0,    0,  0,   0,  99.98, _
 84,   219,   0,       2,      "min",            50,    0,    0,  0,   0,  50, _
 84,   220,   0,      40,      "s",             100,    0,    0,  0,   0,   0, _
                                                                    _
 85,   202,   0,       3.067,  "min",             0,   82,    0,  0,   0,  18, _
 85,   202,   1,       3.033,  "min",             0,   45.65, 0,  0,  45.65, 0, _ 
-85,   202,   1,       3.033,  "min",             0,    0,    0,  0,   0,   8.7, _ 
 85,   202,   2,     460,      "ms",              0,    0.25, 0,  0,   0,   0, _
-85,   202,   2,     460,      "ms",              0,    0.25, 0,  0,  99.65,   0, _
-85,   202,   2,     460,      "ms",              0,    0.25, 0,  0,   0,   0.1, _
 85,   203,   0,       7.4,    "min",             0,   34.5,  0,  0,   0,  31, _
-85,   203,   0,       7.4,    "min",             0,   34.5,  0,  0,   0,   0, _
 85,   204,   0,       9.2,    "min",             0,   96.2,  0,  0,   0,   3.8, _
 85,   204,   1,     108,      "ms",              0,    0,    0,  0,   0, 100, _
 85,   205,   0,      26.9,    "min",             0,   45,    0,  0,   0,  10, _
-85,   205,   0,      26.9,    "min",             0,   45,    0,  0,   0,   0, _
 85,   206,   0,      30,      "min",             0,   99.11, 0,  0,   0,   0.89, _
 85,   207,   0,       1.8,    "h",               0,   91.4,  0,  0,   0,   8.60, _
 85,   208,   0,       1.63,   "h",               0,   99.45, 0,  0,   0,   0.55, _
 85,   209,   0,       5.41,   "h",               0,   95.9,  0,  0,   0,   4.1, _
 85,   210,   0,       8.1,    "h",               0,   99.83, 0,  0,   0,   0.18, _
 85,   211,   0,       7.214,  "h",               0,   85.2,  0,  0,   0,  41.8, _    
 85,   212,   0,     314,      "ms",              0,    0,    0,  0,   0, 100, _
 85,   212,   1,     119,      "ms",              0,    0,    0,  0,   0, 100, _
 85,   213,   0,     1.25E-7,  "s",               0,    0,    0,  0,   0, 100, _
 85,   214,   0,     5.58E-7,  "s",               0,    0,    0,  0,   0, 100, _ 
 85,   215,   0,       0.1,    "ms",              0,    0,    0,  0,   0, 100, _
 85,   216,   0,       0.3,    "ms",              0,    0,    0,  0,   0, 100, _ 
 85,   217,   0,      32,      "ms",              0.01, 0,    0,  0,   0,  99.99, _
 85,   218,   0,       1.5,    "s",               0.1,  0,    0,  0,   0,  99.9, _
 85,   219,   0,      54,      "s",               3,    0,    0,  0,   0,  97, _
 85,   220,   0,       3.71,   "min",            92,    0,    0,  0,   0,   8, _
 85,   221,   0,       2.3,    "min",           100,    0,    0,  0,   0,   0, _
 85,   222,   0,      54,      "s",             100,    0,    0,  0,   0,   0, _ 
 85,   223,   0,      50,      "s",             100,    0,    0,  0,   0,   0, _
                                                                       _
 86,   204,   0,       1.24,   "min",             0,   13.5,  0,  0,   0,  73, _
-86,   204,   0,       1.24,   "min",             0,   13.5,  0,  0,   0,   0, _
 86,   205,   0,       2.8,    "min",             0,   76.4,  0,  0,   0,  24.6, _
 86,   206,   0,       5.67,   "min",             0,   38,    0,  0,   0,  62, _
 86,   207,   0,       9.25,   "min",             0,   79,    0,  0,   0,  21, _
 86,   208,   0,      24.35,   "min",             0,   38,    0,  0,   0,  62, _
 86,   209,   0,      28.5,    "min",             0,   83,    0,  0,   0,  17, _
 86,   210,   0,       2.4,    "h",               0,    4,    0,  0,   0,  96, _
 86,   211,   0,      14.6,    "h",               0,   72.6,  0,  0,   0,  27.4, _
 86,   212,   0,      24.9,    "min",             0,    0,    0,  0,   0, 100, _ 
 86,   213,   0,      25,      "ms",              0,    0,    0,  0,   0, 100, _
 86,   214,   0,     2.7E-7,   "s",               0,    0,    0,  0,   0, 100, _ 
 86,   215,   0,     3.3E-6,   "s",               0,    0,    0,  0,   0, 100, _ 
 86,   216,   0,     4.5E-5,   "s",               0,    0,    0,  0,   0, 100, _ 
 86,   217,   0,     5.4E-4,   "s",               0,    0,    0,  0,   0, 100, _ 
 86,   218,   0,      35,      "ms",              0,    0,    0,  0,   0, 100, _ 
 86,   219,   0,       3.96,   "s",               0,    0,    0,  0,   0, 100, _ 
 86,   220,   0,      55.8,    "s",               0,    0,    0,  0,   0, 100, _ 
 86,   221,   0,      25,      "min",            79,    0,    0,  0,   0,  21, _ 'sum not 100% in Report 20
 86,   222,   0,       3.824,  "d",               0,    0,    0,  0,   0, 100, _
 86,   223,   0,      24.2,    "min",           100,    0,    0,  0,   0,   0, _
 86,   224,   0,       1.783,  "h",             100,    0,    0,  0,   0,   0, _
 86,   225,   0,       4.66,   "min",           100,    0,    0,  0,   0,   0, _
 86,   226,   0,       7.4,    "min",           100,    0,    0,  0,   0,   0, _
 86,   227,   0,      20.8,    "s",             100,    0,    0,  0,   0,   0, _
 86,   228,   0,       1.083,  "min",           100,    0,    0,  0,   0,   0, _
                                                                     _
 87,   206,   0,      16,      "s",               0,    0,    0,  0,   0,  42, _
-87,   206,   0,      16,      "s",               0,   58,    0,  0,   0,  42, _
 87,   206,   1,      15.9,    "s",               0,   29,    0,  0,  29,   0, _
-87,   206,   1,      15.9,    "s",               0,    0,    0,  0,   0,  42, _
 87,   206,   2,       0.7,    "s",               0,    0,    0,  0,   0,   0, _
-87,   206,   2,       0.7,    "s",               0,    0,    0,  0,  88,   0, _
-87,   206,   2,       0.7,    "s",               0,    0,    0,  0,   0,  12, _
 87,   207,   0,      14.8,    "s",               0,    5,    0,  0,   0,  95, _
 87,   208,   0,      59.1,    "s",               0,   10,    0,  0,   0,  90, _
 87,   209,   0,      50,      "s",               0,   11,    0,  0,   0,  89, _
 87,   210,   0,       3.18,   "min",             0,   40,    0,  0,   0,  60, _
 87,   211,   0,       3.1,    "min",             0,   20,    0,  0,   0,  80, _
 87,   212,   0,      20,      "min",             0,   57,    0,  0,   0,  43, _
 87,   213,   0,      34.6,    "s",               0,    0.55, 0,  0,   0,  99.45, _ 
 87,   214,   0,       5,      "ms",              0,    0,    0,  0,   0, 100, _
 87,   214,   1,       3.35,   "ms",              0,    0,    0,  0,   0, 100, _
 87,   215,   0,       8.6E-8, "s",               0,    0,    0,  0,   0, 100, _
 87,   216,   0,       7.E-7,  "s",               0,    0,    0,  0,   0, 100, _
 87,   217,   0,       2.2E-5, "s",               0,    0,    0,  0,   0, 100, _
 87,   218,   0,       1,      "ms",              0,    0,    0,  0,   0, 100, _
 87,   218,   1,      22,      "ms",              0,    0,    0,  0,   0, 100, _
 87,   219,   0,      20,      "ms",              0,    0,    0,  0,   0, 100, _
 87,   220,   0,      27.4,    "s",               0.35, 0,    0,  0,   0,  99.65, _
 87,   221,   0,       4.9,    "min",             0,    0,    0,  0,   0, 100, _
 87,   222,   0,      14.2,    "min",           100,    0,    0,  0,   0,   0, _
 87,   223,   0,      21.8,    "min",            99.99, 0,    0,  0,   0,   0.01, _
 87,   224,   0,       3.33,   "min",           100,    0,    0,  0,   0,   0, _
 87,   225,   0,       4,      "min",           100,    0,    0,  0,   0,   0, _
 87,   226,   0,      49,      "s",             100,    0,    0,  0,   0,   0, _
 87,   227,   0,       2.47,   "min",           100,    0,    0,  0,   0,   0, _
 87,   228,   0,      38,      "s",             100,    0,    0,  0,   0,   0, _
 87,   229,   0,      50.2,    "s",             100,    0,    0,  0,   0,   0, _
 87,   230,   0,      19.1,    "s",             100,    0,    0,  0,   0,   0, _
 87,   231,   0,      17.6,    "s",             100,    0,    0,  0,   0,   0, _
 87,   232,   0,       5,      "s",             100,    0,    0,  0,   0,   0, _
                                                           _
 88,   208,   0,       1.3,    "s",               0,    5,    0,  0,   0,  95, _
 88,   209,   0,       4.6,    "s",               0,   10,    0,  0,   0,  90, _
 88,   210,   0,       3.7,    "s",               0,    4,    0,  0,   0,  96, _
 88,   211,   0,      13,      "s",               0,    7,    0,  0,   0,  93, _
 88,   212,   0,      13,      "s",               0,   15,    0,  0,   0,  85, _
 88,   213,   0,       2.74,   "min",             0,   20,    0,  0,   0,  80, _
 88,   213,   1,       2.1,    "ms",              0,    0,    0,  0,  99,   1, _
 88,   214,   0,       2.46,   "s",               0,    0,    0,  0,   0,  99.94, _
-88,   214,   0,       2.46,   "s",               0,    0.06, 0,  0,   0,   0, _
 88,   215,   0,       1.59,   "ms",              0,    0,    0,  0,   0, 100, _ 
 88,   216,   0,       1.82E-7, "s",              0,    0,    0,  0,   0, 100, _                                                                                                                                         
 88,   217,   0,       1.6E-6, "s",               0,    0,    0,  0,   0, 100, _ 
 88,   218,   0,       2.65E-5, "s",              0,    0,    0,  0,   0, 100, _ 
 88,   219,   0,      10,      "ms",              0,    0,    0,  0,   0, 100, _ 
 88,   220,   0,      18,      "ms",              0,    0,    0,  0,   0, 100, _ 
 88,   221,   0,      28,      "s",               0,    0,    0,  0,   0, 100, _ 
 88,   222,   0,      38,      "s",               0,    0,    0,  0,   0, 100, _ 
 88,   223,   0,      11.43,   "d",               0,    0,    0,  0,   0, 100, _ 
 88,   224,   0,       3.64,   "d",               0,    0,    0,  0,   0, 100, _ 
 88,   225,   0,      14.8,    "d",             100,    0,    0,  0,   0,   0, _
 88,   226,   0,    1600.001,  "y",               0,    0,    0,  0,   0, 100, _
 88,   227,   0,      42.2,    "min",           100,    0,    0,  0,   0,   0, _
 88,   228,   0,       5.75,   "y",             100,    0,    0,  0,   0,   0, _
 88,   229,   0,       4,      "min",           100,    0,    0,  0,   0,   0, _
 88,   230,   0,       1.55,   "h",             100,    0,    0,  0,   0,   0, _
 88,   231,   0,       1.717,  "min",           100,    0,    0,  0,   0,   0, _
 88,   232,   0,       4.167,  "min",           100,    0,    0,  0,   0,   0, _
 88,   233,   0,      30,      "s",             100,    0,    0,  0,   0,   0, _
 88,   234,   0,      30,      "s",             100,    0,    0,  0,   0,   0



Redim Shared As Integer INlast(90) 

  ' Division between predominantly beta-minus and beta-plus decay.
  ' With this division and the actual nuclear decay properties, only
  ' one passage is necessary to obtain correct cumulative yields.
EndA:
  Data 1,3,5,8,10,12,14,16,19,20,23,24,27,28,31,32,36,38,39,42,45,46,_
  50,52,55,57,59,60,63,67,69,72,74,77,79,82,83,87,89,91,93,95,97,99,_
  103,106,107,110,111,118,121,125,127,130,133,135,138,140,141,143,146,_
  148,151,155,157,161,163,166,169,171,175,176,181,182,185,188,191,194,_
  195,198,203,207,209,211,213,215,217,219,221,223
    
